{$M 64000,0,650000}
PROGRAM CoolerEditor;

{
  (c) 1997 by B.Bockmhl und J.Strter.
  Version: 1.0
}

USES
    Crt, Sprite, mouse, button, spr_xms, pic_os, mpoint, menu;

CONST

     max_menu = 8;
     menubuttons: array[0..max_menu,0..7] of integer = (
                  (0,1,2,3,4,5,6,7),
                  (8,9,10,11,12,13,14,-1),
                  (15,16,17,18,19,20,21,22),
                  (23,24,25,26,27,28,29,-1),
                  (30,31,32,33,34,35,36,37),
                  (38,39,40,41,42,-1,-1,-1),
                  (43,44,45,46,47,48,49,50),
                  (51,52,53,54,55,56,57,58),
                  (59,60,-1,-1,-1,-1,-1,-1));
     toolstart: array[0..2] of byte = (0,15,30);
     toolend: array[0..2] of byte = (14,29,60);
     tool_nothing = 0;
     tool_units = 1;
     tool_buildings = 2;
     tool_tiles = 3;
     tiles_start = 21;
     max_buildings = 120;
     max_units = 150;
     max_buildings_sprites = 14;
     max_sprites = 60;
     max_units_sprites = 14;
     max_tiles_sprites = 30;
     max_tiles = 30;
     Sand = 0;
     Gras = 1;
     Eis = 2;
     Vulkan = 3;
     Dreck =4;
     tiles_files: array[0..4] of string = ('gras.lib','gras.lib','gras.lib','gras.lib','gras.lib');
     ScrollSpeed=2;
     scrl_x = 32;
     scrl_y = 20;
     XMS_ON = true;
     mode_normal = 0;
     mode_target = 1;
     target_nothing = 0;
     target_unit = 1;
     target_building = 2;

type
    units_structure = record
                        x,y: integer;
                        energy: byte;
                        typ: byte;
                        act_dir: byte;
                        act_sprite: byte;
                        target: byte;
                        target_type: byte;
                        friend: boolean;
                        goal: boolean;
    end;

    buildings_structure = record
                       x,y: integer;
                       energy: byte;
                       gfx: byte;
                       friend: boolean;
                       goal: boolean;
    end;

    mission_structure = record
                 playfield: array[0..99,0..99] of byte;
                 width,height: byte;
                 buildings: array[0..max_buildings] of buildings_structure;
                 units: array[0..max_units] of units_structure;
                 act_world: byte;
                 start_x,start_y: integer;
    end;

    sprites_structure = record
              units:array[0..Max_units_sprites] of spritetyp;
              Buildings:array[0..Max_Buildings_sprites] of spritetyp;
              tiles:array[0..Max_Tiles_sprites] of spritetyp;
              sprites:array[0..Max_sprites] of spritetyp;
              MenuBild,Background:spritetyp;
              pixel: spritetyp;
              KarteBild:spritetyp;
    end;

VAR
   menu_on: boolean;
   dummysprite: spritetyp;
   slowdown: boolean;
   ch:char;
   i:integer;
   tool: byte;
   font1:Byte;
   item:integer;
   x,y,butt:word;
   act_mode: byte;
   isMenu:boolean;
   IsKarte:boolean;
   einheit:integer;
   border: integer;
   maus: spritetyp;
   ofsx,ofsy:integer;
   Menuoffset:integer;
   EditorButton:xButton;
   startx,starty:integer;
   Sprites:sprites_structure;
   mission:mission_structure;
   PalNew:ARRAY[0..768] OF Byte;
   editor:array[0..3] of spritetyp;
   MouseFeld:Array[0..20] of xButton;
   act_units,act_buildings: integer;

Procedure beep;
   begin
      sound(500);
      delay(50);
      nosound;
   end;

function Stri(Zahl:integer):String;
   var
      tmp:string;
   begin
      str(Zahl,tmp);
      stri:=tmp;
   end;

function value(zahl: string): integer;
   var
      leckmich,wert: integer;
   begin
      val(zahl,wert,leckmich);
      value:=wert;
   end;

procedure make_map_tiles;
var
   c: word;
   a,b: word;
begin
      c:=0;
      for b:=0 to mission.height-1 do begin
         for a:=0 to mission.width-1 do begin
            if c=7 then c:=0;
            mission.playfield[a,b]:=tiles_start+c;
            inc(c);
         end;
      end;
end;

procedure LoadGfx_Tiles;
   var
      i: byte;
      anfang: longint;
      lengs: word;
      dummy: spritetyp;
   begin
      if XMS_ON=true then begin
         for i:=0 to max_tiles_sprites do begin
             getfileinfo(tiles_files[mission.act_world],i,anfang,lengs);
             load_sprite(tiles_files[mission.act_world],dummy,anfang);
             xms_push_sprite(dummy,sprites.tiles[i]);
             xms_push_sprite(dummy,sprites.sprites[i+toolstart[2]]);
             freesprite(dummy);
         end;
      end;
   end;

procedure showplayfield(x,y:longint);
   var
      a,b: word;
      tilex,tiley: word;
      offsetx,offsety: word;
      farbe: byte;
   begin
      if x > 3200 - 320 then x:=3200-320;
      if y > 2000 - 200 then y:=2000-200;
      tilex:=x div 32;
      tiley:=y div 20;
      offsetx:=x mod 32;
      offsety:=y mod 20;

      if XMS_ON=true then begin
         for a:=0 to 10 do begin
             for b:=0 to 10 do begin
                 xms_putsprite_medium(a*32-offsetx,b*20-offsety,sprites.tiles[mission.playfield[
                    a+tilex,b+tiley]]);
             end;
         end;
         for a:=0 to max_buildings do begin
             if mission.buildings[a].gfx <> 255 then begin
                with mission.buildings[a] do
                    xms_putsprite_exact(x-startx,y-starty,sprites.buildings[gfx]);
                    if act_buildings = a then begin
                      with mission.buildings[a] do
                          with sprites.buildings[gfx] do begin
                               if friend then farbe:=249 else farbe:=252;
                               rectangle(x-startx,y-starty,x-startx+dtx,y-starty+dty,farbe);
                               if goal then begin
                                  line(x-startx,y-starty,x-startx+dtx,y-starty+dty,farbe);
                                  line(x-startx+dtx,y-starty,x-startx,y-starty+dty,farbe);
                               end;
                          end;
                      end;
             end;
         end;
         for a:=0 to max_units do begin
             if mission.units[a].typ <> 255 then begin
                with mission.units[a] do
                     xms_putsprite_exact(x-startx,y-starty,sprites.units[typ]);
                     if act_units = a then begin
                        with mission.units[a] do
                          with sprites.units[typ] do begin
                               if friend then farbe:=249 else farbe:=252;
                               rectangle(x-startx,y-starty,x-startx+dtx,y-starty+dty,farbe);
                               if goal then begin
                                  line(x-startx,y-starty,x-startx+dtx,y-starty+dty,farbe);
                                  line(x-startx+dtx,y-starty,x-startx,y-starty+dty,farbe);
                               end;
                        end;
                        if mission.units[a].target_type = target_building then begin
                           with mission.buildings[mission.units[a].target] do begin
                                with sprites.buildings[gfx] do begin
                                     rectangle(x-startx,y-starty,x-startx+dtx,y-starty+dty,249);
                                     line(x-startx,y-starty,mission.units[a].x-startx,mission.units[a].y-starty,252);
                                end;
                           end;
                        end;
                        if mission.units[a].target_type = target_unit then begin
                           with mission.units[mission.units[a].target] do begin
                                with sprites.units[typ] do begin
                                     rectangle(x-startx,y-starty,x-startx+dtx,y-starty+dty,249);
                                     line(x-startx,y-starty,mission.units[a].x-startx,mission.units[a].y-starty,252);
                                end;
                           end;
                        end;
                     end;
             end;
         end;
      end;
   end;

Procedure Init_Buttons;
   var
      i,m:integer;
   begin
      For i:=0 to 15 do begin
         if i<8 then begin MouseFeld[i].setbutton(i*34+2,152,i*34+35,174)
         end else begin
            m:=i-8;
            MouseFeld[i].setbutton(m*34+2,175,m*34+35,197)
         end;
      end;
      MouseFeld[16].setButton(276,156,290,170);
      MouseFeld[17].setButton(276,179,290,193);
      MouseFeld[18].setButton(293,154,317,174);
      MouseFeld[19].setButton(293,175,317,195);
      EditorButton.setbutton(319-(mission.width+1),0,319,mission.height+1);
   end;

procedure getsprite_screen(x,y, width, height: integer; var zsprite: spritetyp);
   var
      acty,endy:word;
      offs:word;
      ofs_vscreen,seg_vscreen:word;
      ofs_spr,seg_spr:word;
   begin
      Error:=NoError;
      if width<1 then exit;
      if height<1 then exit;
      if y<0 then exit;
      if x<0 then exit;
      if x+width-1 > 319 then exit;
      if y+height-1 > 199 then exit;
      if maxAvail < height*width then begin
         Error:=OutOfMemError;
         exit;
      end;
      getmem(zsprite.adr,height*width);
      ofs_vscreen:=ofs(vscreen^);
      seg_vscreen:=seg(vscreen^);
      ofs_spr:=ofs(zsprite.adr^);
      seg_spr:=seg(zsprite.adr^);
      zsprite.dtx:=width;
      zsprite.dty:=height;
      acty:=y;
      endy:=y+height;

      asm
         pusha
         push ds
         push es
         mov es,seg_spr
         mov di,ofs_spr
         lds si,vbuf
@anfang:
         mov ax,320
         mul acty
         add ax,x
         mov si,ax
         mov cx,width
         rep movsb
         inc acty
         mov ax,acty
         cmp ax,endy
         jne @anfang
         pop es
         pop ds
         popa
      end;
   end;

PROCEDURE SetNewPal; ASSEMBLER;
   ASM
      push si
      mov si,Offset PalNew
      mov cx,256*3
      xor al,al
      mov dx,03c8h
      out dx,al
      inc dx

      rep outsb
      pop si
   END;

PROCEDURE Fade_To_Pal;
   VAR
      MaxColor:word;
   BEGIN
      ASM
         mov MaxColor,63 {Schreibt 63 in MaxColor, weil die maximale}
         mov ax,ds       {vernderung bei 6 Bit liegt, also 64 durchlufe}
         mov es,ax       {Schreibt das Segment der Daten:hier fr Palette & PalNew}

         lea di,Palette  {Adresse fr Bildpalettenbyte}
         lea si,PalNew   {Adresse fr Einblendpalettenbyte}

         jmp @Anfang  {springt, um nicht von di un si 768 zu subtraieren}
      @Oben:
         sub di,767   {setzt si wieder an den Anfang von PalNew}
         sub si,767   {setzt di wieder an den Anfang von PalNew}
      @Anfang:
         mov cx,0     {schreibt cx=0, damit der Zhler neu begint}
      @NachOben:
         push si      {Speichert si auf dem Stack}
            mov si,di
            lodsb     {Byte aus si(Palette) nach al laden}
            inc di
         pop si
         mov bl,al    {in bl speichern, da lodsb wieder in al schreibt}

         lodsb        {Byte aus si(jetzt PalNew) nach al laden}

         cmp al,bl    {Byte aus Palette(bl) vergleichen mit PalNew(al)}
         je @Weiter   {wenn al=bl, also Farbe bereits richtig dann geh zu @weiter}
         ja @decr     {wenn al>bl dann mu farbe erniedrigt werden}

         inc al       {sonst al erhhe}
         jmp @incr    {zu @incr springen, weil bei @decr al wieder kleiner wird}
      @decr:
         dec al       {verkleinert al um 1}
      @incr:
         dec si
         push di
            mov di,si
            stosb     {schreibe neues al in PalNew}
            inc si
         pop di
      @Weiter:
         inc cx         {erhht cx Ŀ}
         cmp cx,767     {um zu gucken, ob schon alle Bytes der PalNew erhht wurden}
         jne @NachOben  {wenn noch nicht 768 durchlufe, dann spring zu @nachoben}

         call WaitRetrace
         call SetNewPal   {setze NewPal im Grafikspeicher}
         dec MaxColor     {vermindere maxcolor um zu sehen, Ŀ}
         jne @Oben        {ob gesamter Vorgang schon 64 mal geschehen ist Ŀ}
      END;                {damit auch die hellsten Farben auf ihre 63 kommen}
   END;

PROCEDURE FadeToCol(Col:Byte);
   VAR
      MaxColor:word;
   BEGIN
      ASM
         mov MaxColor,63
         mov ax,ds
         mov es,ax
      @Oben:
         mov cx,0
      @NachOben:
         lea si,PalNew
         add si,cx
         mov di,si
         lodsb

         cmp al,col
         je @weiter
         ja @decrise

         inc al
         jmp @incrise
      @decrise:
         dec al
      @incrise:
         lea si,PalNew
         add si,cx
         mov di,si
         stosb
      @weiter:
         inc cx
         cmp cx,768
         jne @Nachoben
         call WaitRetrace
         call SetNewPal
         dec MaxColor
         jne @Oben
      END;
   END;

Procedure ClearMouse;
   begin
      if (menu_on = false) then if (y < border) and (tool = tool_tiles) then exit;
      repeat until buttonreleased(leftbutton);
      SetPointerPosition(x,y);
   end;

procedure PaintButton(x1,y1,x2,y2:integer;IsButton:boolean);
   var i:byte;
   Begin
      Filledrectangle(x1,y1,x2,y2,24);
      if IsButton then begin
         Line(x1,y1,x2,y1,7);
         Line(x1,y1,x1,y2,7);
         Line(x2,y1,x2,y2,53);
         Line(x1,y2,x2,y2,53);
      end else begin
         Line(x1,y1,x2,y1,53);
         Line(x1,y1,x1,y2,53);
         Line(x2,y1,x2,y2,7);
         Line(x1,y2,x2,y2,7);
      end;
   end;

Procedure MaleMenu(Item:Integer);
   var
      i:integer;
      dummy:spritetyp;
   Begin
      PaintButton(0,150,319,199,true);
      for i:=0 to 7 do begin
        if menubuttons[menuoffset,i] > -1 then begin
          { Button zeichnen }
          if menubuttons[menuoffset,i] <> item then
             PaintButton(MouseFeld[i].B_x1,
             MouseFeld[i].B_y1,
             MouseFeld[i].B_x2,
             MouseFeld[i].B_y2,true)
          else
             PaintButton(MouseFeld[i].B_x1,
             MouseFeld[i].B_y1,
             MouseFeld[i].B_x2,
             MouseFeld[i].B_y2,false);
             { Sprite zeichnen }
             if XMS_ON=true then begin
                xms_PutSprite_exact(MouseFeld[i].B_x1+1,
                   MouseFeld[i].B_y1+1,sprites.sprites[menubuttons[menuoffset,i]]);
             end;
        end;
      end;
      for i:=8 to 15 do begin
        if menubuttons[menuoffset+1,i-8] > -1 then begin
          { Button zeichnen }
          if menubuttons[menuoffset+1,i-8] <> item then
             PaintButton(MouseFeld[i].B_x1,
             MouseFeld[i].B_y1,
             MouseFeld[i].B_x2,
             MouseFeld[i].B_y2,true)
          else
             PaintButton(MouseFeld[i].B_x1,
             MouseFeld[i].B_y1,
             MouseFeld[i].B_x2,
             MouseFeld[i].B_y2,false);
             { Sprite zeichnen }
             if XMS_ON=true then begin
                xms_PutSprite_exact(MouseFeld[i].B_x1+1,
                   MouseFeld[i].B_y1+1,sprites.sprites[menubuttons[menuoffset+1,i-8]]);
             end;
        end;
      end;
      For i:=16 to 19 do begin
         PaintButton(MouseFeld[i].B_x1,
                     MouseFeld[i].B_y1,
                     MouseFeld[i].B_x2,
                     MouseFeld[i].B_y2,true);
         putsprite_exact(MouseFeld[i].B_x1+1,
                         MouseFeld[i].B_y1+1,
                         editor[i-16]);
      end;
   end;

Procedure MaleAlles(IsTrue:boolean);
   Begin
      clearvbuf(0);
      if XMS_ON=true then showplayfield(startx,starty);
      if IsMenu then border:=150 else border:=200;
      if y < border then begin
         ofsx:=startx mod 32;
         ofsy:=starty mod 20;
         if (XMS_ON=true) and (einheit > -1) then begin
            if tool = tool_units then
               xms_putsprite_exact(x-sprites.units[einheit].dtx div 2,
                                   y-sprites.units[einheit].dty div 2,
                                   sprites.units[einheit])
            else if tool = tool_buildings then
               xms_putsprite_exact(x-sprites.buildings[einheit-toolstart[1]].dtx div 2,
                                   y-sprites.buildings[einheit-toolstart[1]].dty div 2,
                                   sprites.buildings[einheit-toolstart[1]])
            else if tool = tool_tiles then begin
               xms_putsprite_exact(x-(x mod 32)-ofsx, y-(y mod 20)-ofsy,
                   sprites.sprites[einheit]);
               rectangle(x-(x mod 32)-ofsx, y-(y mod 20)-ofsy,x-(x mod 32)-ofsx+32, y-(y mod 20)-ofsy+20,7);
            end;
         end;
      end;
      if IsTrue then MaleMenu(Einheit);
      if IsKarte then begin
         PutSprite_fast(EditorButton.B_x1,
                        EditorButton.B_y1,
                        sprites.KarteBild);
         rectangle(editorbutton.b_x1+1+(startx div 32),
                   editorbutton.b_y1+1+(starty div 20),
                   editorbutton.b_x1+10+(startx div 32),
                   editorbutton.b_y1+10+(starty div 20),7);
      end;
   end;

Procedure ScrollMenu(location:boolean;speed:word);
   var
      i:integer;
   begin
      if location=false then begin
         i:=150;
         repeat
            MaleAlles(false);
            putsprite_medium(0,i,sprites.MenuBild);
            Showvbuf;
            i:=i+speed;
         until i>=200;
      end else begin
         i:=200;
         repeat
            MaleAlles(false);
            putsprite_medium(0,i,sprites.MenuBild);
            Showvbuf;
            i:=i-Speed;
         until i<=150;
      end;
   end;

Procedure ScrollKarte(location:boolean;speed:word);
   var
      i:integer;
      IsKarteTmp:boolean;
   begin
      IsKarteTmp:=IsKarte;
      IsKarte:=false;
      if location=false then begin
         i:=EditorButton.B_x1;
         repeat
            MaleAlles(IsMenu);
            putsprite_medium(i,0,sprites.KarteBild);
            Showvbuf;
            i:=i+speed*2;
         until i>=319;
      end else begin
         i:=319;
         repeat
            MaleAlles(IsMenu);
            putsprite_medium(i,0,sprites.KarteBild);
            Showvbuf;
            i:=i-Speed*2;
         until i<=EditorButton.B_x1;
      end;
      IsKarte:=IsKarteTmp;
   end;

Procedure Scal_Sprite_to_32x20(Var qsprite:spritetyp);
   var
      lengs,width:real;
      gesucht_x,gesucht_y:real;
   Begin
      clearvbuf(0);
      lengs:=qsprite.dtx;
      width:=qsprite.dty;
      gesucht_x:=100/(lengs/32);
      gesucht_y:=100/(width/20);
      Putsprite_Scal(0,0,Round(Gesucht_x),Round(Gesucht_y),qsprite);
      freesprite(qsprite);
      getsprite_screen(0,0,32,20,qsprite);
   end;

Procedure LoadSprites;
   var
      i:integer;
      dummy: spritetyp;
      start: longint;
      lengs: word;
   begin
      if XMS_ON=true then begin
         For i:=1 to 15 do begin
            getfileinfo('ein'+stri(i)+'.lib',7,start,lengs);
            load_sprite('ein'+stri(i)+'.lib',dummy,start);
            xms_push_sprite(dummy,sprites.units[i-1]);
            Scal_Sprite_to_32x20(dummy);
            Xms_push_sprite(dummy,sprites.sprites[i-1]);
            freesprite(dummy);
         end;
{         For i:=10 to 15 do begin
            getfileinfo('gfx\ein'+stri(i)+'.lib',7,start,lengs);
            load_sprite('gfx\ein'+stri(i)+'.lib',dummy,start);
            xms_push_sprite(dummy,sprites.units[i-1]);
            Scal_Sprite_to_32x20(dummy);
            Xms_push_sprite(dummy,sprites.sprites[i-1]);
            freesprite(dummy);
         end;}
         For i:=0 to max_buildings_sprites do begin
            getfileinfo('build.lib',i,start,lengs);
            load_sprite('build.lib',dummy,start);
            xms_push_sprite(dummy,sprites.buildings[i]);
            Scal_Sprite_to_32x20(dummy);
            Xms_push_sprite(dummy,sprites.sprites[i+15]);
            freesprite(dummy);
         end;
      end;

      load_sprite('maus0000',maus,0);

      if XMS_ON=true then begin
         loadgif('pal.gif');
         getsprite(0,0,320,200,dummy);
         xms_push_sprite(dummy,sprites.background);
         freesprite(dummy);
      end;

      load_sprite('uparrow.bjf',editor[0],0);
      load_sprite('dnarraw.bjf',editor[1],0);
      load_sprite('options.bjf',editor[2],0);
      load_sprite('exit.bjf',editor[3],0);
   end;

procedure standard;
   var
      i: word;
   begin
      for i:=0 to max_tiles_sprites do begin
         sprites.tiles[i].dtx:=0;
         sprites.tiles[i].dty:=0;
         sprites.tiles[i].adr:=nil;
      end;
      for i:=0 to max_units do begin
         with mission.units[i] do begin
              energy:=100;
              typ:=255;
              friend:=false;
              target_type:=target_nothing;
              goal:=false;
         end;
      end;
      for i:=0 to max_buildings do begin
         with mission.buildings[i] do begin
              energy:=100;
              gfx:=255;
              friend:=false;
              goal:=false;
         end;
      end;
      act_units:=-1;
      act_buildings:=-1;
   end;

Procedure MakeKarteSprite;
   var
      x_z,y_z:integer;
      x,y:integer;
      Farbe:byte;
   begin
      Farbe:=255;
      for x_Z:=EditorButton.B_x1+1 to EditorButton.B_x2-1 do begin
         for y_Z:=EditorButton.B_y1+1 to EditorButton.B_y2-1 do begin
            x:=x_z-EditorButton.B_x1;
            y:=y_z-EditorButton.B_y1;

            case mission.playfield[x-1,y-1] of
               tiles_start..tiles_start+8:Farbe:=0;
               0..7:Farbe:=134;
               8..17:Farbe:=253;
               98:Farbe:=174;
            end;
            Putpixel_Sprite(x,y,Farbe,Sprites.KarteBild);
         end;
      end;

      For i:=0 to max_units do begin
          if mission.units[i].typ <> 255 then
             putpixel_sprite((mission.units[i].x div 32)+1,(mission.units[i].y div 20)+1,252,sprites.kartebild);
      end;

{      PutSprite_fast(EditorButton.B_x1,
                           EditorButton.B_y1,
                           sprites.KarteBild);
             showvbuf;
      readkey;}

      For i:=0 to max_buildings do begin
          if mission.buildings[i].gfx <> 255 then
             putpixel_sprite((mission.buildings[i].x div 32)+1,(mission.buildings[i].y div 20)+1,252,sprites.kartebild);
      end;
   end;

procedure kill_object;
var
   i: byte;
begin
     if act_units > -1 then begin
        for i:=0 to max_units do begin
            with mission.units[i] do
                 if (target_type = target_unit) and (target = act_units) then target_type:=target_nothing;
        end;
        mission.units[act_units].typ:=255;
     end
     else if act_buildings > -1 then begin
        for i:=0 to max_units do begin
            with mission.units[i] do
                 if (target_type = target_building) and (target = act_buildings) then target_type:=target_nothing;
        end;
        mission.buildings[act_buildings].gfx:=255;
     end;
     act_units:=-1;
     act_buildings:=-1;
     makeKarteSprite;
end;

procedure set_energy;
var
   energy: integer;
   leckmich: string;
   result: string;
begin
     Mpoint_off;
     if act_units > -1 then leckmich:=stri(mission.units[act_units].energy)
     else leckmich:=stri(mission.buildings[act_buildings].energy);
     repeat
           result:=menu_input(50,50,25,'ENERGIE 1-100 z.Z.:('+leckmich+')');
           if result = '' then exit;
           energy:=value(result);
     until ((energy > 0) and (energy < 101));
     if act_units > -1 then
        mission.units[act_units].energy:=byte(energy)
     else
        if act_buildings > -1 then mission.buildings[act_buildings].energy:=byte(energy);
end;

procedure popupmenu_units;
var
   oldx,oldy: word;
begin
     elements[0]:='GEGNER';
     elements[1]:='FREUND';
     elements[2]:='MISSIONSZIEL';
     elements[3]:='ZIEL WHLEN';
     elements[4]:='LEBENSENERGIE';
     elements[5]:='LSCHEN';
     malealles(IsMenu);
     menu_popup(x,y,100,50,5);
     showvbuf;
     mpoint_on;
     getmouseposition(butt,oldx,oldy);
     repeat
           getmouseposition(butt,x,y);
           if (oldx <> x) or (oldy <> y) then begin
              malealles(IsMenu);
              menu_popup(x,y,100,50,5);
              mpoint_off;
              showvbuf;
              mpoint_on;
              oldx:=x;
              oldy:=y;
           end;
     until buttonpressed(leftbutton);
     mpoint_off;
     if act_element <> element_none then begin
        with mission.units[act_units] do begin
             case act_element of
                  0: friend:=false;
                  1: friend:=true;
                  2: if goal then goal:=false else goal:=true;
                  3: act_mode:=mode_target;
                  4: set_energy;
                  5: kill_object;
             end;
        end;
     end;
     mpoint_off;
     clearmouse;
end;

procedure popupmenu_buildings;
var
   oldx,oldy: word;
begin
     elements[0]:='GEGNER';
     elements[1]:='FREUND';
     elements[2]:='MISSIONSZIEL';
     elements[3]:='LEBENSENERGIE';
     elements[4]:='LSCHEN';
     malealles(IsMenu);
     menu_popup(x,y,100,50,4);
     showvbuf;
     mpoint_on;
     getmouseposition(butt,oldx,oldy);
     repeat
           getmouseposition(butt,x,y);
           if (oldx <> x) or (oldy <> y) then begin
              malealles(IsMenu);
              menu_popup(x,y,100,50,4);
              mpoint_off;
              showvbuf;
              mpoint_on;
              oldx:=x;
              oldy:=y;
           end;
     until buttonpressed(leftbutton);
     mpoint_off;
     if act_element <> element_none then begin
        with mission.buildings[act_buildings] do begin
             case act_element of
                  0: friend:=false;
                  1: friend:=true;
                  2: if goal then goal:=false else goal:=true;
                  3: set_energy;
                  4: kill_object;
             end;
        end;
     end;
     mpoint_off;
     clearmouse;
end;

function markiere_einheit: boolean;
var
   i: integer;
begin
     markiere_einheit:=false;
     for i:=max_units downto 0 do begin
         if mission.units[i].typ <> 255 then begin
            if xms_spriteoverlap_exact(x,y,sprites.pixel,mission.units[i].x-startx,mission.units[i].y-starty,
               sprites.units[mission.units[i].typ]) then begin
                 if act_mode = mode_target then begin
                    with mission.units[act_units] do begin
                         target:=i;
                         target_type:=target_unit;
                         act_mode:=mode_normal;
                    end;
                 end;
                 if act_units = i then popupmenu_units;
                  act_units:=i;
                  act_buildings:=-1;
                  markiere_einheit:=true;
                  exit;
            end;
         end;
     end;
     for i:=max_buildings downto 0 do begin
         if mission.buildings[i].gfx <> 255 then begin
            if xms_spriteoverlap_exact(x,y,sprites.pixel,mission.buildings[i].x-startx,mission.buildings[i].y-starty,
               sprites.buildings[mission.buildings[i].gfx]) then begin
                 if act_mode = mode_target then begin
                    with mission.units[act_units] do begin
                         target:=i;
                         target_type:=target_building;
                         act_mode:=mode_normal;
                    end;
                 end;
                 if act_buildings = i then popupmenu_buildings;
                 act_units:=-1;
                 act_buildings:=i;
                 markiere_einheit:=true;
                 exit;
            end;
         end;
     end;
end;

procedure put_object;
   var
      i: word;
      result: boolean;
   begin
      if tool = tool_buildings then begin
         for i:=0 to max_buildings do begin
            with mission do begin
               if buildings[i].gfx = 255 then begin
                  buildings[i].energy:=100;
                  buildings[i].goal:=false;
                  buildings[i].friend:=false;
                  buildings[i].gfx:=einheit-toolstart[1];
                  buildings[i].x:=startx+x-sprites.buildings[einheit-toolstart[1]].dtx div 2;
                  buildings[i].y:=starty+y-sprites.buildings[einheit-toolstart[1]].dty div 2;
                  makekartesprite;
                  exit;
               end;
            end;
         end;
      end;
      if tool = tool_units then begin
         if einheit = 14 then begin
            for i:=0 to max_units do begin
                if mission.units[i].typ = 14 then exit;
            end;
         end;
         for i:=0 to max_units do begin
            with mission do begin
               if units[i].typ = 255 then begin
                  units[i].energy:=100;
                  units[i].goal:=false;
                  units[i].friend:=false;
                  units[i].target_type:=target_nothing;
                  units[i].typ:=einheit;
                  units[i].x:=startx+x-sprites.units[einheit].dtx div 2;
                  units[i].y:=starty+y-sprites.units[einheit].dty div 2;
                  makekartesprite;
                  exit;
               end;
            end;
         end;
      end;
      if tool = tool_tiles then begin
         mission.playfield[(startx+x) div 32,(starty+y) div 20]:=einheit-toolstart[2];
         makekartesprite;
      end;
   end;

Procedure Reset_Program;
  Begin
     act_units:=-1;
     act_buildings:=-1;
     standard;
     startx:=0;starty:=0;
     IsMenu:=true;
     IsKarte:=true;
     Menuoffset:=0;
     einheit:=0;
     item:=0;

     Freesprite(sprites.KarteBild);
     Make_empty_sprite(mission.height+2,mission.width+2,sprites.KarteBild);
     init_buttons;
     screen_off;
     with EditorButton do begin
        PaintButton(B_x1,B_y1,B_x2,B_y2,true);
        Getsprite_Screen(B_x1,B_y1,mission.width+2,mission.height+2,sprites.KarteBild);
     end;
     clearvbuf(0);
     screen_on;
  end;

Procedure NewLevel;
   var
      oldx,oldy: word;
      result: string;
      newwidth,newheight:integer;
   begin
      clearmouse;
      elements[0]:='LANDSCHAFT WHLEN:';
      elements[1]:='WSTE';
      elements[2]:='WALD';
      elements[3]:='WINTER';
      elements[4]:='VULKAN';
      elements[5]:='ERDE';
      malealles(IsMenu);
      menu_main(x,y,100,50,4);
      showvbuf;
      mpoint_on;
      getmouseposition(butt,oldx,oldy);
      menu_on:=true;
      repeat
            getmouseposition(butt,x,y);
            if (oldx <> x) or (oldy <> y) then begin
               malealles(IsMenu);
               menu_main(x,y,100,50,4);
               mpoint_off;
               showvbuf;
               mpoint_on;
               oldx:=x;
               oldy:=y;
            end;
      until buttonpressed(leftbutton);
      menu_on:=false;
      mpoint_off;
      if act_element = element_none then exit;
      case act_element of
           0:mission.act_world:=sand;
           1:mission.act_world:=gras;
           2:mission.act_world:=eis;
           3:mission.act_world:=vulkan;
           4:mission.act_world:=dreck;
      end;
      mpoint_off;
      repeat
         result:=menu_input(50,50,25,'BREITE DER KARTE 10-100:');
         if result = '' then exit;
         newwidth:=value(result);
      until (newwidth>9) and (newwidth<101);
      repeat
         result:=menu_input(50,50,22,'HHE DER KARTE 10-100:');
         if result = '' then exit;
         newheight:=value(result);
      until (newheight>9) and (newheight<101);
      mission.width:=newwidth;
      mission.height:=newheight;
      make_map_tiles;

      Reset_program;
      LoadGFX_Tiles;
      mpoint_off;
      makekartesprite;
      clearmouse;
   end;

function FileExists(FileName: String): Boolean;
   var
      F: file;

   begin
     {$I-}
     Assign(F, FileName);
     Reset(F);
     Close(F);
     {$I+}
     FileExists := (IOResult = 0) and (FileName <> '');
   end;

Procedure LoadMap;
   Var
      FileName:string;
      f:file of mission_structure;

   Begin
      mpoint_off;
      repeat
         FileName:=menu_input(10,50,35,'BITTE GEBEN SIE DATEINAMEN EIN:');
         if FileName='' then exit;
      until FileExists(FileName);

      Reset_program;
      {I-}
      assign(f,filename);
      reset(f);
      read(f,mission);
      close(f);
      {I+}
      LoadGFX_Tiles;
      makeKarteSprite;
   end;

Procedure SaveMap;
   Var
      FileName:string;
      f:file of mission_structure;
      OK: boolean;
      oldx,oldy: word;
   Begin
      OK:=false;
      repeat
         mpoint_off;
         FileName:=menu_input(10,50,35,'BITTE GEBEN SIE DATEINAMEN EIN:');
         if FileName='' then exit;
         if FileExists(FileName) then begin
            elements[0]:='DATEI EXISTIERT!';
            elements[1]:='BERSCHREIBEN';
            elements[2]:='ZURCK';
            elements[3]:='ABBRECHEN';
            malealles(IsMenu);
            menu_main(x,y,100,50,2);
            showvbuf;
            mpoint_on;
            getmouseposition(butt,oldx,oldy);
            menu_on:=true;
            repeat
                  getmouseposition(butt,x,y);
                  if (oldx <> x) or (oldy <> y) then begin
                     malealles(IsMenu);
                     menu_main(x,y,100,50,2);
                     mpoint_off;
                     showvbuf;
                     mpoint_on;
                     oldx:=x;
                     oldy:=y;
                  end;
            until buttonpressed(leftbutton);
            menu_on:=false;
            mpoint_off;
            case act_element of
                 0: OK:=true;
                 1: OK:=false;
                 2: exit;
              else exit;
            end;
            mpoint_off;
            clearmouse;
         end else OK:=true;
      until OK;

      {I-}
      assign(f,filename);
      rewrite(f);
      write(f,mission);
      close(f);
      {I+}
   end;

Procedure sort_buildings;
var
   sortOK: boolean;
   dummy: buildings_structure;
   i: byte;
begin
     repeat
           sortOK:=true;
           for i:=0 to max_buildings-1 do begin
               with mission do begin
                    if buildings[i+1].y < buildings[i].y then begin
                       dummy := buildings[i];
                       buildings[i]:=buildings[i+1];
                       buildings[i+1]:=dummy;
                       sortOK:=false;
                    end;
               end;
           end;
     until sortOK;
end;

Procedure Options_Menu;
   var
      oldx,oldy:word;

   Begin
      einheit:=-1;
      elements[0]:='OPTIONEN';
      elements[1]:='NEU';
      elements[2]:='LADEN';
      elements[3]:='SPEICHERN';
      elements[4]:='GEBUDE SORTIEREN';

      malealles(IsMenu);
      menu_main(x,y,100,50,3);
      showvbuf;

      menu_on:=true;
      mpoint_on;
      getmouseposition(butt,oldx,oldy);

      repeat
         getmouseposition(butt,x,y);
         if (oldx <> x) or (oldy <> y) then begin
            malealles(IsMenu);

            menu_main(x,y,100,50,3);
            mpoint_off;
            showvbuf;

            mpoint_on;
            oldx:=x;
            oldy:=y;
         end;
      until buttonpressed(leftbutton);
      case act_element of
         0: NewLevel;
         1: LoadMap;
         2: SaveMap;
         3: sort_buildings;
      end;
      menu_on:=false;
      mpoint_off;
      clearmouse;
   end;

Procedure exitprog;
   var
      oldx,oldy:word;

   procedure ende;
   begin
      mpoint_off;
      FadeToCol(63);
      Leave_Mode13h;
      if XMS_ON=true then xms_sprites_done;
      WriteLn('Danke!');
      halt(0);
   end;

   Begin
      einheit:=-1;
      elements[0]:='PROGAMMENDE - SPEICHERN?';
      elements[1]:='JA';
      elements[2]:='NEIN';
      elements[3]:='ABBRECHEN';

      malealles(IsMenu);
      menu_main(x,y,70,50,2);
      showvbuf;

      menu_on:=true;
      mpoint_on;
      getmouseposition(butt,oldx,oldy);

      repeat
         getmouseposition(butt,x,y);
         if (oldx <> x) or (oldy <> y) then begin
            malealles(IsMenu);

            menu_main(x,y,70,50,2);
            mpoint_off;
            showvbuf;

            mpoint_on;
            oldx:=x;
            oldy:=y;
         end;
      until buttonpressed(leftbutton);
      case act_element of
         0: begin savemap; ende; end;
         1: ende;
      end;
      ch:=#0;
      menu_on:=false;
      mpoint_off;
      clearmouse;
   end;

{############################################################################}
{############################################################################}
{############################################################################}
{############################################################################}
{############################################################################}
{############################################################################}
{############################################################################}

BEGIN
   menu_on:=false;
   Init_Mode13h;

   loadgif('ed.gif');
   setpal;
   move(vscreen^,ptr($0a000,0)^,64000);

   for i:= 0 to 768 do begin
       PalNew[i]:=Palette[i];
       Palette[i]:=63;
   end;

   sprites.pixel.dtx:=0;
   sprites.KarteBild.dtx:=0;
   font1:=load_font('versuch.fnt');
   setfont(font1);
   menu_init(0,53,24,12,77,font1);

   if XMS_ON=true then xms_sprites_init(vbuf,245,2500);

   mission.act_world:=gras;
   mission.width:=51;
   mission.height:=51;
   reset_program;

   Make_empty_sprite(2,2,dummysprite);
   putpixel_sprite(0,0,255,dummysprite);
   putpixel_sprite(1,0,255,dummysprite);
   putpixel_sprite(1,1,255,dummysprite);
   putpixel_sprite(0,1,255,dummysprite);
   if xms_on then begin
      xms_push_sprite(dummysprite,sprites.pixel);
      freesprite(dummysprite);
   end;

   LoadSprites;
   loadgfx_tiles;
   make_map_tiles;
   makekartesprite;

   InitMouse;
   mpoint_init(maus);
   mpoint_off;
   Init_Buttons;
   SetPointerPosition(10,10);

   for i:= 0 to 768 do begin
       Palette[i]:=PalNew[i];
   end;

   fadeToCol(63);

   loadgif('pal.gif');

   for i:= 0 to 768 do begin
       PalNew[i]:=63;
   end;

   MaleAlles(IsMenu);
   Showvbuf;

   Fade_To_Pal;

   ch:=#0;
   slowdown:=false;

   repeat
      GetMousePosition(butt,x,y);
      if keypressed then begin
         if ch=' ' then if slowdown then slowdown:=false else slowdown:=true;
         ch:=readkey;
      end;

      if buttonpressed(rightbutton) then begin
         ClearMouse;

         if EditorButton.seekclick(x,y) then
            if IsKarte=true then with EditorButton Do Begin
               MaleAlles(IsMenu);
               Getsprite_Screen(B_x1,B_y1,
                                mission.width+3,mission.height+3,
                                sprites.KarteBild);
               IsKarte:=false;
               ScrollKarte(IsKarte,ScrollSpeed);
            end else begin
               IsKarte:=true;
               MakeKarteSprite;
               ScrollKarte(IsKarte,ScrollSpeed);
            end
         else if y >= 150 then begin
            if IsMenu=true then begin
               MaleAlles(true);
               Showvbuf;

               Getsprite_Screen(0,150,320,50,sprites.MenuBild);
               IsMenu:=false;
               ScrollMenu(IsMenu,ScrollSpeed);
            end else begin
               IsMenu:=true;
               ScrollMenu(IsMenu,ScrollSpeed);
            end;
         end else begin
            einheit:=-1;
         end;
      end;

      MaleAlles(IsMenu);
      if buttonpressed(leftbutton) then begin
         if IsKarte and editorbutton.seekclick(x,y) then begin
            if (x-editorbutton.b_x1>1) and (x-editorbutton.b_x1<mission.width-1) then begin
               if (y-editorbutton.b_y1>1) and (y-editorbutton.b_y1<mission.height-1) then begin
                  startx:=(x-editorbutton.b_x1) * 32;
                  starty:=(y-editorbutton.b_y1) * 20;
                  clearmouse;
               end;
            end;
         end else
         if (IsMenu=true) then begin
            clearmouse;
            if y < border then if einheit = -1 then markiere_einheit
            else put_object;
            For i:=16 to 19 do if MouseFeld[i].seekclick(x,y) then Begin
               item:=i;
               if Item=19 then ch:=#27;
               if Item=18 then Options_Menu;
               if Item=16 then if not (Menuoffset=0) then dec(Menuoffset);
               if Item=17 then if not (Menuoffset=max_menu-1) then inc(Menuoffset);
            end;

            For i:=0 to 7 do if MouseFeld[i].seekclick(x,y) then begin
                if menubuttons[menuoffset,i] > -1 then begin
                   einheit:=menubuttons[menuoffset,i];
                end;
            end;
            For i:=8 to 15 do if MouseFeld[i].seekclick(x,y) then begin
                if menubuttons[menuoffset+1,i-8] > -1 then begin
                   einheit:=menubuttons[menuoffset+1,i-8];
                end;
            end;
         end else if (y < border) then begin
            clearmouse;
            if einheit = -1 then markiere_einheit
            else put_object;
         end;
      end;

      if y<1 then dec(starty,scrl_y);
      if y>198 then inc(starty,scrl_y);
      if x<1 then dec(startx,scrl_x);
      if x>318 then inc(startx,scrl_x);

      if startx < 0 then startx:=0;
      if starty < 0 then starty:=0;
      if starty > mission.height*20-200 then starty:=mission.height*20-200;
      if startx > mission.width*32-320 then startx:=mission.width*32-320;

      for i:=0 to 2 do begin
          if ((einheit >= toolstart[i]) and
              (einheit <= toolend[i])) then tool:=i+1;
      end;

      putsprite_exact(x,y,maus);

      if slowdown then begin
         waitretrace;
         waitretrace;
      end;
      Showvbuf;

      if ch = #27 then exitprog;
   until false;
END.