UNIT FHandler;

{ (c) by Jan Strter 1997.                                                 }
{**************************************************************************}
{ Zweck: Verbiegt den Timer-Interrupt, um feststellen zu knnen, wieviel   }
{        whrend eines Vorgangs vergangen ist, ntzlich, um Programme wie  }
{        z.B. Spiele an unterschiedlich schnelle Rechner anpassen zu       }
{        knnen. Einfach, aber wirkungsvoll. Knnte allerdings mit anderen }
{        Units, die ebenfalls den Timer-Interrupt verbiegen (wie z.B.      }
{        Units zur Soundausgabe) in Konflikt geraten.                      }
{**************************************************************************}
{ Version: 1.5                                                             }

{**************************************************************************}
INTERFACE
{**************************************************************************}

USES
    dos, crt;

VAR
   TimerCounter: word;

PROCEDURE timer_on;
PROCEDURE timer_off;
PROCEDURE timer_begin_count;
FUNCTION timer_stop_count: word;

{**************************************************************************}
IMPLEMENTATION
{**************************************************************************}

CONST
     frequency = 1820;
     oldtimerint = $71;

VAR
   old_proc: pointer;
   TimerFreq: word;
   Orig_freq: word;
   oldexitproc: pointer;
   old_timer_counter: byte;
   handler_installed: boolean;

PROCEDURE timer_handler; INTERRUPT; ASSEMBLER;
ASM
   inc TimerCounter
   inc old_timer_counter
   cmp Old_Timer_counter,100
   jb @weiter
   int oldtimerint
   mov Old_timer_counter,0
@weiter:
   cmp TimerCounter,65000
   jb @ende
   mov TimerCounter,0
@ende:
   mov al,0020h
   out 0020h,al
END;

PROCEDURE timer_on;
VAR
   icounter: word;
   oldv: word;
BEGIN
     ASM cli END;
     handler_installed:=true;
     icounter:= 1193180 DIV Frequency;
     port[$43] := $36;
     port[$40] := Lo(icounter);
     port[$40] := Hi(icounter);

     getintvec(8,old_proc);
     setintvec(oldtimerint,old_proc);
     setintvec(8,@timer_handler);
     timercounter:=0;
     old_timer_counter:=0;
     ASM sti END;
END;

PROCEDURE timer_off;
BEGIN
     ASM cli END;
     IF handler_installed = false THEN exit;
     port[$43] := $36;
     port[$40] := 0;
     port[$40] := 0;
     getintvec(oldtimerint,old_proc);
     setintvec(8,old_proc);
     handler_installed:=false;
     ASM sti END;
END;

PROCEDURE timer_begin_count;
BEGIN
     timercounter:=0;
END;

FUNCTION timer_stop_count: word;
BEGIN
     timer_stop_count:=timercounter;
END;

PROCEDURE timer_exit; FAR;
BEGIN
     exitproc:=oldexitproc;
     IF handler_installed THEN timer_off;
END;

BEGIN
     handler_installed := false;
     oldexitproc := exitproc;
     exitproc := @timer_exit;
     timercounter := 0;
     old_timer_counter := 0;
END.