UNIT Menu;

{
 Eine kleine Unit, um unter Verwendung von SPRITE.TPU Mens, Texteingabe-
 boxen und Anzeigefenster zu kreieren.

 (c) 1997 by Jan Strter.
}

INTERFACE

USES
    sprite, button, crt;

CONST
     max_elements = 15;
     element_none = 255;
VAR
   elements: ARRAY[0..max_elements] OF STRING;
   act_element: byte;

PROCEDURE menu_init(_schwarz,_dunkelgrau,_grau,_weiss,_gelb,_schrift: byte);
PROCEDURE menu_popup(mousex,mousey: word; x,y: integer; elemente: byte);
PROCEDURE menu_main(mousex,mousey: word; x,y: integer; elemente: byte);
FUNCTION menu_input(x,y: integer; width: byte; headline: STRING): STRING;

IMPLEMENTATION

CONST
     offset_x = 5;
     offset_y = 3;
     zwischenraum_y = 2;
     headline_offset = 5;

VAR
   schwarz,dunkelgrau,grau,weiss,gelb,schrift: byte;
   akt_butt,akt_x,akt_y: word;

FUNCTION getCentered(X1,X2,Width: Integer): Integer;
BEGIN
  getCentered:=(X1+(((X2-X1)-Width) DIV 2));
END;

PROCEDURE menu_init;
BEGIN
     schwarz:=_schwarz;
     dunkelgrau:=_dunkelgrau;
     grau:=_grau;
     weiss:=_weiss;
     gelb:=_gelb;
     schrift:=_schrift;
END;

PROCEDURE PaintBox(x1,y1,x2,y2:integer;IsButton:boolean);
   BEGIN
      Filledrectangle(x1,y1,x2,y2,grau);
      IF IsButton THEN BEGIN
         Line(x1,y1,x2,y1,weiss);
         Line(x1,y1,x1,y2,weiss);
         Line(x2,y1,x2,y2,dunkelgrau);
         Line(x1,y2,x2,y2,dunkelgrau);
      END ELSE BEGIN
         Line(x1,y1,x2,y1,dunkelgrau);
         Line(x1,y1,x1,y2,dunkelgrau);
         Line(x2,y1,x2,y2,weiss);
         Line(x1,y2,x2,y2,weiss);
      END;
   END;

PROCEDURE menu_popup;
VAR
   endx,endy: integer;
   width,height: word;
   i: integer;
   temp1,temp2: byte;
   buttons: ARRAY[0..max_elements] OF xbutton;
BEGIN
     setfont(schrift);
     temp2:=0;
     height:=0;
     FOR i:=0 TO elemente DO BEGIN
         temp1:=length(elements[i]);
         IF temp1 > temp2 THEN temp2:=temp1;
         height:=height+textheight(elements[i])+zwischenraum_y;
     END;
     height:=height+2*offset_y;
     FOR i:=0 TO elemente DO BEGIN

         temp1:=length(elements[i]);
         IF temp1 = temp2 THEN break;
     END;
     width:=textwidth(elements[i])+2*offset_x;
     endx:=x+width;
     endy:=y+height;
     FOR i:=0 TO elemente DO BEGIN
         buttons[i].setbutton(x+offset_x,y+offset_y+(i*(textheight(elements[i])+zwischenraum_y)),
                              endx-offset_x,y+offset_y+(i*(textheight(elements[i])+zwischenraum_y))
                              +textheight(elements[i]));

     END;
     filledrectangle(x,y,endx,endy,grau);
     paintbox(x,y,endx,endy,true);
     act_element:=element_none;
     FOR i:=0 TO elemente DO BEGIN
         IF buttons[i].seekclick(mousex,mousey) THEN BEGIN
            filledrectangle(x+offset_x-1,y+offset_y+(i*(textheight(elements[i])+zwischenraum_y))-1,
                              endx-offset_x,y+offset_y+(i*(textheight(elements[i])+zwischenraum_y))
                              +textheight(elements[i]),gelb);
            outtextxy(x+offset_x,y+offset_y+(i*(textheight(elements[i])+zwischenraum_y)),elements[i],weiss);
            act_element := i;
         END ELSE
            outtextxy(x+offset_x,y+offset_y+(i*(textheight(elements[i])+zwischenraum_y)),elements[i],weiss);
     END;
END;

PROCEDURE menu_main;
VAR
   endx,endy: integer;
   width,height: word;
   i: integer;
   temp1,temp2: byte;
   buttons: ARRAY[0..max_elements] OF xbutton;
BEGIN
     setfont(schrift);
     temp2:=0;
     height:=0;
     FOR i:=0 TO elemente+1 DO BEGIN
         temp1:=length(elements[i]);
         IF temp1 > temp2 THEN temp2:=temp1;
         height:=height+textheight(elements[i])+zwischenraum_y;
     END;
     height:=height+2*offset_y+headline_offset;
     FOR i:=0 TO elemente+1 DO BEGIN
         temp1:=length(elements[i]);
         IF temp1 = temp2 THEN break;
     END;
     width:=textwidth(elements[i])+2*offset_x;
     endx:=x+width;
     endy:=y+height;
     FOR i:=1 TO elemente+1 DO BEGIN
         buttons[i].setbutton(x+offset_x,y+offset_y+(i*(textheight(elements[i])+zwischenraum_y))+headline_offset,
                              endx-offset_x,y+offset_y+(i*(textheight(elements[i])+zwischenraum_y))
                              +textheight(elements[i])+headline_offset);

     END;
     filledrectangle(x,y,endx,endy,grau);
     paintbox(x,y,endx,endy,true);
     act_element:=element_none;
     FOR i:=1 TO elemente+1 DO BEGIN
         IF buttons[i].seekclick(mousex,mousey) THEN BEGIN
            filledrectangle(x+offset_x-1,y+offset_y+(i*(textheight(elements[i])+zwischenraum_y))-1+headline_offset,
                              endx-offset_x,y+offset_y+(i*(textheight(elements[i])+zwischenraum_y))
                              +textheight(elements[i])+headline_offset,gelb);
            outtextxy(x+offset_x,y+offset_y+(i*(textheight(elements[i])+zwischenraum_y))+headline_offset,elements[i],weiss);
            act_element := i-1;
         END ELSE
            outtextxy(x+offset_x,y+offset_y+(i*(textheight(elements[i])+zwischenraum_y))+headline_offset,elements[i],weiss);
     END;
     outtextxy(getcentered(x,endx,textwidth(elements[0])),y+offset_y,elements[0],weiss);
END;

FUNCTION menu_input;
VAR
   txt: STRING;
   x1,y1,x2,y2: integer;
   dtx,dty: word;
   ch: char;
BEGIN
     setfont(schrift);
     dtx:=textwidth('A')*width+(2*offset_x);
     dty:=offset_y*2+(2*textheight('A'))+5;
     x1:=x;
     y1:=y;
     x2:=x1+dtx;
     y2:=y1+dty;
     paintbox(x1,y1,x2,y2,true);
     outtextxy(getcentered(x1,x2,textwidth(headline)),y1+offset_y,headline,weiss);
     paintbox(x1+offset_x-1,y2-offset_y-textheight('A')-2,x2-offset_x+1,y2-offset_y,false);
     showvbuf;
     txt:='';
     ch:=#0;
     REPEAT
           IF keypressed THEN BEGIN
              ch:=readkey;
              IF (ch <> #8) AND (length(txt) < width-1) THEN
                 txt:=txt+ch;
              IF (ch = #8) AND (length(txt) > 0) THEN BEGIN
                 txt:=copy(txt,0,length(txt)-1);
              END;
           END;
           paintbox(x1+offset_x-1,y2-offset_y-textheight('A')-2,x2-offset_x+1,y2-offset_y,false);
           outtextxy(x1+offset_x+1,y2-offset_y-textheight('A'),txt+'_',weiss);
           showvbuf;
     UNTIL (ch = #13) OR (ch = #27);
     menu_input:=copy(txt,1,length(txt)-1);
     IF ch = #27 THEN menu_input:='';
END;

BEGIN
END.