UNIT mpoint; { ver. 1.0 }

{
 Kleine Unit, um einen interrupt-gesteuerten Mauszeiger im VGA-Modus
 anzuzeigen.
 Sollte nur in Verbindung mit SPRITE.TPU (ebenfalls von mir geschrieben)
 und einer (funktionierenden) Microsoft-kompatiblen Maus-Unit verwendet
 werden.
 Modus 13h MUSS vorher initialisiert sein. Der INIT-Prozedur mu ein
 fertig geladenes Sprite bergebenwerden, das dann als Mauscursor fungiert.

 (c) 1997 by Jan Strter.

 P.S.:
 Was irgendjemand mit diesem Stckchen Software tut oder nicht tut, ist
 mir ziemlich egal.
}

{ ************************************************************************ }
INTERFACE
{ ************************************************************************ }

USES
    sprite,dos,crt,mouse;

CONST

     mpoint_noerror = 0;
     mpoint_MouseError = 1;
     mpoint_SpriteError = 2;
     mpoint_error: byte = mpoint_noerror;

PROCEDURE mpoint_init(mpointer: spritetyp);
PROCEDURE mpoint_done;
PROCEDURE mpoint_off;
PROCEDURE mpoint_on;

{ ************************************************************************ }
IMPLEMENTATION
{ ************************************************************************ }

VAR
   cursoron: boolean;
   savebuffer: pointer;
   save_width,save_height: word;
   saved: boolean;
   reg: registers;
   mpointer_sprite: spritetyp;
   interrupt_active: boolean;
   x,y: word;
   oldx,oldy: word;

PROCEDURE restorescreen(x,y: word); ASSEMBLER;
VAR
   dtx,dty: word;
ASM
   mov ax,save_width
   mov dtx,ax
   mov ax,save_height
   mov dty,ax
   push ds
   push es
   mov ax,0a000h
   mov es,ax
   mov ax,320
   mul y
   add ax,x
   mov di,ax
   lds si,savebuffer
   mov bx,dty
@anfang:
   mov cx,dtx
   rep movsb
   add di,320
   sub di,dtx
   dec bx
   ja @anfang
   pop es
   pop ds
END;

PROCEDURE savescreen(x,y: word); ASSEMBLER;
VAR
   dtx,dty: word;
ASM
   mov ax,save_width
   mov dtx,ax
   mov ax,save_height
   mov dty,ax
   mov ax,x
   mov oldx,ax
   mov ax,y
   mov oldy,ax
   push ds
   push es
   les di,savebuffer
   mov ax,320
   mul y
   add ax,x
   mov si,ax
   mov ax,0a000h
   mov ds,ax
   mov bx,dty
@anfang:
   mov cx,dtx
   rep movsb
   add si,320
   sub si,dtx
   dec bx
   ja @anfang
   pop es
   pop ds
END;

PROCEDURE putpointer(x,y: integer; VAR zsprite: spritetyp);
VAR
   startx,starty,endx: word;
   clip_dn,clip_up,clip_lt,clip_rt: word;
   ofs_spr: word;
   seg_spr: word;
   width: word;
   restx: word;
   dtx,dty:word;
BEGIN
     IF ((x>319) OR (y>199)) OR ((x+zsprite.dtx<=0) OR (y+zsprite.dty<=0)) THEN exit;
     width:=zsprite.dtx;
     ASM                        { Von Hand ist es 'nen bichen schneller,}
        xor ax,ax               { weil TP vor jedem MOV noch ein berflssiges}
        mov clip_rt,ax          { XOR AX,AX einfgt. }
        mov clip_lt,ax
        mov clip_dn,ax
        mov clip_up,ax
     END;
     endx:=x+zsprite.dtx;
     IF x<0 THEN
     BEGIN
          startx:=0;
          clip_lt:=-x;
     END
     ELSE BEGIN
          startx:=x;
          IF x+zsprite.dtx>320 THEN
          BEGIN
               endx:=320;
               clip_rt:=(x+zsprite.dtx-320);
          END;
     END;
     IF y<0 THEN
     BEGIN
          starty:=0;
          clip_up:=-y;
     END
     ELSE BEGIN
          starty:=y;
          IF y+zsprite.dty>200 THEN
          BEGIN
               clip_dn:=(y+zsprite.dty-200);
          END;
     END;
     seg_spr:=seg(zsprite.adr^);
     ofs_spr:=ofs(zsprite.adr^);
     restx:=320-endx;
     dtx:=zsprite.dtx-clip_rt-clip_lt;
     dty:=zsprite.dty-clip_up-clip_dn;
ASM
   pusha                                {Rettet mal wieder die Wale, h,}
   push es                              {die Register}
   mov ax,0a000h
   mov es,ax                            {Bildschirm-Segment nach ES}
   push ds
   cld                                  {Direction Flag lschen}
   mov ds,seg_spr                       {Sprite-Segment nach DS}
   mov ax,width                         {Offset in Sprite-Daten berechnen.}
   mul clip_up
   add ax,clip_lt
   add ax,ofs_spr
   mov si,ax                            {Und in SI laden}
   mov ax,320                           {Offset in VBUF berechnen}
   mul starty
   add ax,startx
   mov di,ax                            {Und nach DI laden.}
   mov cx,dtx
   mov bx,dty
@anfang:
   lodsb                                {Byte holen}
   or al,al                             {Prfen, ob Null}
   je @null                             {Wenn ja, dann Sprung}
   mov es:[di],al                       {ansonsten: Pixel setzen}
@null:
   inc di                               {DI weiter, um Pixel zu berspringen}
   dec cx                               {CX erniedrigen}
   jne @anfang                          {wenn grer Null, nochmal}
   add si,clip_rt                       {Sonst Zeiger weitersetzen}
   add si,clip_lt
   add di,restx
   add di,startx
   mov cx,dtx
   dec bx                               {Y-Zhler runter und gucken, ob Ende}
   jne @anfang                          {Wenn nicht, dann nochmal (GHN!)}
   pop ds
   pop es
   popa                                 {Register restaurieren...}
END;
END;                                    {Bis zum nchsten Mal, tsch.}

PROCEDURE mpoint_handler(Flags, CS, IP, AX, BX, CX, DX, SI, DI, DS, ES, BP : WORD); INTERRUPT;
BEGIN
     x:=cx;
     y:=dx;
     IF cursoron THEN BEGIN
        IF saved THEN BEGIN
           restorescreen(oldx,oldy);
           saved:=false;
        END;
        savescreen(cx,dx);
        saved:=true;
        putpointer(cx,dx,mpointer_sprite);
     END;
     INLINE($8B/$E5/$5D/$07/$1F/$5F/$5E/$5A/$59/$5B/$58/$CB);
     interrupt_active := false;
END;

PROCEDURE mpoint_init;
CONST
     EventMask = 1;
BEGIN
  IF save_width <> 0 THEN freemem(savebuffer,save_height*save_width);
  save_width:=mpointer.dtx;
  save_height:=mpointer.dty;
  oldx:=0;
  oldy:=0;
  saved:=false;
  getmem(savebuffer,mpointer.dtx*mpointer.dty);
  mpointer_sprite := mpointer;
  Reg.AX := 12;
  Reg.CX := EventMask;
  Reg.ES := seg(mpoint_handler);
  Reg.DX := ofs(mpoint_handler);
  intr($33, Reg);
{  setpointershape(mpointer.dtx,mpointer.dty,seg(mpointer.adr^),ofs(mpointer.adr^));
  showmouse;}
END;

PROCEDURE mpoint_done;
BEGIN
END;

PROCEDURE mpoint_on;
BEGIN
     savescreen(x,y);
     putpointer(x,y,mpointer_sprite);
     cursoron:=true;
END;

PROCEDURE mpoint_off;
BEGIN
     IF saved THEN restorescreen(x,y);
     cursoron:=false;
END;

BEGIN
     cursoron:=false;
     saved:=false;
     save_width:=0;
     save_height:=0;
END.