TITLE RMEMASM.ASM

  MODEL LARGE,PASCAL

  NOJUMPS

  extrn xms_enable_a20  : far
  public mem_lesen
  public mem_Write
  public Enable_4Giga
  public Multitasker_aktiv
  public xms_putsprite_fast_asm
  public xms_putbackground
  public xms_putsprite
  public xms_putsprite_med
  public xms_spriteoverlap_asm
  public putsprite_shadow_asm
  public putsprite_trans_asm

  DATASEG
  extrn xms_vbuf        : dword
  extrn GDT_Off         : byte
  extrn GDT             : byte

  CODESEG
  .386P


;*************************************************************************
;***                                                                   ***
;***   Prft, ob ein Multitasker wie QEMM oder EMM386 aktiv ist        ***
;***                                                                   ***
;*************************************************************************
proc Multitasker_aktiv far
   mov eax,cr0
   and ax,1
   ret
;Multitasker_aktiv endp
endp

;*************************************************************************
;***                                                                   ***
;***      Kopiert einen Block aus dem RMEM in den Hauptspeicher        ***
;***                                                                   ***
;*************************************************************************
proc mem_Lesen far quellp:dword,zielofs : word,zielseg : word,laenge:word
         call xms_Enable_A20
         mov  ax,zielseg           ; Hauptspeicher-addy nach ES:SI
         mov  es,ax
         mov  di,zielofs
         xor  ax,ax                ; RMEM Quelladresse nach GS:EAX
         mov  gs,ax
         mov  eax,quellp
         mov  cx,laenge
lloop:   mov  bl,byte ptr gs:[eax] ; Bytes kopieren
         mov  es:[di],bl
         inc  eax
         inc  di
         loop lloop
         ret
;mem_Lesen endp
endp

;*************************************************************************
;***                                                                   ***
;***       Kopiert einen Block aus dem Hauptspeicher ins RMEM          ***
;***                                                                   ***
;*************************************************************************

proc mem_Write far quellp:dword, zielofs:word, zielseg:word, laenge:word
         call xms_Enable_A20
         mov  ax,zielseg           ; Hauptspeicher-addy nach ES:SI
         mov  es,ax
         mov  di,zielofs
         xor  ax,ax                ; RMEM Quelladresse nach GS:EAX
         mov  gs,ax
         mov  eax,quellp
         mov  cx,laenge
nloop:
         mov  bl,es:[di]           ; Bytes kopieren
         mov  byte ptr gs:[eax],bl
         inc  eax
         inc  di
         loop nloop
         ret
;mem_Write endp
endp
;*************************************************************************
;***                                                                   ***
;***            Schaltet den Processor ins Flat - Model                ***
;***                                                                   ***
;*************************************************************************
proc Enable_4Giga far
	mov GDT_Off[0],16
	mov eax,seg GDT
	shl eax,4
	mov bx,offset GDT
	movzx ebx,bx
	add eax,ebx
	mov dword ptr GDT_Off[2],eax
	lgdt pword ptr GDT_Off         ; GDT laden

	mov bx,08h                     ;  bx zeigt auf den 1. Eintrag des GDT
	push ds
	cli                            ; Interrupts ausschalten
	mov eax,cr0                    ; In den Protected mode schalten
	or eax,1
	mov cr0,eax
	jmp In_den_Protectedmode       ; Executionpipe lschen
	In_den_Protectedmode:
	mov gs,bx                      ; Segmente auf 4 GB anpassen
	mov fs,bx
	mov es,bx
	mov ds,bx
	and al,0FEh                    ; Zurck in den Real-mode schalten, ohne den
	mov cr0,eax                    ; Processor zu resetten
	jmp In_den_Realmode            ; Executionpipe lschen
	In_den_Realmode:
	sti                            ; Interrupts wieder einschalten
	pop ds
  ret
;Enable_4Giga endp
endp

PROC xms_putsprite_fast_asm FAR x:word, y:word, adr:dword, dtx:word, dty:word, dwords: word, bytes:word
  call xms_Enable_A20
  les di,xms_vbuf
  mov ax,320
  sub ax,dtx
  mov si,ax
  mov ax,320
  mul y
  add ax,x
  add di,ax
  xor eax,eax
  mov gs,ax
  mov eax,adr
  add eax,100000h
  mov dx,dty
anfang_y:
  mov cx,dwords
  or cx,cx
  je copy_bytes
anfang_x_d:
  mov ebx,dword ptr gs:[eax]
  mov dword ptr es:[di],ebx
  add eax,4
  add di,4
  dec cx
  jne anfang_x_d
copy_bytes:
  mov cx,bytes
  or cx,cx
  je override_bytes
anfang_x:
  mov bl,byte ptr gs:[eax]
  mov es:[di],bl
  inc eax
  inc di
  dec cx
  jne anfang_x
override_bytes:
  add di,si
  dec dx
  ja anfang_y
  ret
ENDP

PROC xms_putbackground FAR adr:dword
   call xms_Enable_A20
   les di,xms_vbuf
   xor eax,eax
   mov gs,ax
   mov eax,adr
   add eax,100000h
   mov cx,16000
anfang:
   mov ebx,dword ptr gs:[eax]
   mov dword ptr es:[di],ebx
   add eax,4
   add di,4
   dec cx
   jne anfang
   ret
ENDP


PROC xms_putsprite FAR adr:dword,x:word,y:word,c_l:word,c_r:word,c_u:word,c_d:word,rest_z:word,dtx:word,dty:word,wdt:word
   call xms_Enable_A20

   les di,xms_vbuf                ; Ziel-Adresse berechnen
   mov ax,320
   mul y
   add ax,x
   add di,ax

   xor eax,eax                     ; Quell-Adresse berechnen
   mov gs,ax
   mov ebx,adr
   add ebx,100000h
   mov ax,dtx
   mul c_u
   add ax,c_l
   add ebx,eax

   mov ax,dty
   mov dx,ax
y_loop:
   mov cx,wdt
x_loop:
   mov al,byte ptr gs:[ebx]
   inc ebx
   or al,al
   je null
   mov es:[di],al
null:
   inc di
   dec cx
   jne x_loop
   xor eax,eax
   add ax,c_r
   add ax,c_l
   add ebx,eax
   add di,rest_z
   add di,x
   dec dx
   jne y_loop
   ret
ENDP



PROC putsprite_shadow_asm FAR adr:dword,x:word,y:word,c_l:word,c_r:word,c_u:word,c_d:word,rest_z:word,dtx:word,dty:word,wdt:word,ts:word,to:word

   call xms_Enable_A20
   push ds

   les di,xms_vbuf
   mov ax,320
   mul y
   add ax,x
   add di,ax

   mov ds,ts

   xor eax,eax                     ; Quell-Adresse berechnen
   mov gs,ax
   mov ebx,adr
   add ebx,100000h
   mov ax,dtx
   mul c_u
   add ax,c_l
   add ebx,eax

   mov ax,dty
   mov dx,ax
y_loop_s:
   mov cx,wdt
x_loop_s:
   mov al,byte ptr gs:[ebx]
   inc ebx
   or al,al
   je null_s

   xor ax,ax
   mov si,to
   mov al,es:[di]
   add si,ax
   mov al,ds:[si]

   mov es:[di],al
null_s:
   inc di
   dec cx
   jne x_loop_s
   xor eax,eax
   add ax,c_r
   add ax,c_l
   add ebx,eax
   add di,rest_z
   add di,x
   dec dx
   jne y_loop_s
   pop ds
   ret
ENDP

PROC putsprite_trans_asm FAR adr:dword,x:word,y:word,c_l:word,c_r:word,c_u:word,c_d:word,rest_z:word,dtx:word,dty:word,wdt:word,ts:word

   call xms_Enable_A20
   push ds

   les di,xms_vbuf
   mov ax,320
   mul y
   add ax,x
   add di,ax

   xor eax,eax                     ; Quell-Adresse berechnen
   mov gs,ax
   mov ebx,adr
   add ebx,100000h
   mov ax,dtx
   mul c_u
   add ax,c_l
   add ebx,eax

   mov ax,dty
   mov dx,ax
   mov ds,ts			  ; Segment der Transparenz-Tabelle nach DS
y_loop_t:
   mov cx,wdt
x_loop_t:
   mov al,byte ptr gs:[ebx]
   or al,al
   je null_t

   xor ax,ax
   mov al,es:[di]
   mov si,ax
   shl si,8
   mov al,byte ptr gs:[ebx]
   add si,ax
   mov al,ds:[si]
   mov es:[di],al

null_t:
   inc ebx
   inc di
   dec cx
   jne x_loop_t
   xor eax,eax
   add ax,c_r
   add ax,c_l
   add ebx,eax
   add di,rest_z
   add di,x
   dec dx
   jne y_loop_t
   pop ds
   ret
ENDP


PROC xms_putsprite_med FAR adr:dword,x:word,y:word,c_r:word,c_l:word,c_u:word,c_d:word,rest:word,dtx:word,dty:word,wdt:word,w:word,b:word
   call xms_enable_a20

   les di,xms_vbuf
   mov ax,320
   mul y
   add ax,x
   add di,ax

   mov ebx,adr                ; Quell-Adresse berechnen
   add ebx,100000h
   xor eax,eax
   mov gs,ax
   mov ax,wdt
   mul c_u
   add ax,c_l
   add ebx,eax

   mov dx,dty

loop_y:

   mov cx,w
   or cx,cx
   je override_d
loop_x_d:
   mov eax,dword ptr gs:[ebx]
   mov dword ptr es:[di],eax
   add ebx,4
   add di,4
   dec cx
   jne loop_x_d

override_d:
   mov cx,b
   or cx,cx
   je override_b
loop_x_b:
   mov al,byte ptr gs:[ebx]
   mov byte ptr es:[di],al
   inc ebx
   inc di
   dec cx
   jne loop_x_b

override_b:
   xor eax,eax
   mov ax,c_l
   add ax,c_r
   add ebx,eax
   add di,rest
   add di,x

   dec dx
   jne loop_y

   ret
ENDP




proc xms_spriteoverlap_asm FAR x1:word,y1:word,a1:dword,x2:word,y2:word,a2:dword,r1:dword,r2:dword,sx1:word,sx2:word,sy1:word,sy2:word,d1:word,d2:word,w:word,h:word

   call xms_enable_a20

   xor eax,eax
   mov ebx,a1
   mov ax,d1
   mul sy1
   add ax,sx1
   add ebx,eax
   add ebx,100000h
   mov esi,ebx

   xor eax,eax
   mov ebx,a2
   mov ax,d2
   mul sy2
   add ax,sx2
   add ebx,eax
   add ebx,100000h
   mov edi,ebx

   xor ax,ax
   mov gs,ax

   xor ebx,ebx
   mov bx,h
anfy:
   mov cx,w
anfx:
   mov ah,byte ptr gs:[esi]
   mov al,byte ptr gs:[edi]
   and ah,al
   jz weiter
   jmp hit
weiter:
   inc esi
   inc edi
   dec cx
   jne anfx
   add esi,r1
   add edi,r2
   dec bx
   jne anfy
   jmp nohit
hit:
   mov al,1
   jmp ende
nohit:
   mov al,0
ende:
   ret

ENDP



END