{$V-}{$M 16000,0,0} {$R-}
Unit SCREEN;    {Unit, die direkten Zugriff auf Bildschirmspeicher gewhrt}
{===========================================================================}
INTERFACE
{===========================================================================}
USES
    CRT;

TYPE
    LISTTYPE = RECORD
             ELEMENT: ARRAY[1..23] OF STRING;
    END;

    SCREENTYPE = ARRAY[0..3999] OF BYTE;

    WINDOW_CLASS = OBJECT
         X1_,Y1_,X2_,Y2_,FC_,BC_: BYTE;
         Shadow_: BOOLEAN;
         SCREENNO_: BYTE;
         Title_: STRING;
         RESTORE: SCREENTYPE;
         PROCEDURE SAVE_SCREEN;
         PROCEDURE RESTORE_SCREEN;
         PROCEDURE SHOW;
         PROCEDURE HIDE;
         PROCEDURE WRITE(X,Y: BYTE; STR: STRING);
         FUNCTION INPUTLINE(X,Y,WIDTH: BYTE): STRING;
         PROCEDURE INIT(SCREENNO,FC,BC,X1,Y1,X2,Y2: BYTE; Title: STRING; Shadow: BOOLEAN);
    END;

CONST
     MAXSCREEN = 1;
     HL_FC = WHITE;
     HL_BC = BLUE;
     NORMAL_FC = WHITE;
     NORMAL_BC = RED;
     CENTERED = 0;
     AUTO = 0;

VAR
     SCREENSEG: WORD;
     SCREENBUF: ARRAY[0..MAXSCREEN] OF SCREENTYPE;
     SWAPBUF: SCREENTYPE;
     LISTE: LISTTYPE;
     BUFMINX,BUFMINY,BUFMAXX,BUFMAXY: BYTE;

     BUFACTINDEX: INTEGER;
     ACTATTR: BYTE;
     I,K: INTEGER;

PROCEDURE COLORCHECK;
PROCEDURE SETCOLORS(T_COL, BK_COL: BYTE);
FUNCTION GETCENTERED(WERT1,WERT2,BREITE: BYTE): INTEGER;
PROCEDURE SETATTR(ATTRIBUTE: BYTE);
PROCEDURE SCREENNOCHECK(SCREENNO: BYTE);
PROCEDURE PUSHSCREEN(SCREENNO: BYTE);
PROCEDURE POPSCREEN(SCREENNO: BYTE);
PROCEDURE CLEARBUF(SCREENNO: BYTE);
PROCEDURE FILLBUF(SCREENNO: BYTE; CH: CHAR);
PROCEDURE PUTCHAR(SCREENNO: BYTE; X: BYTE; Y: BYTE; CH: CHAR);
FUNCTION GETCHAR(SCREENNO: BYTE; X: BYTE; Y: BYTE): CHAR;
FUNCTION GETATTR(SCREENNO: BYTE; X: BYTE; Y: BYTE): BYTE;
PROCEDURE PUTSTRING(SCREENNO: BYTE; X: BYTE; Y: BYTE; STR: STRING);
PROCEDURE PUTSHADOWCHAR(SCREENNO, X, Y: BYTE);
PROCEDURE DRAWBOX(SCREENNO,X1,Y1,X2,Y2: BYTE; Title: STRING; SHADOW: BOOLEAN);
FUNCTION LISTBOX(SN,X,Y,WIDTH: BYTE; LISTE: LISTTYPE; ELEMENTS: INTEGER; TITLE: STRING): INTEGER;
{===========================================================================}
IMPLEMENTATION
{===========================================================================}

PROCEDURE COLORCHECK;
BEGIN
     IF (MEM[$0000:$0410] AND $30) <> $30 THEN
         SCREENSEG:=$B800
     ELSE
         SCREENSEG:=$B000;
END;
{===========================================================================}
PROCEDURE SCREENNOCHECK(SCREENNO: BYTE);
BEGIN
     IF ((SCREENNO<0) OR (SCREENNO>MAXSCREEN)) THEN BEGIN NORMVIDEO; HALT; END;
END;
{===========================================================================}
PROCEDURE SETATTR(ATTRIBUTE: BYTE);
BEGIN
     ACTATTR:=ATTRIBUTE;
END;
{===========================================================================}
FUNCTION GETCENTERED(WERT1,WERT2,BREITE: BYTE): INTEGER;
BEGIN
     GETCENTERED:=(WERT1+(((WERT2-WERT1)-BREITE) DIV 2));
END;
{===========================================================================}
PROCEDURE SETCOLORS(T_COL, BK_COL: BYTE);
VAR
   OLDATTR: BYTE;
BEGIN
     OLDATTR:=TEXTATTR;
     TEXTCOLOR(T_COL);
     TEXTBACKGROUND(BK_COL);
     SETATTR(TEXTATTR);
     TEXTATTR:=OLDATTR;
END;
{===========================================================================}
PROCEDURE PUSHSCREEN(SCREENNO: BYTE);
BEGIN
     COLORCHECK;
     SCREENNOCHECK(SCREENNO);
     FOR I:=0 TO 3999 DO SCREENBUF[SCREENNO][I]:=MEM[SCREENSEG:I];
END;
{===========================================================================}
PROCEDURE POPSCREEN(SCREENNO: BYTE);
BEGIN
     COLORCHECK;
     SCREENNOCHECK(SCREENNO);
     FOR I:=0 TO 3999 DO MEM[SCREENSEG:I]:=SCREENBUF[SCREENNO][I];
END;
{===========================================================================}
PROCEDURE CLEARBUF(SCREENNO: BYTE);
BEGIN
     COLORCHECK;
     SCREENNOCHECK(SCREENNO);
     FOR I:=0 TO 1999 DO BEGIN
         SCREENBUF[SCREENNO][I*2]:=$20;
         SCREENBUF[SCREENNO][I*2+1]:=ACTATTR;
     END;
END;
{===========================================================================}
PROCEDURE FILLBUF(SCREENNO: BYTE; CH: CHAR);
BEGIN
     COLORCHECK;
     SCREENNOCHECK(SCREENNO);
     FOR I:=0 TO 1999 DO BEGIN
         SCREENBUF[SCREENNO][I*2]:=ORD(CH);
         SCREENBUF[SCREENNO][I*2+1]:=ACTATTR;
     END;
END;
{===========================================================================}
PROCEDURE PUTCHAR(SCREENNO: BYTE; X: BYTE; Y: BYTE; CH: CHAR);
VAR
   BUFBYTE: INTEGER;
BEGIN
     IF X*Y < 2001 THEN BEGIN
        SCREENNOCHECK(SCREENNO);
        BUFBYTE:=(80*(Y-1)+(X-1))*2;
        SCREENBUF[SCREENNO][BUFBYTE]:=ORD(CH);
        SCREENBUF[SCREENNO][BUFBYTE+1]:=ACTATTR;
     END;
END;
{===========================================================================}
FUNCTION GETCHAR(SCREENNO: BYTE; X: BYTE; Y: BYTE): CHAR;
BEGIN
     SCREENNOCHECK(SCREENNO);
     IF X*Y < 2001 THEN BEGIN
        GETCHAR:=CHR(SCREENBUF[SCREENNO][(80*(Y-1)+(X-1))*2]);
     END;
END;
{===========================================================================}
FUNCTION GETATTR(SCREENNO: BYTE; X: BYTE; Y: BYTE): BYTE;
BEGIN
     SCREENNOCHECK(SCREENNO);
     IF X*Y < 2001 THEN BEGIN
        GETATTR:=SCREENBUF[SCREENNO][((80*(Y-1)+(X-1))*2)+1];
     END;
END;
{===========================================================================}
PROCEDURE PUTSTRING(SCREENNO: BYTE; X: BYTE; Y: BYTE; STR: STRING);
VAR
   ACTBUFBYTE: INTEGER;
BEGIN
     SCREENNOCHECK(SCREENNO);
     IF X*Y < 2001 THEN BEGIN
        ACTBUFBYTE:=(80*(Y-1)+(X-1))*2;
        FOR I:=1 TO LENGTH(STR) DO BEGIN
            IF ACTBUFBYTE > 3999 THEN
               I:=LENGTH(STR)
            ELSE BEGIN
               SCREENBUF[SCREENNO][ACTBUFBYTE]:=ORD(STR[I]);
               INC(ACTBUFBYTE);
               SCREENBUF[SCREENNO][ACTBUFBYTE]:=ACTATTR;
               INC(ACTBUFBYTE);
            END;
        END;
     END;
END;
{===========================================================================}
PROCEDURE PUTSHADOWCHAR(SCREENNO, X, Y: BYTE);
VAR
   ACTATTR_:BYTE;
   CH: CHAR;
BEGIN
     SCREENNOCHECK(SCREENNO);
     IF X*Y < 2001 THEN BEGIN
        ACTATTR_:=ACTATTR;
        CH:=GETCHAR(SCREENNO, X, Y);
        SETCOLORS(7,0);
        PUTCHAR(SCREENNO,X,Y,CH);
        ACTATTR:=ACTATTR_;
     END;
END;
{===========================================================================}
PROCEDURE DRAWBOX(SCREENNO,X1,Y1,X2,Y2: BYTE; Title: STRING; SHADOW: BOOLEAN);
VAR
   A,B: INTEGER;
BEGIN
     SCREENNOCHECK(SCREENNO);
     IF ((X1<1) OR (X1>80)) THEN EXIT;
     IF ((Y1<1) OR (Y1>25)) THEN EXIT;
     IF ((X2<1) OR (X2>80)) THEN EXIT;
     IF ((Y2<1) OR (Y2>25)) THEN EXIT;
     PUTCHAR(SCREENNO,X1,Y1,'');
     FOR A:=X1+1 TO X2-1 DO PUTCHAR(SCREENNO,A,Y1,'');
     PUTCHAR(SCREENNO,X2,Y1,'');
     FOR B:=Y1+1 TO Y2-1 DO BEGIN
         PUTCHAR(SCREENNO,X1,B,'');
         FOR A:=X1+1 TO X2-1 DO PUTCHAR(SCREENNO,A,B,' ');
         IF SHADOW THEN BEGIN PUTSHADOWCHAR(SCREENNO,X2+1,B); PUTSHADOWCHAR(SCREENNO,X2+2,B); END;
         PUTCHAR(SCREENNO,X2,B,'');
     END;
     PUTCHAR(SCREENNO,X1,Y2,'');
     FOR A:=X1+1 TO X2-1 DO PUTCHAR(SCREENNO,A,Y2,'');
     PUTCHAR(SCREENNO,X2,Y2,'');
     IF SHADOW THEN BEGIN PUTSHADOWCHAR(SCREENNO,X2+1,Y2); PUTSHADOWCHAR(SCREENNO,X2+2,Y2); END;
     IF SHADOW THEN BEGIN
        FOR A:=X1+2 TO X2+2 DO PUTSHADOWCHAR(SCREENNO,A,Y2+1);
     END;
     IF ((LENGTH(Title) < X2-X1) AND (LENGTH(Title) > 0)) THEN BEGIN
        PUTSTRING(SCREENNO,(X2-X1-LENGTH(Title)) div 2+X1, Y1, Title);
     END;
END;
{===========================================================================}
PROCEDURE WINDOW_CLASS.SAVE_SCREEN;
BEGIN
     FOR I:=0 TO 3999 DO RESTORE[I]:=MEM[SCREENSEG:I];
END;
{===========================================================================}
PROCEDURE WINDOW_CLASS.RESTORE_SCREEN;
BEGIN
     FOR I:=0 TO 3999 DO MEM[SCREENSEG:I]:=RESTORE[I];
END;
{===========================================================================}
PROCEDURE WINDOW_CLASS.SHOW;
VAR
   OLD_ATTR: BYTE;
BEGIN
     SAVE_SCREEN;
     OLD_ATTR:=ACTATTR;
     SETCOLORS(FC_,BC_);
     DRAWBOX(SCREENNO_,X1_,Y1_,X2_,Y2_,Title_,Shadow_);
     ACTATTR:=OLD_ATTR;
END;
{===========================================================================}
PROCEDURE WINDOW_CLASS.HIDE;
BEGIN
     RESTORE_SCREEN;
END;
{===========================================================================}
PROCEDURE WINDOW_CLASS.WRITE(X,Y: BYTE; STR: STRING);
VAR
   A: INTEGER;
   OLDATTR: BYTE;
BEGIN
     OLDATTR:=ACTATTR;
     SETCOLORS(FC_,BC_);
     FOR A:=0 TO LENGTH(STR)-1 DO BEGIN
         IF ((X1_+X+A IN [X1_..X2_]) AND (Y1_+Y IN [Y1_..Y2_])) THEN BEGIN
            PUTCHAR(SCREENNO_,X1_+X+A,Y1_+Y,STR[A+1]);
         END;
     END;
     ACTATTR:=OLDATTR;
END;
{===========================================================================}
FUNCTION WINDOW_CLASS.INPUTLINE(X,Y,WIDTH: BYTE): STRING;
VAR
   OLDATTR: BYTE;
   LINE: STRING;
BEGIN
     IF ((X1_+X IN [X1_..X2_]) AND (X1_+X+WIDTH IN [X1_..X2_])) THEN BEGIN
        IF (Y1_+Y IN [Y1_..Y2_]) THEN BEGIN
           WINDOW(X1_+X,Y1_+Y,X1_+X+WIDTH,Y1_+Y);
           OLDATTR:=ACTATTR;
           TEXTCOLOR(YELLOW);
           TEXTBACKGROUND(BLUE);
           CLRSCR;
           READLN(LINE);
           INPUTLINE:=LINE;
           ACTATTR:=OLDATTR;
           WINDOW(1,1,80,25);
        END;
     END;
END;
{===========================================================================}
PROCEDURE WINDOW_CLASS.INIT(SCREENNO,FC,BC,X1,Y1,X2,Y2: BYTE; Title: STRING; Shadow: BOOLEAN);
BEGIN
     FC_:=FC;
     BC_:=BC;
     X1_:=X1;
     Y1_:=Y1;
     X2_:=X2;
     Y2_:=Y2;
     SCREENNO_:=SCREENNO;
     Title_:=Title;
     Shadow_:=Shadow;
END;
{===========================================================================}
FUNCTION LISTBOX(SN,X,Y,WIDTH: BYTE; LISTE: LISTTYPE; ELEMENTS: INTEGER; TITLE: STRING): INTEGER;
VAR
   RESTORE: SCREENTYPE;
   ACT_ELEMENT: INTEGER;
   ACT_POS: INTEGER;
   MAX_ELEMENTS: INTEGER;
   CH: CHAR;

PROCEDURE PUTELEMENTXY(SN,X,Y,WIDTH: BYTE; ELEMENT: STRING; HL: BOOLEAN);
VAR
   DINGS: INTEGER;
BEGIN
   IF HL THEN SETCOLORS(HL_FC, HL_BC) ELSE SETCOLORS(NORMAL_FC,NORMAL_BC);
   PUTSTRING(SN,X,Y,ELEMENT);
   IF Length(Element) < Width then begin
      for dings:=x+length(element) to x+width-1 do
          putchar(sn,dings,y,' ');
    end;
END;

PROCEDURE SCROLLTO(SN: BYTE; POS: INTEGER);
VAR
   A: INTEGER;
   ELEMENT: STRING;
BEGIN
     FOR A:=0 TO ELEMENTS DO BEGIN
         IF A < MAX_ELEMENTS THEN BEGIN
            IF ACT_POS+A = ACT_ELEMENT THEN
               PUTELEMENTXY(SN,X+1,Y+A+1,WIDTH,LISTE.ELEMENT[A+1],TRUE)
            ELSE
               PUTELEMENTXY(SN,X+1,Y+A+1,WIDTH,LISTE.ELEMENT[A+1],FALSE);
         END;
     END;
     ACT_POS:=POS;
END;

PROCEDURE GO_UP;
BEGIN
     IF ACT_ELEMENT > 1 THEN BEGIN
        ACT_ELEMENT:=ACT_ELEMENT-1;
        SCROLLTO(SN,1);
     END;
END;

PROCEDURE GO_DOWN;
BEGIN
     IF ACT_ELEMENT < MAX_ELEMENTS THEN BEGIN
        ACT_ELEMENT:=ACT_ELEMENT+1;
        SCROLLTO(SN,1);
     END;
END;

PROCEDURE RESTORE_SCREEN;
BEGIN
     FOR I:=0 TO 3999 DO MEM[SCREENSEG:I]:=RESTORE[I];
     PUSHSCREEN(SN);
END;

BEGIN
     IF X = 0 THEN X := GETCENTERED(1,80,WIDTH);
     IF Y = 0 THEN Y := GETCENTERED(1,25,ELEMENTS);
     SCREENNOCHECK(SN);
     FOR I:=0 TO 3999 DO RESTORE[I]:=MEM[SCREENSEG:I];
     SETCOLORS(NORMAL_FC,NORMAL_BC);
     DRAWBOX(SN,X,Y,X+WIDTH+1,Y+ELEMENTS+1,TITLE,TRUE);
     ACT_ELEMENT:=1;
     ACT_POS:=1;
     MAX_ELEMENTS:=ELEMENTS;
     SCROLLTO(SN,1);
     POPSCREEN(SN);
     REPEAT
           CH:=READKEY;
           IF CH = #27 THEN BEGIN LISTBOX:=-1; RESTORE_SCREEN; EXIT; END;
           IF CH = #13 THEN BEGIN LISTBOX:=ACT_ELEMENT; RESTORE_SCREEN; EXIT; END;
           IF CH = #0 THEN BEGIN
              CH:=READKEY;
              IF CH = #72 THEN GO_UP;
              IF CH = #80 THEN GO_DOWN;
           END;
           POPSCREEN(SN);
     UNTIL CH = #27;
END;
{===========================================================================}
{Initalisierungsteil}
{===========================================================================}
BEGIN
     COLORCHECK;
     SETCOLORS(7,0);
END.
{===========================================================================}
{Ende der Untit}
{===========================================================================}