program soundset;       {Mal wieder ein SOUNDSET - diesmal fr ABLAZE!}

uses
    crt, dos, screen;

const
     ver_str = 'V1.0';
     statusbar_str = 'SOUND-Setup '+ver_str+' fr THE DRAFT. Copyright (c) by Jan Strter 1997.            ';
     config_file = 'CONFIG.DAT';
     ports_str: array[0..3] of string = ('220h','240h','260h','280h');
     ports: array[0..3] of word = ($220,$240,$260,$280);
     irqs_str: array[0..2] of string = ('2','5','7');
     irqs: array[0..2] of byte = (2,5,7);
     dmas_str: array[0..2] of string = ('0','1','3');
     dmas: array[0..2] of byte = (0,1,3);

type
     config_typ = record
                     SB_Active: boolean;
                     SB_Port: Word;
                     SB_Irq, SB_Dma: Byte;
                     Volume: byte;
                     shadows_on, trans_on, smoke_on: boolean;
     end;

var
  CFG: config_typ;
  F: file of config_typ;
  PRINTSTATUS: STRING;
  OldX,OldY: BYTE;

Procedure CursorOnOff(OnOff: Boolean); Assembler;
Asm
     XOR Ax,Ax                                            {Ax auf 0.}
     MOV Al,OnOff                      {Cursor an- oder ausschalten?}
     Or  Al,Al
     JA  @1                                   {Wenn on dann nach @1.}
     SUB Ax,Ax                                            {Ax auf 0.}
     MOV Ah,01h                                       {Funktion 01h.}
     MOV Ch,20h                              {Ch auf gleichen Wert..}
     MOV Cl,20h                                           {..wie Cl.}
     INT 10h                                    {Bios-Interrupt 10h.}
     JMP @3                                      {ans Ende springen.}
@1:                                     {Routine Cursor einschalten.}
     Xor Ax,Ax                                            {Ax auf 0.}
     Mov Ah,0Fh                                       {Funktion 0Fh.}
     Int 10h                                    {Bios-Interrupt 10h.}
     Cmp Ah,7                                    {Wenn Ergebnis = 7.}
     JE  @2                          {Dann liegt Farbbildschirm vor.}
     XOR Al,Al                                            {Al auf 0.}
     MOV AH,01h                                       {Funktion 01h.}
     MOV CX,0607h                            {Cursorgre festlegen.}
     INT 10h                                    {Bios-Interrupt 10h.}
     JMP @3                                      {ans Ende springen.}
@2:                                 {Routine fr den Farbbildschirm.}
     SUB Al,Al                                            {Al auf 0.}
     MOV Ah,01h                                       {Funktion 01h.}
     MOV CX,0C0Dh                            {Cursorgre festlegen.}
     INT 10h                                    {Bios-Interrupt 10h.}
@3:
end;

Procedure INITDesktop;
Begin
     OldX:=WhereX;
     OldY:=WhereY;
     PUSHSCREEN(1);
     CLEARBUF(0);
     SETCOLORS(BLUE,WHITE);
     FILLBUF(0,'');
     setcolors(white,lightgray);
     drawbox(0,2,1,78,4,' Hinweis: ',true);
     putstring(0,4,2,'Wenn der Rechner "abschmiert", andere Einstellungen versuchen, oder');
     putstring(0,4,3,'"Keine Sounkarte" einstellen. Irgendwann klappt es schon!');
     SETCOLORS(YELLOW,BLUE);
     FILLCHAR(PRINTSTATUS,255,' ');
     INSERT(STATUSBAR_Str,PRINTSTATUS,1);
     PUTSTRING(0,1,25,PRINTSTATUS);
     SETCOLORS(WHITE,LIGHTGRAY);
     POPSCREEN(0);
     GOTOXY(80,25);
     CURSORONOFF(FALSE);
End;

Procedure Ende;
Begin
     CursorOnOff(True);
     popscreen(1);
     setcolors(lightgray,black);
     gotoxy(oldx,oldy);
     writeln('SOUNDSET '+ver_str+' (c) by Jan Strter 1996.');
     halt;
End;

procedure open_config_file;
begin
     assign(f,config_file);
     {$I-} reset(f); {$I+}
     if ioresult <> 0 then begin
        cfg.sb_port:=$220;
        cfg.sb_irq:=5;
        cfg.sb_dma:=1;
        cfg.SB_active:=FALSE;
        cfg.shadows_on:=true;
        cfg.trans_on:=true;
        cfg.smoke_on:=true;
        cfg.volume:=1;
        {$I-} rewrite(f); {$I+}
        write(f,cfg);
     end;
     {$I-}
     seek(f,0);
     read(f,cfg);
     {$I+}
end;

procedure write_config_file;
begin
     {$I-}
     seek(f,0);
     write(f,cfg);
     close(f);
     {$I+}
end;

procedure select_soundkarte;
var
   choose: integer;
begin
     liste.element[1]:='SoundBlaster + kompatible';
     liste.element[2]:='Keine';
     choose:=listbox(0,centered,centered,30,liste,2,' Sounkarte: ');
     if choose = -1 then ende;
     if choose = 1 then cfg.sb_active:=true else cfg.sb_active:=false;
end;

procedure select_portbase;
var a: byte;
choose: integer;
begin
     for a:=1 to 4 do begin
         liste.element[a]:=ports_str[a-1];
     end;
     choose:=listbox(0,centered,centered,30,liste,4,' Port-Adresse: ');
     if choose = -1 then ende;
     cfg.sb_port:=ports[choose-1];
end;

procedure select_irq;
var a:byte;
choose: integer;
begin
     for a:=1 to 3 do begin
         liste.element[a]:=irqs_str[a-1];
     end;
     choose:=listbox(0,centered,centered,20,liste,3,' IRQ-Kanal: ');
     if choose = -1 then ende;
     cfg.sb_irq:=irqs[choose-1];
end;

procedure select_dma;
var a: byte;
choose: integer;
begin
     for a:=1 to 3 do begin
         liste.element[a]:=dmas_str[a-1];
     end;
     choose:=listbox(0,centered,centered,20,liste,3,' DMA-Kanal: ');
     if choose = -1 then ende;
     cfg.sb_dma:=dmas[choose-1];
end;

begin
     open_config_file;
     initdesktop;
     select_soundkarte;
     if cfg.sb_active = true then begin
        select_portbase;
        select_irq;
        select_dma;
     end;
     write_config_file;
     ende;
end.