{$F-}{$G+}{$R-}{$A-}{$Q-}{$S-}{$B-}{$I-}
unit sprite;

{*************************************************************************}
{  Autor: Jan Strter                                                     }
{  Zweck: Unit zur Realisierung von Spritegrafik im Modus 13h             }
{  Version: 4.6                                                           }
{*************************************************************************}
{                                                                         }
{ Da die Unit mittlerweile zu lang geworden ist, um die Funktionen kurz   }
{ zu erlutern, verzichte ich an dieser Stelle darauf und verweise auf    }
{ die Kommentare innerhalb des Programmtextes.                            }
{ Der hier vorliegende Code ist mir von als FreeWare deklariert worden,   }
{ darf also nach Belieben kopiert, zerhackstckt, verwendet und weiter -  }
{ gegeben werden, solange er nicht in kommerziellen Programmen verwendet  }
{ wird.                                                                   }
{ Ich weise darauf hin, da ich in keinster Weise die Verantwortung dafr }
{ bernehme, da die Unit einwandfrei funktioniert, und keine Daten durch }
{ ihre Benutzung verloren gehen.                                          }
{                                                                         }
{ FEATURES:                                                               }
{                                                                         }
{ Untersttzung vom 256-Farbengrafikmodus der VGA-Karte,                  }
{ beliebig viele Sprites, beliebige Positionierung, Sprites drfen sich   }
{ berlagern und schneiden, werden exakt (d.h. Farbe 0 ist durchsichtig,  }
{ Rnder werden geclippt) gezeichnet, Linienalgorythmen, Sprites knnen   }
{ skaliert (vergrert/verkleinert) gezeichnet werden, arbeitet mit       }
{ Frame-Buffering, d.h. man sieht den Bildschirmaufbau nicht, kann        }
{ GIF und PCX-Dateien laden, (auerdem noch ein eigenes Format), Routinen }
{ fr Diverse Paletten-Effekte (Ausblenden, rotieren...),                 }
{ Funktionen fr verschiedene Zeichenstzen, Routinen zum Feststellen, ob }
{ sich zwei Sprites schneiden, Schatten, Transparenzeffekte, u.s.w.,      }
{ u.s.w...                                                                }

{=========================================================================}
INTERFACE
{=========================================================================}

const
   RED = 0;
   GREEN = 1;
   BLUE = 2;
      FontMask: array[0..14] of word =
       ($4000,$2000,$1000,$800,$400,$200,$100,$80,$40,$20,$10,8,4,2,1);
      internalFont:array[0..255,0..5] of byte=
     ((  0,  0,  0,  0,  0,  0), {#0}
      (  0, 54,  0, 62, 28,  0), {#1}
      ( 62, 42, 62, 34, 54, 62), {#2}
      (  0, 20, 62, 62, 28,  8), {#3}
      (  0,  8, 28, 62, 28,  8), {#4}
      (  8, 28, 54, 62,  8, 28), {#5}
      (  8, 28, 62, 62,  8, 28), {#6}
      (  0,  8, 54, 54,  8,  0), {#7}
      ( 62, 54, 42, 42, 54, 62), {#8}
      (  0, 28, 50, 38, 28,  0), {#9}
      ( 62, 34, 42, 42, 34, 62), {#10}
      ( 14,  6,  8, 28, 34, 28), {#11}
      ( 28, 34, 28,  8, 62,  8), {#12}
      ( 14, 10,  8,  8, 56, 56), {#13}
      (  0, 30, 18, 30, 18, 54), {#14}
      (  0,  8, 42, 20, 42,  8), {#15}
      (  0, 32, 56, 62, 56, 32), {#16}
      (  0,  2, 14, 62, 14,  2), {#17}
      (  8, 28, 42, 42, 28,  8), {#18}
      (  0, 54, 54, 54,  0, 54), {#19}
      (  0, 30, 42, 26, 10, 10), {#20}
      (  6,  8,  4, 10, 36, 24), {#21}
      (  0,  0,  0,  0, 62, 62), {#22}
      (  8, 28,  8, 28,  8, 62), {#23}
      (  0,  8, 28, 62,  8,  8), {#24}
      (  0,  8,  8, 62, 28,  8), {#25}
      (  0,  8,  4, 62,  4,  8), {#26}
      (  0,  8, 16, 62, 16,  8), {#27}
      (  0,  0, 48, 62,  0,  0), {#28}
      (  0,  0, 20, 62, 20,  0), {#29}
      (  0,  0,  0,  8, 28, 62), {#30}
      (  0,  0, 62, 28,  8,  0), {#31}
      (  0,  0,  0,  0,  0,  0), { }
      (  0, 12, 12, 12,  0, 12), {!}
      (  0, 20, 20,  0,  0,  0), {"}
      (  0, 20, 62, 20, 62, 20), {#}
      (  8, 30, 40, 28, 10, 60), { $}
      (  0, 50,  4,  8, 16, 38), {%}
      (  0, 28, 54, 28, 38, 26), {&}
      (  0,  4,  8,  0,  0,  0), {'}
      (  0, 28, 48, 48, 48, 28), {(}
      (  0, 56, 12, 12, 12, 56), {)}
      (  0, 20,  8, 62,  8, 20), {*}
      (  0,  0,  8, 62,  8,  0), {+}
      (  0,  0,  0,  8,  8, 16), {,}
      (  0,  0,  0, 62,  0,  0), {-}
      (  0,  0,  0,  0, 12,  0), {.}
      (  1,  2,  4,  8, 16, 32), {/}
      (  0, 28, 38, 42, 50, 28), {0}
      (  0, 12, 28, 12, 12, 30), {1}
      (  0, 60,  6, 28, 48, 62), {2}
      (  0, 60,  6, 28,  6, 60), {3}
      (  0, 48, 52, 62, 12, 12), {4}
      (  0, 62, 48, 60,  6, 60), {5}
      (  0, 62, 32, 62, 34, 62), {6}
      (  0, 62,  6, 12, 24, 24), {7}
      (  0, 28, 54, 28, 54, 28), {8}
      (  0, 28, 34, 30,  2, 28), {9}
      (  0,  0,  8,  0,  8,  0), {:}
      (  0,  0,  8,  0,  8, 16), {;}
      (  0,  6, 12, 24, 12,  6), {<}
      (  0,  0, 62,  0, 62,  0), {=}
      (  0, 24, 12,  6, 12, 24), {>}
      ( 28, 34,  4,  8,  0,  8), {?}
      (  0, 28, 34, 46, 32, 30), {@}
      (  0, 28, 50, 62, 50, 50), {A}
      (  0, 60, 50, 60, 50, 60), {B}
      (  0, 30, 48, 48, 48, 30), {C}
      (  0, 60, 54, 50, 54, 60), {D}
      (  0, 62, 48, 60, 48, 62), {E}
      (  0, 62, 48, 60, 48, 48), {F}
      (  0, 30, 48, 54, 50, 30), {G}
      (  0, 50, 50, 62, 50, 50), {H}
      (  0, 30, 12, 12, 12, 30), {I}
      (  0, 62,  2,  2, 50, 28), {J}
      (  0, 50, 52, 56, 52, 50), {K}
      (  0, 48, 48, 48, 48, 62), {L}
      (  0, 34, 54, 42, 34, 34), {M}
      (  0, 34, 50, 42, 38, 34), {N}
      (  0, 28, 50, 50, 50, 28), {O}
      (  0, 60, 50, 60, 48, 48), {P}
      (  0, 24, 52, 52, 52, 26), {Q}
      (  0, 60, 34, 60, 52, 50), {R}
      (  0, 62, 48, 62,  6, 62), {S}
      (  0, 62, 24, 24, 24, 24), {T}
      (  0, 50, 50, 50, 50, 62), {U}
      (  0, 50, 50, 50, 50, 12), {V}
      (  0, 34, 34, 42, 62, 20), {W}
      (  0, 34, 54, 28, 54, 34), {X}
      (  0, 50, 50, 28, 12, 12), {Y}
      (  0, 62,  6, 28, 48, 62), {Z}
      (  0, 30, 24, 24, 24, 30), {[}
      ( 32, 16,  8,  4,  2,  1), {\}
      (  0, 30,  6,  6,  6, 30), {]}
      (  8, 20, 34,  0,  0,  0), {^}
      (  0,  0,  0,  0,  0, 62), {_}
      ( 16,  8,  0,  0,  0,  0), {`}
      (  0,  0, 28, 50, 50, 30), {a}
      (  0, 32, 60, 34, 34, 60), {b}
      (  0,  0, 30, 48, 48, 30), {c}
      (  0,  2, 30, 34, 34, 30), {d}
      (  0,  0, 28, 62, 32, 28), {e}
      (  0,  6,  8, 30,  8,  8), {f}
      (  0, 28, 34, 30,  2, 28), {g}
      (  0, 48, 60, 50, 50, 50), {h}
      ( 12,  0, 12, 12, 12, 12), {i}
      (  6,  0,  6,  6, 54, 28), {j}
      (  0, 48, 52, 56, 54, 54), {k}
      (  0, 24, 24, 24, 24, 14), {l}
      (  0,  0, 52, 62, 42, 34), {m}
      (  0,  0, 60, 50, 50, 50), {n}
      (  0,  0, 28, 50, 50, 28), {o}
      (  0,  0, 60, 50, 60, 48), {p}
      (  0,  0, 28, 38, 30,  6), {q}
      (  0,  0, 44, 26, 24, 24), {r}
      (  0, 14, 16, 12, 34, 28), {s}
      (  0, 24, 62, 24, 26, 12), {t}
      (  0,  0, 50, 50, 50, 30), {u}
      (  0,  0, 50, 50, 50, 28), {v}
      (  0,  0, 34, 42, 42, 28), {w}
      (  0,  0, 54, 24, 12, 54), {x}
      (  0,  0, 50, 62,  2, 28), {y}
      (  0,  0, 60, 12, 48, 62), {z}
      (  0, 14, 24, 48, 24, 14),(*{*)
      (  0,  4,  4,  0,  4,  4), {|}
      (  0, 56, 12,  6, 12, 56),(*}*)
      (  0, 26, 36,  0,  0,  0), {~}
      (  0,  8, 20, 34, 62,  0), {#127}
      ( 28, 50, 32, 50, 28, 48), {#128}
      (  0, 50,  0, 50, 50, 30), {#129}
      (  6,  8, 28, 62, 32, 28), {#130}
      (  4, 10,  0, 30, 49, 31), {#131}
      ( 26,  0, 28, 50, 50, 30), {#132}
      ( 12,  2, 28, 34, 34, 30), {#133}
      (  4, 10,  4, 28, 50, 30), {#134}
      (  0, 30, 48, 30,  4, 24), {#135}
      ( 28,  0, 28, 62, 48, 28), {#136}
      ( 20,  0, 28, 62, 32, 28), {#137}
      ( 12,  2, 28, 62, 48, 28), {#138}
      ( 26,  0, 12, 12, 12, 12), {#139}
      ( 12, 18,  0, 12, 12, 12), {#140}
      ( 24,  4,  0, 12, 12, 12), {#141}
      ( 50,  0, 28, 50, 62, 50), {#142}
      ( 12,  0, 28, 50, 62, 50), {#143}
      ( 28, 62, 48, 60, 48, 62), {#144}
      (  0, 52, 10, 28, 40, 22), {#145}
      (  0, 14, 20, 62, 36, 38), {#146}
      (  8, 20,  0, 28, 50, 28), {#147}
      ( 20,  0, 28, 50, 50, 28), {#148}
      ( 24,  4,  0, 28, 50, 28), {#149}
      (  8, 20,  0, 50, 50, 30), {#150}
      ( 24,  4,  0, 50, 50, 30), {#151}
      ( 20,  0, 50, 62,  2, 28), {#152}
      ( 20,  0, 28, 50, 50, 28), {#153}
      ( 50,  0, 50, 50, 50, 62), {#154}
      (  4, 30, 32, 32, 30,  4), {#155}
      ( 12, 18, 56, 16, 34, 62), {#156}
      ( 54,  8, 62,  8, 62,  8), {#157}
      ( 48, 40, 52, 46, 36, 38), {#158}
      ( 12, 10, 24, 12, 40, 24), {#159}
      ( 12, 16,  0, 28, 34, 30), {#160}
      ( 12, 16,  0,  8,  8,  8), {#161}
      ( 12, 16,  0, 28, 50, 28), {#162}
      ( 12, 16,  0, 50, 50, 30), {#163}
      ( 26, 36,  0, 44, 18, 18), {#164}
      ( 26, 36,  0, 50, 42, 38), {#165}
      ( 28, 36, 26,  0, 62,  0), {#166}
      ( 28, 34, 28,  0, 62,  0), {#167}
      (  8,  0,  8, 16, 34, 28), {#168}
      (  0,  0, 63, 48,  0,  0), {#169}
      (  0,  0, 63,  3,  0,  0), {#170}
      ( 18, 20,  8, 16, 42, 10), {#171}
      ( 18, 20,  8, 20, 38,  2), {#172}
      ( 12,  0, 12, 12, 12,  0), {#173}
      ( 10, 20, 40, 20, 10,  0), {#174}
      ( 40, 20, 10, 20, 40,  0), {#175}
      ( 21, 42, 21, 42, 21, 42), {#176}
      ( 63, 63, 63, 63, 63, 63), {#177}
      ( 42, 21, 42, 21, 42, 21), {#178}
      (  4,  4,  4,  4,  4,  4), {#179}
      (  4,  4,  4, 60,  4,  4), {#180}
      (  4,  4, 60,  4, 60,  4), {#181}
      ( 10, 10, 10, 58, 10, 10), {#182}
      (  0,  0,  0, 62, 10, 10), {#183}
      (  0,  0, 60,  4, 60,  4), {#184}
      ( 10, 10, 58,  2, 58, 10), {#185}
      ( 10, 10, 10, 10, 10, 10), {#186}
      (  0,  0, 62,  2, 58, 10), {#187}
      ( 10, 10, 58,  2, 62,  0), {#188}
      ( 10, 10, 10, 62,  0,  0), {#189}
      (  4,  4, 60,  4, 60,  0), {#190}
      (  0,  0,  0, 60,  4,  4), {#191}
      (  4,  4,  4,  7,  0,  0), {#192}
      (  4,  4,  4, 63,  0,  0), {#193}
      (  0,  0,  0, 63,  4,  4), {#194}
      (  4,  4,  4,  7,  4,  4), {#195}
      (  0,  0,  0, 63,  0,  0), {#196}
      (  4,  4,  4, 63,  4,  4), {#197}
      (  4,  4,  7,  4,  7,  4), {#198}
      ( 10, 10, 10, 11, 10, 10), {#199}
      ( 10, 10, 11,  8, 15,  0), {#200}
      (  0,  0, 15,  8, 11, 10), {#201}
      ( 10, 10, 59,  0, 63,  0), {#202}
      (  0,  0, 63,  0, 59, 10), {#203}
      ( 10, 10, 11,  8, 11, 10), {#204}
      (  0,  0, 63,  0, 63,  0), {#205}
      ( 10, 10, 59,  0, 59, 10), {#206}
      (  4,  4, 63,  0, 63,  0), {#207}
      ( 10, 10, 10, 63,  0,  0), {#208}
      (  0,  0, 63,  0, 63,  4), {#209}
      (  0,  0,  0, 63, 10, 10), {#210}
      ( 10, 10, 10, 15,  0,  0), {#211}
      (  4,  4,  7,  4,  7,  0), {#212}
      (  0,  0,  7,  4,  7,  4), {#213}
      (  0,  0,  0, 15, 10, 10), {#214}
      ( 10, 10, 10, 63, 10, 10), {#215}
      (  4,  4, 63,  4, 63,  4), {#216}
      (  4,  4,  4, 60,  0,  0), {#217}
      (  0,  0,  7,  4,  4,  4), {#218}
      ( 63, 63, 63, 63, 63, 63), {#219}
      (  0,  0,  0, 63, 63, 63), {#220}
      ( 48, 48, 48, 48, 48, 48), {#221}
      (  3,  3,  3,  3,  3,  3), {#222}
      ( 63, 63, 63,  0,  0,  0), {#223}
      (  0,  0, 26, 36, 36, 26), {#224}
      (  0, 28, 38, 44, 34, 44), {#225}
      (  0, 62, 34, 32, 32, 32), {#226}
      (  0,  0, 62, 20, 20, 20), {#227}
      ( 62, 18,  8, 16, 34, 62), {#228}
      (  0,  0, 30, 36, 36, 24), {#229}
      (  0, 18, 18, 30, 16, 48), {#230}
      (  0,  0, 26, 44,  8,  8), {#231}
      (  0, 62,  8, 20,  8, 62), {#232}
      (  0, 28, 34, 62, 34, 28), {#233}
      (  0, 28, 34, 34, 20, 54), {#234}
      ( 14, 16,  8, 28, 34, 28), {#235}
      (  0,  0, 20, 42, 20,  0), {#236}
      (  0,  2, 20, 42, 20, 32), {#237}
      (  0, 30, 32, 62, 32, 30), {#238}
      (  0,  0, 28, 34, 34, 34), {#239}
      (  0, 62,  0, 62,  0, 62), {#240}
      (  0,  8, 28,  8,  0, 62), {#241}
      ( 16,  8,  4,  8, 16, 62), {#242}
      (  4,  8, 16,  8,  4, 62), {#243}
      (  4, 10,  8,  8,  8,  8), {#244}
      (  8,  8,  8,  8, 40, 16), {#245}
      (  0,  8,  0, 62,  0,  8), {#246}
      ( 26, 36,  0, 26, 36,  0), {#247}
      ( 24, 36, 24,  0,  0,  0), {#248}
      (  0,  0,  0, 12,  0,  0), {#249}
      (  0,  0,  0,  4,  0,  0), {#250}
      ( 15,  8,  8, 40, 24,  8), {#251}
      ( 44, 18, 18,  0,  0,  0), {#252}
      ( 56,  4, 24, 32, 60,  0), {#253}
      (  0,  0, 28, 28,  0,  0), {#254}
      (  0,  0,  0,  0,  0,  0));{#255}

Type

   pcx_header = record
        Manufacturer: byte;     { Always 10 for PCX file }

        Version: byte;          { 2 - old PCX - no palette (not used anymore),
                                  3 - no palette,
                                  4 - Microsoft Windows - no palette (only in
                                      old files, new Windows version uses 3),
                                  5 - with palette }

        Encoding: byte;         { 1 is PCX, it is possible that we may add
                                  additional encoding methods in the future }

        Bits_per_pixel: byte;   { Number of bits to represent a pixel
                                  (per plane) - 1, 2, 4, or 8 }

        Xmin: integer;          { Image window dimensions (inclusive) }
        Ymin: integer;          { Xmin, Ymin are usually zero (not always) }
        Xmax: integer;
        Ymax: integer;

        Hdpi: integer;          { Resolution of image (dots per inch) }
        Vdpi: integer;          { Set to scanner resolution - 300 is default }

        ColorMap: array [0..15, RED..BLUE] of byte;
                                { RGB palette data (16 colors or less)
                                  256 color palette is appended to end of file }

        Reserved: byte;         { (used to contain video mode)
                                  now it is ignored - just set to zero }

        Nplanes: byte;          { Number of planes }

        Bytes_per_line_per_plane: integer;   { Number of bytes to allocate
                                               for a scanline plane.
                                               MUST be an an EVEN number!
                                               Do NOT calculate from Xmax-Xmin! }

        PaletteInfo: integer;   { 1 = black & white or color image,
                                  2 = grayscale image - ignored in PB4, PB4+
                                  palette must also be set to shades of gray! }

        HscreenSize: integer;   { added for PC Paintbrush IV Plus ver 1.0,  }
        VscreenSize: integer;   { PC Paintbrush IV ver 1.02 (and later)     }
                                { I know it is tempting to use these fields
                                  to determine what video mode should be used
                                  to display the image - but it is NOT
                                  recommended since the fields will probably
                                  just contain garbage. It is better to have
                                  the user install for the graphics mode he
                                  wants to use... }

        Filler: array [74..127] of byte;     { Just set to zeros }
        end;

{ Dieser Record ist aus dem original Beispiel-Programm von ZSoft
  (der Firma, die PCX entwickelt hat) entnommen und dementsprechend
  auf Englisch. }

    bjf_header = record
               Formatkennung: string[3]; { Kennung vom BJF-Format }
               width: word;              { Breite des Sprites }
               height: word;             { Hhe des Sprites }
               Packing: boolean;         { Gepackt? (RLE) }
               Pal: boolean;             { Palette mit drin? }
    end;

    SpriteTyp=Record
              Adr:Pointer;              { Zeiger auf Sprite-Daten **}
              dtx,dty:Word;             { Breite und Hhe **}
{              px,py,}                    { Position (x/y) *}
{              sx,sy:Integer;}            { Unbenutzt *}

    { * optional, wird von der Unit selbst nicht benutzt
      ** darf nur von der Unit selbst verndert werden, sonst gibt's
      vermutlich Komplikationen! }

    End;

    font_header = record
             kennung: string[4];        { Kennung }
             width, height: byte;       { Hhe und Breite des Fonts }
    end;

    FontType = Record
             Adr:Pointer;               { Adresse auf Font-Daten }
             Width,Height: Byte;        { Hhe und Breite }
    end;

{ **** ffentliche Konstanten und Variablen **** }

const
      akt_pfad: string = '';            { Alle Datei-Rountinen benutzen das hier }
      MaxFont = 15;                     { Max.Anzahl von Zeichenstzen, beliebig }
      FontInternal = 255;               { Unter dieser Nummer wird der eingebaute Font benutzt }
      akt_font: byte = FontInternal;    { Aktueller Zeichensatz }
      NoError = 0;                      { Fehlercodes }
      OutOfMemError = 1;                { Kein Speicher mehr da }
      IOError = 2;                      { Datei-Fehler }
      WrongFormatError = 3;             { Falsches Format }
      Error: byte = NoError;            { Standardmig kein Fehler }

var
    palette:Array[0..767] of Byte;      { Enthlt Farbpalette }
    shadowpal: array[0..255] of byte;   { Enthlt Schattenwerte }
    VScreen:Pointer;                    { Zeiger auf Bildaten -> Loadgif, LOAD_SPRITE }
{    _virtualvseg: word;}                 { Zeiger auf Bildschirmpuffer, fr Assemblerteil }
    vbuf: pointer;                      { Zeiger auf Bildschirmpuffer (64 KB) }
    Font: array[0..MaxFont] of FontType;{ Zeigerstruktur auf Fonts }
    Transpal: pointer;                  { Zeiger auf Transparenz-Tabelle }

{ **** ffentliche Prozeduren und Funktionen **** }

procedure init_mode13h;
          { Initialisiert den 256-Farben-Grafikmodus und allokiert Speicher }
procedure leave_mode13h;
          { Gibt Speicher frei und schaltet Textmodus ein }
procedure clearVbuf(col: byte);
          {Lscht den Bildschirmpuffer }
procedure showVBuf;
          {Zeigt den Inhalt des Bildschirmpuffers auf dem Monitor an }
procedure putpixel(x,y: integer; col: byte);
          { Setzt einen Punkt an x/y mit der Farbe col }
procedure putpixel_save(x,y: integer; col: byte);
          { wie PUTPIXEL, aber Bereichsprfung (langsamer & sicherer) }
procedure putpixel_sprite(x,y:word; col:byte; qsprite:spritetyp);
          { Setzt einen Punkt im Sprite QSprite an x/y mit der Farbe col }
function getpixel_screen(x,y:word): byte;
          { Liest Pixel direkt aus dem Bildschirmspeicher }
function getpixel_vbuf(x,y:word): byte;
          { Liest Pixel aus Bildschirmpuffer }
function getpixel_sprite(x,y:word; qsprite:spritetyp): byte;
          { Liest Pixel aus Sprite-Daten }
procedure line(x1, y1, x2, y2: INTEGER; Col: Byte);
          { Zeichnet eine Linie mit der Farbe col }
procedure circle(x, y, r: INTEGER; Col:Byte);
          { Zeichnet einen Kreis }
procedure ellipse(x, y, rx, ry: INTEGER; Col:Byte);
          { Zeichnet eine Ellipse }
procedure rectangle(x1, y1, x2, y2: integer; Col:Byte);
          { Zeichnet ein Rechteck }
procedure filledrectangle(x1,y1,x2,y2: integer; col: byte);
          { Zeichnet ein geflltes Rechteck }
procedure shadowrectangle(x1,y1,x2,y2: integer);
          { Zeichnet ein Rechteck als Schatten. }
procedure transrectangle(x1,y1,x2,y2: integer; col: byte);
          { Zeichnet ein Rechteck transparent. }
procedure getsprite(x,y, width, height:integer; var zsprite: spritetyp);
          { Liest ein Sprite aus VSCREEN }
procedure make_empty_sprite(width,height: word; var zsprite: spritetyp);
          { Erstellt LEERES Sprite (kann man vielleicht mal brauchen...) }
procedure freesprite(var zsprite: spritetyp);
          { Gibt den Speicher eines Sprites wieder frei }
function  putsprite_exact(x,y: integer; var zsprite: spritetyp): boolean;
          { Zeichnet ein Sprite korrekt abgeschnitten und durchscheinend }
procedure putsprite_shadow(x,y: integer; var zsprite: spritetyp);
          { Zeichnet das Sprite als Schatten. (Erst MAKESHADOWPAL aufrufen!)}
procedure putsprite_trans(x,y: integer; var zsprite: spritetyp);
          { Zeichnet Sprite transparent. (Erste LOADTRANSPAL oder MAKETRANSPAL aufrufen!) }
procedure putsprite_medium(x,y: integer; qsprite: spritetyp);
          { Zeichnet Sprites korrekt geclippt. (Nicht durchsichtig }
procedure putsprite_fast(x,y: integer; var zsprite: spritetyp);
          { Zeichnet ein Sprite ohne Clipping und nicht durchscheinend (schneller)}
procedure putbackground(zsprite:spritetyp);
          { Zeichnet nur Sprites, die 320*200 Punkte gro sein (sehr schnell) }
procedure putsprite_scal(x,y,scale_x,scale_y: integer; zsprite: spritetyp);
          { Zeichnet Sprite skaliert (korrekt, wie putsprite_exact, ziemlich lahm) }
procedure putsprite_scal_fast(x,y,scale_x,scale_y: integer; zsprite: spritetyp);
          { wie PUTSPRITE_SCAL, nur keine Bereichsprfung => schneller }
procedure LoadGif(name:String);
          { Ldt eine GIF-Datei in VSCREEN -> getsprite }
procedure setpal;
          { Schreibt 'PALETTE' an den DAC }
procedure getpal;
          { Liest aktuelle Farbpalette in 'PALETTE' }
procedure setcolor(col,r,g,b:byte);
          { Verndert Farbe COL in Farbpalette und setzte neue Werte RGB. }
procedure getcolor(col:byte; var R,G,B:byte);
          { Liest RGB-Wert von Farbe COL }
function findcol(r1,g1,b1: byte): byte;
          { Sucht eine Farbe mit dem passenden RGB-Wert aus der Palette }
procedure makeshadowpal;
          { Erstellt ein Array, in dem die Schattenwerte eingetragen werden.
            (Jetzt wei jeder, worum es geht...) }
procedure maketranspal;
          { Erstellt fr die aktuelle Palette eine Transparenz-Palette,
            diese ist 64 KByte gro und ein P-75 bentigt eine halbe Minute,
            um sie zu berechnen, man sollte also die Palette berechnen und
            dann in eine Datei sichern, anstatt sie immer neu auszurechen... }
procedure loadtranspal(filename: string);
          { Ldt die Transparenz-Palette (64 KB) aus Datei FILENAME ein. }
procedure savetranspal(filename: string);
          { Sichert die Transparenz-Palette in FILENAME. }
procedure freetranspal;
          { Gibt die 64 KByte der Transparenz-Tabelle wieder frei. }
procedure Pal_Rot(Start,Ende:Word);
          { Rotiert Palette im Bereich Start-Ende um 1 }
procedure waitretrace;
          { Wartet auf den Vertical-Retrace }
procedure fade_out;
          { Zieht Farbpalette auf schwarz (ausblenden) }
procedure screen_off;
          { Schaltet den Monitor 'aus' (auf schwarz) }
procedure screen_on;
          { Schaltet den Monitor wieder ein }
procedure save_sprite(filename: string; qsprite: spritetyp; pack_onoff,pal: boolean);
          { Speichert Sprite auf Platte, die Palette kann mitgesichert   }
          { werden, und die Bildaten knnen mit RLE-Verfahren gepackt    }
          { werden. SAVE_SPRITE verndert keine Bereiche innerhalb des   }
          { Speichers. Die gesicherten Bilder knnen nur von             }
          { LOAD_SPRITE wieder geladen werden, da es sich um ein eigenes }
          { Grafikformat handelt. (*.BJF - Benjamin-Jan-Format...)       }
procedure load_sprite(filename: string; var zsprite: spritetyp; anf: longint);
          { Ldt Sprite von Platte (eigenes *.BJF-Format, PCX-hnlich)   }
          { ACHTUNG: diese Prozedur VERNDERT VSCREEN, danach mu eine   }
          { eventuelle *.GIF-Datei neu geladen werden, sollten aus ihr   }
          { noch Sprite-Daten entnommen werden.                          }
          { Palette wird NICHT selbststndig verndert, soll die         }
          { Palette mitgeladen werden, mu nach Aufruf von LOAD_SPRITE   }
          { noch SETPAL aufgerufen werden.                               }
          { ANF (der letzte Parameter) ist normalerweise 0, nur wenn     }
          { mehrere Bilder in einer Datei gespeichert sind, mu ANF      }
          { den Offset des gewnschten Bildes in der Datei angeben.      }
procedure load_pcx_sprite(filename: string; var zsprite: spritetyp);
          { Ldt *.PCX-Datei direkt ins Sprite ZSPRITE, verndert          }
          { ebenfalls VSCREEN. (Die Datei darf nicht hrer als 64KB sein) }
function spriteoverlap_fast(x1,y1: integer; sprite1: spritetyp; x2,y2: integer; sprite2: spritetyp): boolean;
          { Gibt zurck, ob sich die Koordinaten zweier Sprites berlappen }
function spriteoverlap_exact(x1,y1: integer; sprite1: spritetyp; x2,y2: integer; sprite2: spritetyp): boolean;
          { Wie SPRITEOVERLAP_FAST, nur "korrekt" d.h. auf Pixelebene (langsamer!) }
procedure outtextxy(x,y: integer; text: string; farbe: byte);
          { Gibt Text an X/Y aus, benutzt aktuellen Zeichensatz }
function textheight(text: string): word;
          { Gibt Texthhe zurck. }
function textwidth(text: string): word;
          { Gibt Textbreite zurck }
function load_font(filename: string): byte;
          { Ldt Font und gibt Nummer zurck, unter der man den Font }
          { spter ansprechen kann.                                  }
procedure freefont(nummer: byte);
          { Gibt Speicher von Font NUMMER wieder frei. }
procedure setfont(nummer: byte);
          { Stellt Font NUMMER fr nachfolgende Textoperationen ein. }
{=========================================================================}
IMPLEMENTATION
{=========================================================================}

{ **** Interne Konstanten und Variablen **** }

const clr=256;                          { Wird fr LOADGIF bentigt }
     _eof=257;                          { dito }
var
    ueber_x,ueber_y:word;               { Wird fr LOADGIF bentigt }
    Handle:Word;                        { dito, alle folgenden ebenso }
    Puf:Array[0..767] of Byte;
    PufInd:Word;
    Stack:Array[0..1280] of byte;
    ab_prfx,ab_tail:Array[0..4096] of word;
    Byt:Byte;
    free,breite,max,
    stackp,restbits,restbyte,sonderfall,
    code,old_code,readbyt,bits,bits2get:Word;
    lbyte:Word;
    mask:Word;
    zseg,zofs,
    GifName:String[255];

procedure showvbuf; external;
procedure clearvbuf(col: byte); external;
{$L VBUFFER.OBJ}

Procedure Screen_Off;
Begin
  Port[$3c4]:=1;                {Register 1 des TS (TS Mode) selektieren}
  Port[$3c5]:=Port[$3c5] or 32; {Bit 5 (Screen Off) setzen}
End;

Procedure Screen_On;
Begin
  Port[$3c4]:=1;                     {Register 1 des TS (TS Mode) selektieren}
  Port[$3c5]:=Port[$3c5] and not 32; {Bit 5 (Screen Off lschen}
End;

procedure Init_mode13h;
var
  P :Pointer;
begin
  Error:=NoError;
  if maxAvail < $FFFF+64000 then begin
     Error:=OutOfMemError;
     exit;
  end;
  Getmem(vbuf,64000);
  getmem(vscreen,$FFFF);
  asm
    mov ax,13h
    int 10h
  end;
end;

procedure leave_mode13h;
begin
     freemem(VBuf,64000);
     freemem(vscreen,$FFFF);
asm
   mov ax,03h
   int 10h
end;
end;

procedure setpal; assembler;
asm
  push si
  mov si,offset palette
  mov cx,256*3
  xor al,al
  mov dx,03c8h
  out dx,al
  inc dx

  rep outsb
  pop si
end;

procedure getpal; assembler;
asm
  push di
  mov di,offset palette
  mov cx,256*3
  xor al,al
  mov dx,03c7h
  out dx,al
  mov dx,3c9h

  rep insb
  pop di
end;

procedure setcolor;
begin
     palette[col*3]:=R;
     palette[col*3+1]:=G;
     palette[col*3+2]:=B;
     setpal;
end;

procedure getcolor;
begin
     getpal;
     R:=palette[col*3];
     G:=palette[col*3+1];
     B:=palette[col*3+2];
end;

procedure Pal_Rot(Start,Ende:Word); assembler;
asm
  mov ax,ds
  mov es,ax

  lea si,palette
  mov di,si

  mov ax,3
  mul start
  add si,ax
  mov ax,3
  mul ende
  add di,ax

  mov bx,[si]
  mov dl,[si+2]

  mov cx,di
  sub cx,si

  mov di,si
  add si,3

  cld
  or cx,cx
  jns @vorwaerts
  std
  neg cx
  sub si,4
  add di,2
  add cx,2
@vorwaerts:

  rep movsb
  mov [di],bx
  mov [di+2],dl

  cld
end;

Procedure GifOpen;assembler;
asm
	mov ax,03d00h
  lea dx,gifname + 1
  int 21h
  mov handle,ax
End;
Procedure GifRead(n:Word);assembler;
asm
	mov ax,03f00h
  mov bx,handle
  mov cx,n
  lea dx,puf
	int 21h
end;
Procedure GifSeekdelta(delta:Longint);assembler;
asm
	mov ax,04200h
  mov bx,handle
  mov cx,word ptr delta + 2
  mov dx,word ptr delta
  int 21h
End;
Procedure GifClose;Assembler;
asm
	mov ax,03e00h
  mov bx,handle
  int 21h
End;
Procedure ShiftPal;assembler;
asm
	push ds
  pop es
  mov si,offset Puf
  mov di,offset Palette
  mov cx,768
@l1:
	lodsb
  shr al,2
  stosb
  loop @l1
End;
Procedure FillPuf;
Begin
	GifRead(1);
  restbyte:=puf[0];
  GifRead(restbyte);
End;

Function GetPhysByte:Byte;assembler;
asm
	push bx
	cmp restbyte,0
  ja @restda
  pusha
  call fillpuf
  popa
	mov pufind,0
@restda:
  mov bx,PufInd
  mov al,byte ptr Puf[bx]
  inc pufind
  pop bx
End;

Function GetLogByte:Word;assembler;
asm
  push si
	mov ax,breite
	mov si,ax
  mov dx,restbits
  mov cx,8
  sub cx,dx
  mov ax,lByte
  shr ax,cl
  mov code,ax
  sub si,dx
@nextbyte:
  call getphysbyte
  xor ah,ah
  mov lByte,ax
  dec restbyte

  mov bx,1
  mov cx,si
  shl bx,cl
  dec bx
  and ax,bx

  mov cx,dx
  shl ax,cl
  add code,ax

  sbb dx,breite
  add dx,8
  jns @positiv
  add dx,8
@positiv:
  sub si,8
  jle @fertig       { <= 0 }
	add dx,breite
  sub dx,8
  jmp @nextbyte
@fertig:
	mov restbits,dx
  mov ax,code
	pop si
End;

Procedure LoadGif(name:String);
Var ziel,
    quelle,qseg:Word;
    x_count:Word;
    zielvarlok:Pointer;
    startadr:word;
    seek:longint;
    f: file;
Begin
  error:=NoError;
  if pos('.',name) = 0 then name:=name+'.GIF';
  assign(f,name);
  {$I-} reset(f,1); {$I+}
  if ioresult <> 0 then begin
     error:=IOerror;
     exit;
  end;
  close(f);
  startadr:=0;
  seek:=0;
  gifName:=Name+#0;
  Error:=NoError;
  GifOpen;
  gifseekdelta(seek+13);
  gifread(768);
  Shiftpal;
  gifread(1);
  While Puf[0] = $21 do Begin  {Erw - Block berlesen}
    gifread(2);
    gifread(puf[1]+1);
  End;
  GifRead(10);
  If Puf[8] and 128 = 128 Then Begin
    gifread(768);
  	Shiftpal;
  End;
  lByte:=0;
  Zielvarlok:=vscreen;
asm
    les di,zielvarlok

    mov free,258        {1. freie Posit in Alphabet}
    mov breite,9        {Zeichenbreite in bit}
    mov max,511         {maximaler darstellbarer Wert bei akt breite}
    mov stackp,0
    mov restbits,0
    mov restbyte,0
  @mainloop:
    call getlogByte
		cmp ax,_eof
    je @abbruch
    cmp ax,clr
    je @clear
  	mov readbyt,ax
    cmp ax,free
    jb @code_in_ab
    mov ax,old_code
    mov code,ax
    mov bx,stackp
    mov cx,sonderfall
    mov word ptr stack[bx],cx
    inc stackp
  @code_in_ab:
  	cmp ax,clr
  	jb @konkret
  @fillstack_loop:
    mov bx,code
    shl bx,1
    push bx
    mov ax,word ptr ab_tail[bx]
    mov bx,stackp
    shl bx,1
    mov word ptr stack[bx],ax
    inc stackp
    pop bx
    mov ax,word ptr ab_prfx[bx]
    mov code,ax
    cmp ax,clr
    ja @fillstack_loop
  @konkret:
  	mov bx,stackp
    shl bx,1
    mov word ptr stack[bx],ax
    mov sonderfall,ax
    inc stackp
    mov bx,stackp
    dec bx
    shl bx,1
  @readstack_loop:
  	mov ax,word ptr stack[bx]

		stosb
  	or di,di
    jne @noovl1
    push startadr
    push 16384
    add startadr,16384
    les di,zielvarlok

@noovl1:
    dec bx
    dec bx
    jns @readstack_loop
    mov stackp,0
    mov bx,free
    shl bx,1
    mov ax,old_code
    mov word ptr ab_prfx[bx],ax
    mov ax,code
    mov word ptr ab_tail[bx],ax
    mov ax,readbyt
    mov old_code,ax
    inc free
    mov ax,free
    cmp ax,max
    jbe @mainloop
    cmp byte ptr breite,12
    jae @mainloop
    inc breite
    mov cl,byte ptr breite
    mov ax,1
    shl ax,cl
    dec ax
    mov max,ax
    jmp @mainloop
  @clear:
    mov breite,9
    mov max,511
    mov free,258
    call getlogbyte
    mov sonderfall,ax
    mov old_code,ax

    stosb
    or di,di
    jne @noovl2
    push startadr
    push 16384
    add startadr,16384
    les di,zielvarlok

@noovl2:

  jmp @mainloop
  @abbruch:
  End;
  gifclose;
End;

procedure putpixel(x,y: integer; col: byte); assembler;
asm
   pusha
   push es
   lds di,vbuf
   mov ax,320
   mul y
   add ax,x
   add di,ax
   mov al,byte ptr col
   mov es:[di],al
   pop es
   popa
end;

procedure getsprite(x,y, width, height: integer; var zsprite: spritetyp);
var
   acty,endy:word;
   offs:word;
   ofs_vscreen,seg_vscreen:word;
   ofs_spr,seg_spr:word;
begin
     Error:=NoError;
     if width<1 then exit;
     if height<1 then exit;
     if y<0 then exit;
     if x<0 then exit;
     if x+width-1 > 319 then exit;
     if y+height-1 > 199 then exit;
     if maxAvail < height*width then begin
        Error:=OutOfMemError;
        exit;
     end;
     getmem(zsprite.adr,height*width);
     ofs_vscreen:=ofs(vscreen^);
     seg_vscreen:=seg(vscreen^);
     ofs_spr:=ofs(zsprite.adr^);
     seg_spr:=seg(zsprite.adr^);
     zsprite.dtx:=width;
     zsprite.dty:=height;
     acty:=y;
     endy:=y+height;
asm
   pusha
   push ds
   push es
   mov ds,seg_vscreen
   mov es,seg_spr
   mov di,ofs_spr
@anfang:
   mov ax,320
   mul acty
   add ax,x
   add ax,ofs_vscreen
   mov si,ax
   mov cx,width
   rep movsb
   inc acty
   mov ax,acty
   cmp ax,endy
   jne @anfang
   pop es
   pop ds
   popa
end;
end;

procedure make_empty_sprite(width,height: word; var zsprite: spritetyp);
var
   dummy: byte;
   a,b: word;
begin
     dummy:=0;
     if maxavail < width*height then begin
        error:=OutOfMemError;
        exit;
     end;
     zsprite.dtx:=width;
     zsprite.dty:=height;
     getmem(zsprite.adr,width*height-1);
     fillchar(zsprite.adr^,width*height-1,dummy);
     for a:=0 to width-1 do begin
         for b:=0 to height-1 do begin
             putpixel_sprite(a,b,0,zsprite);
         end;
     end;
end;

procedure putbackground(zsprite:spritetyp);
var
   ofs_spr: word;
   seg_spr: word;
begin
     seg_spr:=seg(zsprite.adr^);
     ofs_spr:=ofs(zsprite.adr^);
asm
   push es
   les di,vbuf
   push ds
   mov ds,seg_spr
   mov si,ofs_spr
   mov cx,16000
db 66h
   rep movsw
   pop ds
   pop es
end;
end;

procedure putsprite_fast;
var
   seg_spr,ofs_spr:word;
   words,bytes: word;
   restx,dty: word;
begin
     seg_spr:=seg(zsprite.adr^);
     ofs_spr:=ofs(zsprite.adr^);
     words:=zsprite.dtx div 4;          { Das ganze wird in 4 und 1 Byte }
     bytes:=zsprite.dtx mod 4;          { Blcke zerlegt, um mglichst oft }
     restx:=320-zsprite.dtx;            { MOVSD verwenden zu knnen, was }
     dty:=zsprite.dty;                  { 'ne Ecke schneller geht, als jedes }
asm                                     { Byte einzeln zu kopieren }
   push es
   les di,vbuf
   push ds
   mov ds,seg_spr
   mov ax,320
   mul y
   add ax,x
   add di,ax
   mov si,ofs_spr
   mov bx,dty
@anfang:
   mov cx,words
   db 66h
   rep movsw
   mov cx,bytes
   rep movsb
   dec bx
   je @ende
   add di,restx
   jmp @anfang
@ende:
   pop ds
   pop es
end;
end;

procedure putsprite_medium(x,y: integer; qsprite: spritetyp);
var
   c_r,c_l,c_u,c_d:word;        { Clipping an den Kanten }
   restx: word;
   anz_dwords: word;            { Anzahl von DWords, die kopiert werden }
   anz_bytes: word;             { Anzahl Bytes, die kopiert werden }
   dtx,dty: word;               { Breite und Hhe, abzglich des Clippings }
   restx_spr: word;
   startx,endx: word;           { Koordinaten am Bildschirm }
   starty,endy: word;
begin
     { Prfen, ob berhaupt sichtbar, wenn nicht, dann sofort raus }
     if (x>319) or (y>199) then exit;
     if (x+qsprite.dtx<=0) or (y+qsprite.dty<=0) then exit;
     { Clipping berechnen }
     c_r := 0; c_l := 0; c_u := 0; c_d := 0; { Voreinstellung: 0 }
     if x < 0 then begin
        c_l := -x;
        startx:=0;
     end else startx:=x;
     if y < 0 then begin
        c_u := -y;
        starty:=0;
     end else starty:=y;
     if x+qsprite.dtx > 320 then begin
        c_r := x+qsprite.dtx-320;
        endx:=320;
     end else endx:=x+qsprite.dtx;
     if y+qsprite.dty > 200 then begin
        c_d := y+qsprite.dty-200;
        endy := 200;
     end else endy:=y+qsprite.dty;
     { Aufspaltung der Daten in DWord- und Bytehppchen }
     dtx := qsprite.dtx-c_r-c_l;
     dty := qsprite.dty-c_u-c_d;
     anz_dwords := dtx div 4;
     anz_bytes := dtx mod 4;
     { Diese Werte mssen nach jeder Zeile dazuaddiert werden, um ein
       korrektes Bild zu erhalten }
     restx:=320-endx;
     restx_spr := c_r+c_l;
asm
   push ds                              { Register retten }
   push es
   pusha
   les di,dword ptr vbuf                { Adressen laden }
   lds si,dword ptr qsprite.adr
   mov ax,320                           { Offset am Bildschirm berechnen }
   mul starty
   add ax,startx
   add di,ax
   mov ax,word ptr qsprite.dtx          { Offset im Sprite berechnen }
   mul c_u
   add ax,c_l
   add si,ax
   mov bx,dty                           { Hhe nach BX laden }
@y_loop:
   mov cx,anz_dwords                    { Anzahl DWORDS nach CX }
   db 66h                               { Befehl auf 32 Bit erweitern }
   rep movsw                            { DWords kopieren }
   mov cx,anz_bytes                     { Anzahl Bytes nach CX }
   rep movsb                            { restliche Bytes kopieren }
   add si,restx_spr                     { 'Reste' dazuaddieren }
   add di,restx
   add di,startx
   dec bx                               { Zeilen-Zhler runter }
   ja @y_loop                           { Wenn nicht Ende, dann nochmal }
   popa
   pop es
   pop ds                               { Register wieder restaurieren }
end;
end;                                    { ...und tsch! }

function putsprite_exact;
var
   startx,starty,endx: word;
   clip_dn,clip_up,clip_lt,clip_rt: word;
   ofs_spr: word;
   seg_spr: word;
   width: word;
   restx: word;
   dtx,dty:word;
begin
     putsprite_exact:=false;
     if ((x>319) or (y>199)) or ((x+zsprite.dtx<=0) or (y+zsprite.dty<=0)) then exit;
     putsprite_exact:=true;
     width:=zsprite.dtx;
     asm                        { Von Hand ist es 'nen bichen schneller,}
        xor ax,ax               { weil TP vor jedem MOV noch ein berflssiges}
        mov clip_rt,ax          { XOR AX,AX einfgt. }
        mov clip_lt,ax
        mov clip_dn,ax
        mov clip_up,ax
     end;
     endx:=x+zsprite.dtx;
     if x<0 then
     begin
          startx:=0;
          clip_lt:=-x;
     end
     else begin
          startx:=x;
          if x+zsprite.dtx>320 then
          begin
               endx:=320;
               clip_rt:=(x+zsprite.dtx-320);
          end;
     end;
     if y<0 then
     begin
          starty:=0;
          clip_up:=-y;
     end
     else begin
          starty:=y;
          if y+zsprite.dty>200 then
          begin
               clip_dn:=(y+zsprite.dty-200);
          end;
     end;
     seg_spr:=seg(zsprite.adr^);
     ofs_spr:=ofs(zsprite.adr^);
     restx:=320-endx;
     dtx:=zsprite.dtx-clip_rt-clip_lt;
     dty:=zsprite.dty-clip_up-clip_dn;
asm
   pusha                                {Rettet mal wieder die Wale, h,}
   push es                              {die Register}
   les di,vbuf
   push ds
   cld                                  {Direction Flag lschen}
   mov ds,seg_spr                       {Sprite-Segment nach DS}
   mov ax,width                         {Offset in Sprite-Daten berechnen.}
   mul clip_up
   add ax,clip_lt
   add ax,ofs_spr
   mov si,ax                            {Und in SI laden}
   mov ax,320                           {Offset in VBUF berechnen}
   mul starty
   add ax,startx
   add di,ax                            {Und nach DI laden.}
   mov cx,dtx
   mov bx,dty
@anfang:
   lodsb                                {Byte holen}
   or al,al                             {Prfen, ob Null}
   je @null                             {Wenn ja, dann Sprung}
   mov es:[di],al                       {ansonsten: Pixel setzen}
@null:
   inc di                               {DI weiter, um Pixel zu berspringen}
   dec cx                               {CX erniedrigen}
   jne @anfang                          {wenn grer Null, nochmal}
   add si,clip_rt                       {Sonst Zeiger weitersetzen}
   add si,clip_lt
   add di,restx
   add di,startx
   mov cx,dtx
   dec bx                               {Y-Zhler runter und gucken, ob Ende}
   jne @anfang                          {Wenn nicht, dann nochmal (GHN!)}
   pop ds
   pop es
   popa                                 {Register restaurieren...}
end;
end;                                    {Bis zum nchsten Mal, tsch.}

procedure putsprite_shadow;
var
   startx,starty,endx: word;
   clip_dn,clip_up,clip_lt,clip_rt: word;
   ofs_spr: word;
   seg_spr: word;
   width: word;
   restx: word;
   dtx,dty:word;
   data_seg: word;
   shadow_ofs: word;
begin
     if ((x>319) or (y>199)) or ((x+zsprite.dtx<=0) or (y+zsprite.dty<=0)) then exit;
     width:=zsprite.dtx;
     asm                        { Von Hand ist es 'nen bichen schneller,}
        xor ax,ax               { weil TP vor jedem MOV noch ein berflssiges}
        mov clip_rt,ax          { XOR AX,AX einfgt. }
        mov clip_lt,ax
        mov clip_dn,ax
        mov clip_up,ax
     end;
     endx:=x+zsprite.dtx;
     if x<0 then
     begin
          startx:=0;
          clip_lt:=-x;
     end
     else begin
          startx:=x;
          if x+zsprite.dtx>320 then
          begin
               endx:=320;
               clip_rt:=(x+zsprite.dtx-320);
          end;
     end;
     if y<0 then
     begin
          starty:=0;
          clip_up:=-y;
     end
     else begin
          starty:=y;
          if y+zsprite.dty>200 then
          begin
               clip_dn:=(y+zsprite.dty-200);
          end;
     end;
     seg_spr:=seg(zsprite.adr^);
     ofs_spr:=ofs(zsprite.adr^);
     shadow_ofs:=ofs(shadowpal);
     restx:=320-endx;
     dtx:=zsprite.dtx-clip_rt-clip_lt;
     dty:=zsprite.dty-clip_up-clip_dn;
asm
   pusha                                {Rettet mal wieder die Wale, h,}
   push es                              {die Register}
   les di,vbuf
   mov data_seg,ds
   mov bx,shadow_ofs
   push ds
   cld                                  {Direction Flag lschen}
   mov ds,seg_spr                       {Sprite-Segment nach DS}
   mov ax,width                         {Offset in Sprite-Daten berechnen.}
   mul clip_up
   add ax,clip_lt
   add ax,ofs_spr
   mov si,ax                            {Und in SI laden}
   mov ax,320                           {Offset in VBUF berechnen}
   mul starty
   add ax,startx
   add di,ax                            {Und nach DI laden.}
   mov cx,dtx
   mov dx,dty
@anfang:
   lodsb                                {Byte holen}
   or al,al                             {Prfen, ob Null}
   je @null                             {Wenn ja, dann Sprung}

   push ds
   xor ax,ax
   mov al,es:[di]
   mov ds,data_seg
   mov bx,shadow_ofs
   add bx,ax
   mov al,ds:[bx]
   pop ds

   mov es:[di],al                       {ansonsten: Pixel setzen}
@null:
   inc di                               {DI weiter, um Pixel zu berspringen}
   dec cx                               {CX erniedrigen}
   jne @anfang                          {wenn grer Null, nochmal}
   add si,clip_rt                       {Sonst Zeiger weitersetzen}
   add si,clip_lt
   add di,restx
   add di,startx
   mov cx,dtx
   dec dx                               {Y-Zhler runter und gucken, ob Ende}
   jne @anfang                          {Wenn nicht, dann nochmal (GHN!)}
   pop ds
   pop es
   popa                                 {Register restaurieren...}
end;
end;                                    {Bis zum nchsten Mal, tsch.}

procedure putsprite_trans;
var
   startx,starty,endx: word;
   clip_dn,clip_up,clip_lt,clip_rt: word;
   ofs_spr: word;
   seg_spr: word;
   width: word;
   restx: word;
   dtx,dty:word;
   trans_seg: word;
begin
     if ((x>319) or (y>199)) or ((x+zsprite.dtx<=0) or (y+zsprite.dty<=0)) then exit;
     width:=zsprite.dtx;
     asm                        { Von Hand ist es 'nen bichen schneller,}
        xor ax,ax               { weil TP vor jedem MOV noch ein berflssiges}
        mov clip_rt,ax          { XOR AX,AX einfgt. }
        mov clip_lt,ax
        mov clip_dn,ax
        mov clip_up,ax
     end;
     endx:=x+zsprite.dtx;
     if x<0 then
     begin
          startx:=0;
          clip_lt:=-x;
     end
     else begin
          startx:=x;
          if x+zsprite.dtx>320 then
          begin
               endx:=320;
               clip_rt:=(x+zsprite.dtx-320);
          end;
     end;
     if y<0 then
     begin
          starty:=0;
          clip_up:=-y;
     end
     else begin
          starty:=y;
          if y+zsprite.dty>200 then
          begin
               clip_dn:=(y+zsprite.dty-200);
          end;
     end;
     seg_spr:=seg(zsprite.adr^);
     ofs_spr:=ofs(zsprite.adr^);
     restx:=320-endx;
     dtx:=zsprite.dtx-clip_rt-clip_lt;
     dty:=zsprite.dty-clip_up-clip_dn;
     trans_seg:=seg(transpal^);
asm
   pusha                                {Rettet mal wieder die Wale, h,}
   push es                              {die Register}
   les di,vbuf
   mov bx,0
   push ds
   cld                                  {Direction Flag lschen}
   mov ds,seg_spr                       {Sprite-Segment nach DS}
   mov ax,width                         {Offset in Sprite-Daten berechnen.}
   mul clip_up
   add ax,clip_lt
   add ax,ofs_spr
   mov si,ax                            {Und in SI laden}
   mov ax,320                           {Offset in VBUF berechnen}
   mul starty
   add ax,startx
   add di,ax                            {Und nach DI laden.}
   mov cx,dtx
   mov dx,dty
@anfang:
   mov al,ds:[si]
   or al,al                             {Prfen, ob Null}
   je @null                             {Wenn ja, dann Sprung}

   push ds
   xor ax,ax
   mov al,es:[di]
   mov bx,ax
   shl bx,8
   mov al,ds:[si]
   add bx,ax
   mov ds,trans_seg
   mov al,ds:[bx]
   pop ds

   mov es:[di],al                       {ansonsten: Pixel setzen}
@null:
   inc si
   inc di                               {DI weiter, um Pixel zu berspringen}
   dec cx                               {CX erniedrigen}
   jne @anfang                          {wenn grer Null, nochmal}
   add si,clip_rt                       {Sonst Zeiger weitersetzen}
   add si,clip_lt
   add di,restx
   add di,startx
   mov cx,dtx
   dec dx                               {Y-Zhler runter und gucken, ob Ende}
   jne @anfang                          {Wenn nicht, dann nochmal (GHN!)}
   pop ds
   pop es
   popa                                 {Register restaurieren...}
end;
end;                                    {Bis zum nchsten Mal, tsch.}

function findcol(r1,g1,b1: byte): byte;
var
   a,b: integer;
   differenz: integer;
   r2,g2,b2: byte;
begin
     findcol:=0;
     for a:=0 to 63 do begin
         for b:=0 to 255 do begin
             r2:=palette[b*3];
             g2:=palette[b*3+1];
             b2:=palette[b*3+2];
             if (((abs(r1-r2) < a) and (abs(g2-g1) < a)) and (abs(b2-b1) < a)) then begin
                findcol:=b;
                exit;
             end;
         end;
     end;
end;

procedure makeshadowpal;
var
   i: byte;
   r,g,b: byte;
begin
     for i:=0 to 255 do begin
         r:=palette[i*3];
         g:=palette[i*3+1];
         b:=palette[i*3+2];
         shadowpal[i]:=findcol(r div 2,g div 2,b div 2);
     end;
end;

procedure loadtranspal;
var
   f: file;
begin
     assign(f,filename);
     {$I-}
     reset(f,1);
     {$I+}
     if ioresult <> 0 then begin
        error:=ioerror;
        exit;
     end;
     if maxavail < 65535 then begin
        error:=outofmemerror;
        close(f);
        exit;
     end;
     getmem(transpal,65535);
     blockread(f,transpal^,65535);
     close(f);
end;

procedure savetranspal;
var
   f: file;
begin
     assign(f,filename);
     {$I-}
     rewrite(f,1);
     {$I+}
     if ioresult <> 0 then begin
        error:=ioerror;
        exit;
     end;
     blockwrite(f,transpal^,65535);
     close(f);
end;

procedure freetranspal;
begin
     if transpal <> nil then begin
        freemem(transpal,65535);
        transpal:=nil;
     end;
end;

procedure xchange(var var1,var2:integer);
var
   dummy:integer;
begin
     dummy:=var1;
     var1:=var2;
     var2:=dummy;
end;

procedure filledrectangle;
var
   words,bytes: word;
   restx: word;
   dtx,dty: word;
   startx,starty: word;
begin
     if (x1=x2) or (y1=y2) then exit;
     if x1>x2 then xchange(x1,x2);
     if y1>y2 then xchange(y1,y2);
     if x1 < 0 then x1:=0 else if x1>319 then exit;
     if y1 < 0 then y1:=0 else if y1>199 then exit;
     if x2 < 0 then exit else if x2>319 then x2:=319;
     if y2 < 0 then exit else if y2>199 then y2:=199;
     dtx:=x2-x1+1;
     dty:=y2-y1+1;
     if (dtx = 0) or (dty = 0) then exit;
     words:=dtx div 2;                  { Das gleiche wie bei PUTSPRITE_FAST }
     bytes:=dtx mod 2;
     restx:=320-dtx;
asm
   push es
   les di,vbuf
   mov ax,320
   mul y1
   add ax,x1
   add di,ax
   mov bx,dty
   mov al,byte ptr col
   mov ah,al
@anfang:
   mov cx,words
   rep stosw
   mov cx,bytes
   rep stosb
   dec bx
   je @ende
   add di,restx
   jmp @anfang
@ende:
   pop es
end;
end;

procedure shadowrectangle;
var
   restx: word;
   dtx,dty: word;
   startx,starty: word;
   pal_ofs: word;
begin
     if (x1=x2) or (y1=y2) then exit;
     if x1>x2 then xchange(x1,x2);
     if y1>y2 then xchange(y1,y2);
     if x1 < 0 then x1:=0 else if x1>319 then exit;
     if y1 < 0 then y1:=0 else if y1>199 then exit;
     if x2 < 0 then exit else if x2>319 then x2:=319;
     if y2 < 0 then exit else if y2>199 then y2:=199;
     dtx:=x2-x1+1;
     dty:=y2-y1+1;
     if (dtx = 0) or (dty = 0) then exit;
     pal_ofs:=ofs(shadowpal);
     restx:=320-dtx;
asm
   push es
   les di,vbuf
   mov ax,320
   mul y1
   add ax,x1
   add di,ax
   mov bx,dty
   xor ax,ax
@anfang:
   mov cx,dtx
@x_schleife:
   mov al,es:[di]
   mov si,pal_ofs
   add si,ax
   mov al,ds:[si]
   mov es:[di],al
   inc di
   dec cx
   jne @x_schleife
   dec bx
   je @ende
   add di,restx
   jmp @anfang
@ende:
   pop es
end;
end;

procedure transrectangle;
var
   restx: word;
   dtx,dty: word;
   startx,starty: word;
begin
     if (x1=x2) or (y1=y2) then exit;
     if x1>x2 then xchange(x1,x2);
     if y1>y2 then xchange(y1,y2);
     if x1 < 0 then x1:=0 else if x1>319 then exit;
     if y1 < 0 then y1:=0 else if y1>199 then exit;
     if x2 < 0 then exit else if x2>319 then x2:=319;
     if y2 < 0 then exit else if y2>199 then y2:=199;
     dtx:=x2-x1+1;
     dty:=y2-y1+1;
     if (dtx = 0) or (dty = 0) then exit;
     restx:=320-dtx;
asm
   push ds
   push es
   les di,vbuf
   mov ax,320
   mul y1
   add ax,x1
   add di,ax
   mov bx,dty
   xor ax,ax
   lds si,transpal
@anfang:
   mov cx,dtx
@x_schleife:

   mov al,es:[di]
   mov si,ax
   shl si,8
   mov al,col
   add si,ax
   mov al,ds:[si]
   mov es:[di],al

   inc di
   dec cx
   jne @x_schleife
   dec bx
   je @ende
   add di,restx
   jmp @anfang
@ende:
   pop es
   pop ds
end;
end;

procedure putpixel_save(x,y: integer; col: byte); assembler;
asm
   push es
   les di,vbuf
   mov ax,x
   or ax,ax             { Diese Koordinatenprfung macht das ganze }
   jb @ende             { natrlich sehr langsam, aber in manchen }
   cmp ax,319           { Fllen ist es so bequemer }
   ja @ende
   mov ax,y
   or ax,ax
   jb @ende
   cmp ax,199
   ja @ende
   mov ax,320
   mul y
   add ax,x
   add di,ax
   mov al,byte ptr col
   mov es:[di],al
@ende:
   pop es
end;

PROCEDURE rectangle(x1, y1, x2, y2: integer; Col:Byte);
var
   a,b:integer;
procedure line_horiz(x1,x2,y: integer; col: byte);
begin
     if x1 < 0 then x1:=0;
     if x2 > 319 then x2:=319;
     if (y < 0) or (y > 199) then exit;
asm
   push ds
   lds di,vbuf
   mov ax,320
   mul y
   add ax,x1
   add di,ax
   mov ax,x2
   sub ax,x1
   mov cx,ax
   inc cx
   mov al,byte ptr col
@anfang:
   mov ds:[di],al
   inc di
   dec cx
   jne @anfang
   pop ds
end;
end;
procedure line_vert(y1,y2,x: integer; col: byte);
begin
     inc(y2);
     if y1 < 0 then y1:=0;
     if y2 > 200 then y2:=200;
     if (x < 0) or (x > 319) then exit;
asm
   push ds
   lds di,vbuf
   mov ax,320
   mul y1
   add ax,x
   add di,ax
   mov ax,y2
   sub ax,y1
   mov cx,ax
   mov al,byte ptr col
@anfang:
   mov ds:[di],al
   add di,320
   dec cx
   jne @anfang
   pop ds
end;
end;
begin
     if (x1=x2) or (y1=y2) then exit;
     if x2 < x1 then xchange(x1,x2);
     if y2 < y1 then xchange(y1,y2);
     if (x2 < 0) or (y2 < 0) then exit;
     if (x1 > 319) or (y1 > 199) then exit;
     line_horiz(x1,x2,y1,col); { Zwei (schnelle) Routinen zum getrennten }
     line_horiz(x1,x2,y2,col); { Zeichnen der Vertikalen/Horizontalen }
     line_vert(y1,y2,x1,col);  { sind krzer und bersichtlicher, als wenn }
     line_vert(y1,y2,x2,col);  { man alles in einer (langen) Assemblerroutine hat }
end;

PROCEDURE line(x1, y1, x2, y2: INTEGER; Col: Byte);
{ Ich hatte bis jetzt weder Zeit noch Lust, diese Prozedur in Assembler }
{ zu bertragen, ich hoffe, man braucht sie nicht so oft... }
VAR
  dx, dy, ex, ey: Integer;

  PROCEDURE Swap(VAR i, j: INTEGER);
  VAR
    t: Integer;
  BEGIN
    t := i;
    i := j;
    j := t;
  END;

BEGIN
  IF x1 > x2 THEN
  BEGIN
    Swap(x1, x2);
    Swap(y1, y2);
  END;
  ex := x1 - x2;
  ey := -Abs(y2 - y1);
  dx := (-ex) SHL 1;
  dy := (-ey) SHL 1;
  IF y1 <= y2 THEN
  BEGIN
    IF dx >= dy THEN FOR x1 := x1 TO x2 DO
    BEGIN
      putpixel_save(x1, y1, Col);
      Inc(ex, dy);
      IF ex > 0 THEN
      BEGIN
        Dec(ex, dx);
        Inc(y1);
      END;
    END
    ELSE FOR y1 := y1 TO y2 DO
    BEGIN
      putpixel_save(x1, y1, Col);
      Inc(ey, dx);
      IF ey > 0 THEN
      BEGIN
        Dec(ey, dy);
        Inc(x1);
      END;
    END;
  END
  ELSE
  BEGIN
    IF dx >= dy THEN
    BEGIN
      FOR x1 := x1 TO x2 DO
      BEGIN
        putpixel_save(x1, y1, Col);
        Inc(ex, dy);
        IF ex > 0 THEN
        BEGIN
          Dec(ex, dx);
          Dec(y1);
        END;
      END;
    END
    ELSE FOR y1 := y1 DOWNTO y2 DO
    BEGIN
      putpixel_save(x1, y1, Col);
      Inc(ey, dx);
      IF ey > 0 THEN
      BEGIN
        Dec(ey,dy);
        Inc(x1);
      END;
    END;
  END;
END;

PROCEDURE ellipseAndcircle(xm, ym: INTEGER; xr,  yr: INTEGER; DisplayColor: Byte);
{ Da ich der Meinung bin, da man Kreise sowieso kaum braucht, habe ich }
{ mir nicht die Mhe gemacht, sie in Assembler zu schreiben. }
VAR
  x, y : INTEGER;
  dx, dy,
  ySub, xAdd,
  r    : LONGINT;
BEGIN
  IF (xr = 0) OR (yr = 0) THEN Exit;
  dx := LONGINT(xr * 2) * LONGINT(xr);
  dy := LONGINT(yr * 2) * LONGINT(yr);
  ySub := 0;
  xAdd := LONGINT(xr) * dy;
  r := xAdd DIV 2;
  x := xr;
  y := 0;
  REPEAT
    putpixel_save(xm + x, ym + y, DisplayColor);
    putpixel_save(xm + x, ym - y, DisplayColor);
    putpixel_save(xm - x, ym - y, DisplayColor);
    putpixel_save(xm - x, ym + y, DisplayColor);
    IF r >= 0 THEN
    BEGIN
      Inc(y);
      Inc(ySub,dx);
      Dec(r,ySub);
    END;
    IF r < 0 THEN
    BEGIN
      Dec(x);
      Dec(xAdd, dy);
      Inc(r, xAdd);
    END;
  UNTIL x < 0;
END;

PROCEDURE circle(x, y, r: INTEGER; Col:Byte);
BEGIN
  ellipseAndcircle(x, y, Round(r * 5 / 4), r, Col);
END;

PROCEDURE ellipse(x, y, rx, ry: INTEGER; Col:Byte);
BEGIN
  ellipseAndcircle(x, y, Round(rx * 5 / 4), ry, Col);
END;

procedure freesprite(var zsprite: spritetyp);
begin
     if zsprite.adr = nil then exit;
     if zsprite.dtx*zsprite.dty < 1 then exit;
     freemem(zsprite.adr,(zsprite.dtx*zsprite.dty));
     zsprite.adr:=nil;
     zsprite.dtx:=0;
     zsprite.dty:=0;
end;

Procedure WaitRetrace;assembler;
asm
   mov dx,3dah
@wait1:
   in al,dx
   test al,8h
   jz @wait1
@wait2:
   in al,dx
   test al,8h
   jnz @wait2
End;

procedure fade_out;
var
   groesste:word;
begin
asm
   mov groesste,63
   mov ax,ds
   mov es,ax
@mainloop:
   lea si,palette
   mov di,si
   mov cx,768
@lp:
   lodsb
   dec al
   jns @setzen
   xor al,al
@setzen:
   stosb
   dec cx
   jne @lp

   call waitretrace
   call setpal
   dec groesste
   jne @mainloop
end;
end;

procedure putsprite_scal(x,y,scale_x,scale_y: integer; zsprite: spritetyp);
{ Auf diese Prozedur bin ich ziemlich stolz, auch wenn sie manchmal }
{ qulend langsam ist. Es lassen sich einige nette Effekte damit erreichen... }
var
   breite,skip:word;
   addx,addy,relx,rely:word;
   seg_vbuf,seg_spr,ofs_vbuf,ofs_spr:word;
   dtx,dty:word;
   actx,acty:integer;
   dirx,diry,diry2:integer;
   zoomx,zoomy:byte;
   vergl_x,vergl_y:word;
begin
     zoomx:=0;
     zoomy:=0;
     seg_vbuf:=seg(vbuf^);
     ofs_vbuf:=ofs(vbuf^);
     seg_spr:=seg(zsprite.adr^);
     ofs_spr:=ofs(zsprite.adr^);
     vergl_x:=abs(scale_x);
     vergl_y:=abs(scale_y);
     if abs(scale_x) > 100 then begin
        addx:=100;
        zoomx:=1;
     end
     else addx:=100-abs(scale_x);
     if abs(scale_y) > 100 then begin
        addy:=100;
        zoomy:=1;
     end
     else addy:=100-abs(scale_y);
     if scale_x < 0 then dirx:=-1 else dirx:=1;
     if scale_y < 0 then begin
        diry2:=-1;
        diry:=-320;
     end else
     begin
        diry2:=1;
        diry:=320;
     end;
     relx:=0;
     rely:=0;
     dtx:=zsprite.dtx;
     dty:=zsprite.dty;
     actx:=x;
     acty:=y;
asm
   pusha                        {Register retten}
   push ds
   push es
   mov ds,seg_spr               {Segmente laden}
   mov es,seg_vbuf
   mov ax,320                   {Start-Offsets laden}
   mul y
   add ax,x
   add ax,ofs_vbuf
   mov di,ax
   mov si,ofs_spr
   mov bx,dty                   {BX: Y-Zhler}
@copy_y:
   mov cx,dtx                   {CX: X-Zhler}
   mov breite,0                 {Werte vorinitialisieren}
   mov ax,x
   mov actx,ax
   mov relx,0
   mov al,zoomx                 {Gucken, ob in X-Richtung Zoom}
   or al,al
   je @copy_x                   {Nein, dann bei Verkleinerung weiter}

@copy_x_z:
   lodsb                        {Byte holen und auf Null prfen}
   or al,al
   je @null_z                   {Wenn ja, dann berspringen}
   mov dx,actx                  {Ansonsten, gucken, ob im erlaubten Bereich}
   or dx,dx
   jb @null_z
   cmp dx,319
   ja @null_z
   mov dx,acty
   or dx,dx
   jb @null_z
   cmp dx,199
   ja @null_z
   mov es:[di],al               {Alles klar: dann setzen}
@null_z:
   mov dx,dirx                  {Zeiger weitersetzen}
   add breite,dx
   add di,dx
   add actx,dx
   mov ax,relx
   add ax,addx
   cmp ax,vergl_x               {Vergleichen, ob SI zurck}
   jbe @ueber_x_z
   jmp @kein_x_ueber_z
@kein_x_ueber_z:                {Zeile mu wiederholt werden,}
   dec si                       {SI und CX zurck}
   inc cx
   jmp @normal_z                {und normal weiter}
@ueber_x_z:
   sub ax,vergl_x               {Zeile mu nicht wiederholt werden}
@normal_z:
   mov relx,ax
   loop @copy_x_z               {zum Anfang, wenn CX nicht Null}
   jmp @weiter_z                {Verkleinerungsteil berjumpen}

@copy_x:
   lodsb                        {s.o.}
   or al,al
   je @null
   mov dx,actx
   or dx,dx
   jb @null
   cmp dx,319
   ja @null
   mov dx,acty
   or dx,dx
   jb @null
   cmp dx,199
   ja @null
   mov es:[di],al               {dito}
@null:
   mov ax,relx
   add ax,addx
   cmp ax,100                   {Gucken, ob Zeile ausgelassen werden mu}
   jb @kein_x_ueber             {nein, dann dahin}
   sub ax,100                   {ja, Nachkommateil zurcksetzen}
   jmp @ueber_x
@kein_x_ueber:
   mov dx,dirx                  {Zeiger weitersetzen}
   add actx,dx
   add breite,dx
   add di,dx
@ueber_x:
   mov relx,ax
   loop @copy_x                 {Nochmal, wenn CX nicht Null}

@weiter_z:

   mov al,zoomy                 {Gucken, ob Zoom in Y-Richtung}
   or al,al
   je @weiter_kein_zoom         {nein, dann weiter bei Verkleinerung}

   mov ax,diry                  {Ansonsten, Zeiger weitersetzen}
   sub ax,breite
   add di,ax
   mov ax,rely
   add ax,addy
   cmp ax,vergl_y               {Und gucken, ob Zeile wiederholt werden soll}
   jbe @ueber_y_z               {Nein, dann da weitermachen}
@kein_y_ueber_z:                {Ja}
   sub si,dtx                   {SI und CX zurck}
   inc bx
   jmp @normal2_z               {und normal weitermachen}
@ueber_y_z:
   sub ax,vergl_y               {Zeile mu nicht wiederholt werden}
@normal2_z:
   mov rely,ax                  {Zeiger weitersetzen}
   mov dx,diry2
   add acty,dx
   dec bx
   je @ende                     {wenn BX Null, dann Grafik beendet}
   jmp @copy_y                  {sont die Scheie nochmal}

@weiter_kein_zoom:              {Verkleinerungs-Teil}
   mov ax,rely
   add ax,addy
   mov rely,ax                  {Nachkommateil erhhen}
   mov dx,diry2
   add acty,dx
   cmp ax,100                   {und prfen, ob Zeile ausgelassen werden soll}
   jb @kein_y_ueber             {N, dann da weitermachen}
   sub acty,dx                  {Aber ja doch, dann Werte zurcksetzen}
   sub ax,100
   sub di,diry                  {In vorhergehende Zeile zurckspringen}
   mov rely,ax
@kein_y_ueber:
   mov ax,diry                  {Zeiger weitersetzen}
   sub ax,breite
   add di,ax
   dec bx
   je @ende                     {Wenn BX Null, dann Tsch}
   jmp @copy_y                  {Und no' ein mol, weils so schn ist}

@ende:
   pop es                       {Register auf ursprngliche Werte}
   pop ds
   popa
end;
end;                            {...und Tsch!}

procedure putsprite_scal_new(x,y,scale_x,scale_y: integer; zsprite: spritetyp);
var
   breite,skip:word;
   addx,addy,relx,rely:word;
   seg_vbuf,seg_spr,ofs_vbuf,ofs_spr:word;
   dtx,dty:word;
   actx,acty:integer;
   dirx,diry,diry2:integer;
   zoomx,zoomy:byte;
   vergl_x,vergl_y:word;
   maske: array[0..320] of byte;
   offset_maske: word;
   act_maske_ofs: word;
   wdh_x: byte;
begin
     offset_maske:=ofs(maske);
     act_maske_ofs:=offset_maske;
     zoomx:=0;
     zoomy:=0;
     seg_vbuf:=seg(vbuf^);
     ofs_vbuf:=ofs(vbuf^);
     seg_spr:=seg(zsprite.adr^);
     ofs_spr:=ofs(zsprite.adr^);
     vergl_x:=abs(scale_x);
     vergl_y:=abs(scale_y);
     if abs(scale_x) > 100 then begin
        addx:=100;
        zoomx:=1;
     end
     else addx:=100-abs(scale_x);
     if abs(scale_y) > 100 then begin
        addy:=100;
        zoomy:=1;
     end
     else addy:=100-abs(scale_y);
     if scale_x < 0 then dirx:=-1 else dirx:=1;
     if scale_y < 0 then begin
        diry2:=-1;
        diry:=-320;
     end else
     begin
        diry2:=1;
        diry:=320;
     end;
     relx:=0;
     rely:=0;
     dtx:=zsprite.dtx;
     dty:=zsprite.dty;
     actx:=x;
     acty:=y;
asm
   pusha                        {Register retten}
   push ds
   push es
   mov ds,seg_spr               {Segmente laden}
   mov es,seg_vbuf
   mov ax,320                   {Start-Offsets laden}
   mul y
   add ax,x
   add ax,ofs_vbuf
   mov di,ax
   mov si,ofs_spr
   mov bx,dty                   {BX: Y-Zhler}
   mov breite,0

   mov al,zoomx
   or al,al
   je @maske_kein_zoom

   mov relx,0
   mov cx,dtx
@wdh_loop_x:
   mov wdh_x,0
   mov ax,relx
   add ax,addx
   cmp ax,vergl_x
   jbe @kein_wdh_x
   inc wdh_x
   inc cx
   inc breite
   jmp @normal_x
@kein_wdh_x:
   sub ax,vergl_x
   push bx
   mov bx,act_maske_ofs
   mov dl,wdh_x
   mov cs:[bx],dl
   pop bx
   inc act_maske_ofs
   mov wdh_x,0
@normal_x:
   mov relx,ax
   inc breite
   dec cx
   jne @wdh_loop_x
   jmp @weiter

@maske_kein_zoom:

   mov wdh_x,0
   mov relx,0
   mov cx,dtx
@scal_loop_x:
   mov wdh_x,0
   mov ax,relx
   add ax,addx
   cmp ax,100
   jb @kein_ueber_x
   sub ax,100
   jmp @ueber_x
@kein_ueber_x:
   inc wdh_x
   inc breite
@ueber_x:
   mov relx,ax
   push bx
   mov bx,act_maske_ofs
   mov dl,wdh_x
   mov cs:[bx],dl
   pop bx
   inc act_maske_ofs
   dec cx
   jne @scal_loop_x

@weiter:

@Y_Loop:

   pop es
   pop ds
   popa
end;
end;

procedure putsprite_scal_fast(x,y,scale_x,scale_y: integer; zsprite: spritetyp);
{ Auf diese Prozedur bin ich ziemlich stolz, auch wenn sie manchmal }
{ qulend langsam ist. Es lassen sich einige nette Effekte damit erreichen... }
var
   breite,skip:word;
   addx,addy,relx,rely:word;
   seg_vbuf,seg_spr,ofs_vbuf,ofs_spr:word;
   dtx,dty:word;
   actx,acty:integer;
   dirx,diry,diry2:integer;
   zoomx,zoomy:byte;
   vergl_x,vergl_y:word;
begin
     zoomx:=0;
     zoomy:=0;
     seg_vbuf:=seg(vbuf^);
     ofs_vbuf:=ofs(vbuf^);
     seg_spr:=seg(zsprite.adr^);
     ofs_spr:=ofs(zsprite.adr^);
     vergl_x:=abs(scale_x);
     vergl_y:=abs(scale_y);
     if abs(scale_x) > 100 then begin
        addx:=100;
        zoomx:=1;
     end
     else addx:=100-abs(scale_x);
     if abs(scale_y) > 100 then begin
        addy:=100;
        zoomy:=1;
     end
     else addy:=100-abs(scale_y);
     if scale_x < 0 then dirx:=-1 else dirx:=1;
     if scale_y < 0 then begin
        diry2:=-1;
        diry:=-320;
     end else
     begin
        diry2:=1;
        diry:=320;
     end;
     relx:=0;
     rely:=0;
     dtx:=zsprite.dtx;
     dty:=zsprite.dty;
     actx:=x;
     acty:=y;
asm
   pusha                        {Register retten}
   push ds
   push es
   mov ds,seg_spr               {Segmente laden}
   mov es,seg_vbuf
   mov ax,320                   {Start-Offsets laden}
   mul y
   add ax,x
   add ax,ofs_vbuf
   mov di,ax
   mov si,ofs_spr
   mov bx,dty                   {BX: Y-Zhler}
@copy_y:
   mov cx,dtx                   {CX: X-Zhler}
   mov breite,0                 {Werte vorinitialisieren}
   mov ax,x
   mov actx,ax
   mov relx,0
   mov al,zoomx                 {Gucken, ob in X-Richtung Zoom}
   or al,al
   je @copy_x                   {Nein, dann bei Verkleinerung weiter}

@copy_x_z:
   lodsb                        {Byte holen und auf Null prfen}
   or al,al
   je @null_z                   {Wenn ja, dann berspringen}
   mov es:[di],al               {Alles klar: dann setzen}
@null_z:
   mov dx,dirx                  {Zeiger weitersetzen}
   add breite,dx
   add di,dx
   add actx,dx
   mov ax,relx
   add ax,addx
   cmp ax,vergl_x               {Vergleichen, ob SI zurck}
   jbe @ueber_x_z
   jmp @kein_x_ueber_z
@kein_x_ueber_z:                {Zeile mu wiederholt werden,}
   dec si                       {SI und CX zurck}
   inc cx
   jmp @normal_z                {und normal weiter}
@ueber_x_z:
   sub ax,vergl_x               {Zeile mu nicht wiederholt werden}
@normal_z:
   mov relx,ax
   loop @copy_x_z               {zum Anfang, wenn CX nicht Null}
   jmp @weiter_z                {Verkleinerungsteil berjumpen}

@copy_x:
   lodsb                        {s.o.}
   or al,al
   je @null
   mov es:[di],al               {dito}
@null:
   mov ax,relx
   add ax,addx
   cmp ax,100                   {Gucken, ob Zeile ausgelassen werden mu}
   jb @kein_x_ueber             {nein, dann dahin}
   sub ax,100                   {ja, Nachkommateil zurcksetzen}
   jmp @ueber_x
@kein_x_ueber:
   mov dx,dirx                  {Zeiger weitersetzen}
   add actx,dx
   add breite,dx
   add di,dx
@ueber_x:
   mov relx,ax
   loop @copy_x                 {Nochmal, wenn CX nicht Null}

@weiter_z:

   mov al,zoomy                 {Gucken, ob Zoom in Y-Richtung}
   or al,al
   je @weiter_kein_zoom         {nein, dann weiter bei Verkleinerung}

   mov ax,diry                  {Ansonsten, Zeiger weitersetzen}
   sub ax,breite
   add di,ax
   mov ax,rely
   add ax,addy
   cmp ax,vergl_y               {Und gucken, ob Zeile wiederholt werden soll}
   jbe @ueber_y_z               {Nein, dann da weitermachen}
@kein_y_ueber_z:                {Ja}
   sub si,dtx                   {SI und CX zurck}
   inc bx
   jmp @normal2_z               {und normal weitermachen}
@ueber_y_z:
   sub ax,vergl_y               {Zeile mu nicht wiederholt werden}
@normal2_z:
   mov rely,ax                  {Zeiger weitersetzen}
   mov dx,diry2
   add acty,dx
   dec bx
   je @ende                     {wenn BX Null, dann Grafik beendet}
   jmp @copy_y                  {sont die Scheie nochmal}

@weiter_kein_zoom:              {Verkleinerungs-Teil}
   mov ax,rely
   add ax,addy
   mov rely,ax                  {Nachkommateil erhhen}
   mov dx,diry2
   add acty,dx
   cmp ax,100                   {und prfen, ob Zeile ausgelassen werden soll}
   jb @kein_y_ueber             {N, dann da weitermachen}
   sub acty,dx                  {Aber ja doch, dann Werte zurcksetzen}
   sub ax,100
   sub di,diry                  {In vorhergehende Zeile zurckspringen}
   mov rely,ax
@kein_y_ueber:
   mov ax,diry                  {Zeiger weitersetzen}
   sub ax,breite
   add di,ax
   dec bx
   je @ende                     {Wenn BX Null, dann Tsch}
   jmp @copy_y                  {Und no' ein mol, weils so schn ist}

@ende:
   pop es                       {Register auf ursprngliche Werte}
   pop ds
   popa
end;
end;                            {...und Tsch!}

function getpixel_screen;
var
   thepixel:byte;
begin
     getpixel_screen:=0;
     if (x<0) or (x>319) then exit;
     if (y<0) or (y>199) then exit;
asm
   push ds
   mov ax,0a000h
   mov ds,ax
   mov ax,320
   mul y
   add ax,x
   mov di,ax
   mov al,ds:[di]
   mov thepixel,al
   pop ds
end;
   getpixel_screen:=thepixel;
end;

function getpixel_vbuf;
var
   thepixel:byte;
   seg_vbuf:word;
begin
     getpixel_vbuf:=0;
     if (x<0) or (x>319) then exit;
     if (y<0) or (y>199) then exit;
     seg_vbuf:=seg(vbuf^);
asm
   push ds
   mov ax,seg_vbuf
   mov ds,ax
   mov ax,320
   mul y
   add ax,x
   mov di,ax
   mov al,ds:[di]
   mov thepixel,al
   pop ds
end;
    getpixel_vbuf:=thepixel;
end;

function getpixel_sprite;
var
   thepixel:byte;
   seg_spr,ofs_spr,breite:word;
begin
     getpixel_sprite:=0;
     if (x<0) or (x>qsprite.dtx) then exit;
     if (y<0) or (y>qsprite.dty) then exit;
     seg_spr:=seg(qsprite.adr^);
     ofs_spr:=ofs(qsprite.adr^);
     breite:=qsprite.dtx;
asm
   push ds
   mov ax,seg_spr
   mov ds,ax
   mov ax,ofs_spr
   mov di,ax
   mov ax,breite
   mul y
   add ax,x
   add di,ax
   mov al,ds:[di]
   mov thepixel,al
   pop ds
end;
    getpixel_sprite:=thepixel;
end;

procedure putpixel_sprite;
var
   seg_spr,ofs_spr,breite:word;
begin
     if (x<0) or (x>qsprite.dtx) then exit;
     if (y<0) or (y>qsprite.dty) then exit;
     seg_spr:=seg(qsprite.adr^);
     ofs_spr:=ofs(qsprite.adr^);
     breite:=qsprite.dtx;
asm
   push ds
   mov ax,seg_spr
   mov ds,ax
   mov ax,ofs_spr
   mov di,ax
   mov ax,breite
   mul y
   add ax,x
   add di,ax
   mov al,col
   mov ds:[di],al
   pop ds
end;
end;

function getnextpixel(qsprite: spritetyp; offs:word): byte;
var
   thepixel: byte;
   _seg, _ofs: word;
begin
     _seg:=seg(qsprite.adr^);
     _ofs:=ofs(qsprite.adr^);
asm
   pusha
   push ds
   mov ax,_seg
   mov ds,ax
   mov ax,offs
   add ax,_ofs
   mov si,ax
   mov al,ds:[si]
   mov thepixel,al
   pop ds
   popa
end;
    getnextpixel:=thepixel;
end;

procedure save_sprite;
var
   f: file;
   header: ^bjf_header;
   offs,a: word;
   col,col2: byte;
   gelesen: byte;
   dummy:byte;
   ende:boolean;
   anfang: longint;
   schrott: word;
   offs_buffer: word;
   seg_vscreen,ofs_vscreen: word;
begin
     { Erstmal kein Fehler, dann Werte in Header schreiben, Datei erstellen, }
     { (ggf. abbrechen), und prfen, ob alles OK. }
     Error:=NoError;
     if pos('.',filename) = 0 then filename:=filename+'.bjf';
     filename:=akt_pfad+filename;
     new(header);
     header^.formatkennung:='BJF';
     header^.width:=qsprite.dtx;
     header^.height:=qsprite.dty;
     header^.packing:=pack_onoff;
     header^.pal:=pal;
     assign(f,filename);
     {$I-} rewrite(f,1); {$I+}
           if ioresult <> 0 then begin
              error:=IOError;
              exit;
           end;

     { Header schreiben }
     blockwrite(f,header^,10);
     anfang:=10;

     { Dateizeiger weitersetzen und ggf. Farbpalette sichern }
     seek(f,anfang);
     if pal = true then begin
        getpal;
        blockwrite(f,palette,sizeof(palette));
        anfang:=10+sizeof(palette);
     end;

     { Falls nicht gepackt werden soll, Daten einfach nur reinschreiben und Ende }
     if pack_onoff = false then begin
        seek(f,anfang);
        blockwrite(f,qsprite.adr^,(qsprite.dtx*qsprite.dty));
        close(f);
        exit;
     end;

     { Ansonsten: Packen vorbereiten }
     seek(f,anfang);
     offs:=0;
     dummy:=255;
     ende:=false;
     seg_vscreen:=seg(vscreen^);
     ofs_vscreen:=ofs(vscreen^);
     offs_buffer:=ofs_vscreen;

     { Und jetzt Daten gepackt in Puffer schreiben }
     repeat
           col:=getnextpixel(qsprite,offs);
           gelesen:=0;
           repeat
                 inc(gelesen);
                 inc(offs);
                 col2:=getnextpixel(qsprite,offs);
           until (col2 <> col) or (gelesen = 255) or (offs = (qsprite.dtx*qsprite.dty)-1);
           if offs >= (qsprite.dtx*qsprite.dty) then ende:=true;
           if (gelesen > 2) or (col = 255) then begin
              mem[seg_vscreen: offs_buffer]:=dummy;
              mem[seg_vscreen: offs_buffer+1]:=col;
              mem[seg_vscreen: offs_buffer+2]:=gelesen;
              inc(offs_buffer,3);
           end else begin
              for a:=0 to gelesen-1 do begin
                  mem[seg_vscreen: offs_buffer]:=col;
                  inc(offs_buffer);
              end;
           end;
     until ende = true;

     { Die gepackten Daten auf die Platte schmeien }
     blockwrite(f,vscreen^,offs_buffer+1);

     { Und Tsch...}
     close(f);
end;

procedure load_sprite;
var
   header: ^bjf_header;
   f: file;
   offs,offs_vscr,a: word;
   col :byte;
   farbe,wdh:byte;
   f_offset: longint;
   ofs_spr,seg_spr:word;
   ofs_scr,seg_scr:word;
   rest: word;
   size: word;
   gelesen: word;
begin
     { Erstmal kein Fehler, Datei ffnen und ggf. abbrechen }
     Error:=NoError;
     if pos('.',filename) = 0 then filename:=filename+'.bjf';
     filename:=akt_pfad+filename;
     new(header);
     assign(f,filename);
     {$I-} reset(f,1); {$I+}
     if ioresult <> 0 then begin
        error:=IOError;
        exit;
     end;

     { Header einladen }
     seek(f,anf);
     blockread(f,header^,10);

     { Prfen, ob gltiges Format }
     if header^.formatkennung <> 'BJF' then begin
        error:=WrongFormatError;
        exit;
     end;

     { Prfen, ob genug Speicher }
     if maxavail < header^.width*header^.height then begin
        error:=OutOfMemError;
        exit;
     end;

     { ggf. Palette einladen }
     if header^.pal = true then begin
        seek(f,anf+10);
        blockread(f,palette,768);
        f_offset:=sizeof(palette)+10;
     end else begin
        f_offset:=10;
     end;

     { Jetzt Daten einlesen }
     if header^.packing <> true then begin
         { ungepackt, kann also direkt eingelesen werden }
         seek(f,anf+f_offset);
         getmem(zsprite.adr,header^.width*header^.height);
         blockread(f,zsprite.adr^,(header^.width*header^.height));
     end else begin
         { gepackt, also erstmal in Puffer lesen }
         seek(f,anf+f_offset);
         rest:=filesize(f)-filepos(f);
         getmem(zsprite.adr,header^.width*header^.height);
         blockread(f,vscreen^,header^.width*header^.height,gelesen);
         offs:=0;
         seg_spr:=seg(zsprite.adr^);
         ofs_spr:=ofs(zsprite.adr^);
         seg_scr:=seg(vscreen^);
         ofs_scr:=ofs(vscreen^);
         offs_vscr:=0;

         { Und nun den ganzen Kram entpacken und ins Sprite schreiben }
         size:=header^.width*header^.height;
         repeat
               col:=mem[seg_scr: ofs_scr+offs_vscr];
               inc(offs_vscr);
               if col = 255 then begin
                  farbe:=mem[seg_scr: ofs_scr+offs_vscr];
                  wdh:=mem[seg_scr: ofs_scr+offs_vscr+1];
                  inc(offs_vscr,2);
                  for a:=0 to wdh-1 do begin
                      mem[seg_spr:ofs_spr+offs]:=farbe;
                      inc(offs);
                  end;
               end else begin
                   mem[seg_spr:ofs_spr+offs]:=col;
                   inc(offs);
               end;
         until offs >= size;
     end;

     { Datei wird nicht mehr bentigt - schlieen }
     close(f);

     zsprite.dtx:=header^.width;
     zsprite.dty:=header^.height;
end;

procedure shift_pcx_pal; assembler;
asm
   mov si,OFFSET palette
   mov cx,768
@lp:
   lodsb
   shr al,2
   mov ds:[si-1],al
   loop @lp
end;

procedure load_pcx_sprite;
const
     { Diese Variablen werden direkt initialisiert. Oder doch nicht? }
     { Das werden sie - einmal. Beim 2. Aufruf mu man selbst dafr }
     { sorgen, da sie wieder zurckgesetzt werden. Aber bis ich DAS }
     { raushatte... }
     spr_zeiger: word = 0;
     pcx_zeiger: word = 0;
     file_size: longint = 0;
     i: word = 0;
     compress_num = $C0;
     datenbyte: byte = 0;
     wdh: byte = 0;
     counter: byte = 0;
var
   f: file;
   pcx_height,pcx_width: word;
   header: pcx_header;
   seg_spr,ofs_spr: word;
   seg_buf,ofs_buf: word;
   gelesen: word;
begin
     if pos('.',filename) = 0 then filename:=filename+'.pcx';
     filename:=akt_pfad+filename;
     {$I-}
     assign(f,filename);
     error:=noerror;
     reset(f,1);
     if ioresult <> 0 then begin
        {$I+}
        error:=IOerror;
        exit;
     end;

     { Header laden. }
     blockread(f,header,128);
     if ioresult <> 0 then begin
        {$I+}
        error:=WrongFormatError;
        close(f);
        exit;
     end;

     {Prfen, ob gltiges Format (Version 3.0, RLE, 256-Farben ect.) }
     with header do begin
          if (manufacturer <> 10) or (version <> 5) or (encoding <> 1) or
             (bits_per_pixel <> 8) or (xmax <=0) or (ymax <= 0) or
             (xmax > 319) or (ymax > 199) then begin
                 {$I+}
                 error:=WrongFormatError;
                 close(f);
                 exit;
          end;
     end;

     { Komprimierte Datei ohne Header und Palette in VSCREEN laden: }
     file_size:=filesize(f)-128-769;
     blockread(f,vscreen^,file_size,gelesen);
     if (ioresult <> 0) or (gelesen <> file_size) then begin
        {$I+}
        error:=WrongFormatError;
        close(f);
        exit;
     end;

     { Zeiger an Paletten-Position setzen. }
     seek(f,filesize(f)-768);

     { Palette in PALETTE laden. }
     blockread(f,palette,768);
     if ioresult <> 0 then begin
        {$I+}
        error:=WrongFormatError;
        close(f);
        exit;
     end;
     shift_pcx_pal;

     { Datei wird nicht mehr bentigt - schlieen! }
     close(f);

     { Jetzt kommt der anstrengende Teil - den Kram entpacken und ins Sprite
       schreiben. }
     pcx_width:=header.xmax-header.xmin+1;
     pcx_height:=header.ymax-header.ymin+1;

     { Erstmal Speicher allokieren.}
     if maxavail < (pcx_width*pcx_height) then begin
        error:=OutOfMemError;
        exit;
     end;
     getmem(zsprite.adr,pcx_width*pcx_height);

     { Dann alle wichtigen Daten ins Sprite schreiben. }
     zsprite.dtx:=pcx_width;
     zsprite.dty:=pcx_height;

     { Adressen laden. }
     seg_buf:=seg(vscreen^);
     ofs_buf:=ofs(vscreen^);
     seg_spr:=seg(zsprite.adr^);
     ofs_spr:=ofs(zsprite.adr^);

     { Eigentlich sollte man denken, der Compiler htte das erledigt;
       dem ist aber nicht so!!!!!! Wenn diese Zeilen hier fehlen, dann
       klappt's paradoxerweise nicht. Oh Borland! }
     pcx_zeiger:=0;
     spr_zeiger:=0;

     { Tataaaa! Ladies und Gentlemen, der Dekompressor! }
     for i:=0 to file_size-1 do begin
         datenbyte:=mem[seg_buf:ofs_buf+pcx_zeiger];
         inc(pcx_zeiger);
         if (datenbyte and compress_num) = compress_num then begin
            wdh:=datenbyte and $3F;
            datenbyte:=mem[seg_buf:ofs_buf+pcx_zeiger];
            inc(pcx_zeiger);
            inc(i);
            for counter:=0 to wdh-1 do begin
                mem[seg_spr: ofs_spr+spr_zeiger]:=datenbyte;
                inc(spr_zeiger);
            end;
         end else begin
             mem[seg_spr: ofs_spr+spr_zeiger]:=datenbyte;
             inc(spr_zeiger);
         end;
     end;

end; {load_pcx_sprite}

function spriteoverlap_fast;
var
   x_overlap,y_overlap: boolean;
begin
     spriteoverlap_fast:=false;
     if (x1 >= x2) and (x1 <= x2+sprite2.dtx-1) then x_overlap:=true else
        if (x2 >= x1) and (x2 <= x1+sprite1.dtx-1) then x_overlap:=true else
           x_overlap:=false;
     if (y1 >= y2) and (y1 <= y2+sprite2.dty-1) then y_overlap:=true else
        if (y2 >= y1) and (y2 <= y1+sprite1.dty-1) then y_overlap:=true else
           y_overlap:=false;
     spriteoverlap_fast:=x_overlap and y_overlap;
end;

function spriteoverlap_exact;
var
   start_x_1,start_x_2,start_y_1,start_y_2: word;
   end_x_1,end_x_2,end_y_1,end_y_2: word;
   breite,hoehe: word;
   gotcha: byte;
   rest_x_1,rest_x_2: word;
   seg_1,ofs_1,seg_2,ofs_2: word;
begin
     spriteoverlap_exact:=false;

     { Haben wir berhaupt eine berschneidung? }
     if spriteoverlap_fast(x1,y1,sprite1,x2,y2,sprite2) = false then exit;

     { Ja, also bestimmen wir berschneidungsbreich }

     { Fall 1: Erstes Sprite befindet sich in X-Richtung im 2. Sprite (links)}
     if ((x1>=x2) and (x1<=x2+sprite2.dtx-1)) then begin
        start_x_1:=x1;
        start_x_2:=x1;
     { Fall 2: 2. Sprite befindet sich in X-Richtung im 1. Sprite (links)}
     end else if ((x2>=x1) and (x2<=x1+sprite1.dtx-1)) then begin
        start_x_1:=x2;
        start_x_2:=x2;
     end;

     { Fall 1: Erstes Sprite befindet sich in X-Richtung im 2. Sprite (rechts)}
     if ((x1+sprite1.dtx-1>=x2) and (x1+sprite1.dtx-1<=x2+sprite2.dtx-1)) then begin
        end_x_1:=x1+sprite1.dtx-1;
        end_x_2:=x1+sprite1.dtx-1;
     { Fall 2: 2. Sprite befindet sich in X-Richtung im 1. Sprite (rechts)}
     end else if ((x2+sprite2.dtx-1>=x1) and (x2+sprite2.dtx-1<=x1+sprite1.dtx-1)) then begin
        end_x_1:=x2+sprite2.dtx-1;
        end_x_2:=x2+sprite2.dtx-1;
     end;

     { Fall 1: 1. Sprite befindet sich in Y-Richtung im 2. Sprite (oben)}
     if ((y1>=y2) and (y1<=y2+sprite2.dty-1)) then begin
        start_y_1:=y1;
        start_y_2:=y1;
     { Fall 2: 2. Sprite befindet sich in Y-Richtung im 1. Sprite (oben)}
     end else if ((y2>=y1) and (y2<=y1+sprite1.dty-1)) then begin
        start_y_1:=y2;
        start_y_2:=y2;
     end;

     { Fall 1: 1. Sprite befindet sich in Y-Richtung im 2. Sprite (unten)}
     if ((y1+sprite1.dty-1>=y2) and (y1+sprite1.dty-1<=y2+sprite2.dty-1)) then begin
        end_y_1:=y1+sprite1.dty-1;
        end_y_2:=y1+sprite1.dty-1;
     { Fall 2: 2. Sprite befindet sich in Y-Richtung im 1. Sprite (unten)}
     end else if ((y2+sprite2.dty-1>=y1) and (y2+sprite2.dty-1<=y1+sprite1.dty-1)) then begin
        end_y_1:=y2+sprite2.dty-1;
        end_y_2:=y2+sprite2.dty-1;
     end;

     { Wir wollen keine absoluten Koordinaten, sondern die innerhalb der
       Sprites }
     dec(start_x_1,x1);
     dec(start_x_2,x2);
     dec(start_y_1,y1);
     dec(start_y_2,y2);
     dec(end_x_1,x1);
     dec(end_x_2,x2);
     dec(end_y_1,y1);
     dec(end_y_2,y2);

     { Breite und Hhe des berschneidungsbereiches bestimmen }
     breite:=end_x_1-start_x_1;
     hoehe:=end_y_1-start_y_1;

     { Um diese Werte mssen die Offsets der Sprites nach jeder Zeile
       erhht werden }
     rest_x_1:=sprite1.dtx-breite;
     rest_x_2:=sprite2.dtx-breite;

     { Segmente und Offsets der Sprite-Daten laden }
     seg_1:=seg(sprite1.adr^);
     seg_2:=seg(sprite2.adr^);
     ofs_1:=ofs(sprite1.adr^);
     ofs_2:=ofs(sprite2.adr^);

     { Wenn der Bereich kleiner Null ist, liest der Rechner irgendwelchen
       Mll aus dem Speicher, das mu verhindert werden! }
     if (breite < 1) or (hoehe < 1) then exit;
asm
   push es                      { Wichtige Register retten }
   push ds
   mov es,seg_1                 { Segmente der Sprites laden }
   mov ds,seg_2
   mov ax,word ptr sprite1.dtx  { Offsets berechnen... }
   mul start_y_1
   add ax,start_x_1
   add ax,ofs_1
   mov di,ax
   mov ax,word ptr sprite2.dtx
   mul start_y_2
   add ax,start_x_2
   add ax,ofs_2
   mov si,ax
   mov gotcha,0                 { Erstmal annehmen, da keine berschneidung }
   mov bx,hoehe                 { Hhe ins BX-Register laden }
@anfang_y:
   mov cx,breite                { Breite ins CX-Register laden }
@anfang_x:
   mov al,es:[di]               { Bytes aus den beiden Sprites laden }
   mov ah,ds:[si]
   and ah,al                    { Und vergleichen }
   jz @weiter
   jmp @hit                     { Wenn BEIDE GRER Null, dann GOTCHA! }
@weiter:
   inc di                       { ansonsten: Zeiger weiter }
   inc si
   dec cx                       { und X-Zhler runter }
   jne @anfang_x                { Wenn noch nicht abgearbeitet, dann nochmal }
   add di,rest_x_1              { Sonst: Zeiger auf nchste Zeilen }
   add si,rest_x_2
   dec bx                       { Und Y-Zhler runter }
   jne @anfang_y                { Noch immer kein Ende? Dann nochmal! }
   jmp @ende                    { Endlich! Zu Ende! }
@hit:
   mov gotcha,1                 { berschneidung gefunden! }
@ende:
   pop ds                       { Register restaurieren }
   pop es
end;
     if gotcha = 1 then spriteoverlap_exact:=true;
end;                            {...und tschss! }

procedure outtextxy_internal(x,y: integer;text: string; farbe: byte);
var
    offs,z,bit,i,CharWidth:BYTE;
    b:byte;
    zeile, spalte: byte;
    akt_x: integer;
begin
     akt_x:=x;
     for i:=1 to length(text) do begin
         offs:=ord(text[i]);
         for b:=0 to 5 do begin
             zeile:=word(internalfont[offs,b]);
             for bit:=0 to 6 do begin
                 if zeile and (fontmask[bit+9]) <> 0 then
                    putpixel_save(x+bit,y+b,farbe);
             end;
         end;
         inc(x,6);
     end;
end;

procedure outtextxy;
var
    offs_bit,z,bit,i,CharWidth:BYTE;
    b:byte;
    offs, zeile, spalte: word;
    akt_x: integer;
    fnt_ofs,fnt_seg: word;
    nummer: byte;
    hoehe: byte;
begin
     if akt_font = fontinternal then begin
        outtextxy_internal(x,y,text,farbe);
        exit;
     end;
     if font[akt_font].width = 0 then exit;
     hoehe:=font[akt_font].height;
     nummer:=akt_font;
     fnt_ofs:=ofs(font[nummer].adr^);
     fnt_seg:=seg(font[nummer].adr^);
     akt_x:=x;
     offs_bit:=16-font[nummer].width;
     for i:=1 to length(text) do begin
         offs:=ord(text[i])*hoehe*2;
         for b:=0 to hoehe-1 do begin
             move(ptr(fnt_seg,fnt_ofs+offs)^,zeile,2);
{             Zeile:=MemW[Fnt_Seg: Fnt_Ofs+Offs];}
             inc(offs,2);
             for bit:=0 to font[nummer].width do begin
                 if zeile and (fontmask[bit]) <> 0 then
                    putpixel_save(x+bit,y+b,farbe);
             end;
         end;
         inc(x,font[nummer].width);
     end;
end;

function textheight;
begin
     if length(text) > 0 then textheight:=font[akt_font].height else textheight:=0;
end;

function textwidth;
begin
     textwidth:=length(text)*font[akt_font].width;
end;

procedure init_fonts;
var
   a: byte;
begin
     for a:=0 to MaxFont do begin
         Font[a].adr:=nil;
         Font[a].width:=0;
         Font[a].height:=0;
     end;
end;

function load_font;
var
   f: file;
   gelesen: word;
   a,nummer: byte;
   ok: boolean;
   header: font_header;
begin
     Error:=NoError;

     { Nummer raussuchen, wenn schon alle vergeben, EXIT }
     ok:=false;
     for a:=0 to MaxFont do begin
         if Font[a].height = 0 then begin
            Nummer:=a;
            OK:=true;
            break;
         end;
     end;
     if ok = false then begin
        Error:=OutOfMemError;
        exit;
     end;

     { Datei ffnen und prfen, ob alles geklappt hat. }
     if pos('.',filename) = 0 then filename:=filename+'.fnt';
     filename:=akt_pfad+filename;
     Assign(f, filename);
     {$I-} reset(f,1); {$I+}
     if IOresult <> 0 then begin
        Error:=IOerror;
        exit;
     end;

     {$I-} {Fr den Rest der Rountine: AUS}

     { Header lesen }
     BlockRead(f,header,sizeof(header),gelesen);
     if gelesen <> sizeof(header) then begin
        load_font:=FontInternal;
        Error:=IOerror;
        close(f);
        {$I+}
        exit;
     end;

     { Format prfen, dann Speicher allokieren }
     if (header.kennung <> 'FONT') or (header.width = 0) or (header.height = 0) then begin
        load_font:=FontInternal;
        Error:=WrongFormatError;
        close(f);
        {$I+}
        exit;
     end;
     if maxavail < header.height*255*2 then begin
        load_font:=FontInternal;
        Error:=OutOfMemError;
        close(f);
        {$I+}
        exit;
     end;
     getmem(Font[Nummer].adr,header.height*255*2);

     { Jetzt endlich die Daten lesen }
     BlockRead(f,font[nummer].adr^,header.height*255*2,gelesen);
     if gelesen <> header.height*255*2 then begin
        load_font:=FontInternal;
        Error:=IOerror;
        close(f);
        {$I+}
        exit;
     end;

     { Datei schlieen und Nummer zurckgeben }
     Font[Nummer].width:=header.width;
     Font[Nummer].height:=header.height;
     {$I+} { Und Error-Checking wieder an }
     close(f);
     load_font:=Nummer;

end; {load_font}

procedure freefont;
begin
     if nummer > MaxFont then exit;
     if font[nummer].height = 0 then exit;
     freemem(font[nummer].adr,font[nummer].height*255*2);
     font[nummer].width:=0;
     font[nummer].height:=0;
     font[nummer].adr:=nil;
end;

procedure setfont;
begin
     if nummer > maxFont then exit;
     if font[nummer].height = 0 then exit;
     akt_font:=nummer;
end;

procedure maketranspal;
var
   a,b: byte;
   r1,g1,b1,r2,g2,b2: byte;
begin
     if transpal = nil then begin
        if memavail < 65535 then begin
           error:=outofmemerror;
           exit;
        end;
        getmem(transpal,65535);
     end;
     getpal;
     for a:=0 to 255 do begin
         for b:=0 to 255 do begin
             r1:=palette[a*3];
             g1:=palette[a*3+1];
             b1:=palette[a*3+2];
             r2:=palette[b*3];
             g2:=palette[b*3+1];
             b2:=palette[b*3+2];
             mem[seg(transpal^):a*256+b]:=findcol((r1+r2) DIV 2, (g1+g2) DIV 2, (b1+b2) DIV 2);
         end;
     end;
end;

begin
     init_fonts;
     transpal:=nil;
end.
{ Endlich zu Ende! }
