{$A+,B-,D-,E-,F+,G-,I-,L-,N-,O-,P-,Q-,R+,S+,T-,V-,X-}
UNIT Tastatur;

{ --------------------------------------------------------------------------
  Die Unit Tastatur ermglicht Ihnen festzustellen, welche Tasten gerade
  gedrckt sind. Hierzu dienen die beiden Arrays KeyDown und KeyExt. Dazu
  sind die BIOS-Tastatur Status-Variablen nach auen gelegt worden. Bitte
  ndern Sie diese Variablen nicht! Sonst kommt der Tastaturtreiber durch-
  einander. Ein Testprogramm ist TastTest, da Sie gleichzeitig zum Ermit-
  teln der Scancodes verwenden knnen.
  KeyDown ist immer aktiv, um die Tastenabfrage zu vereinfachen. Bei er-
  weiterten Tasten ist zustzlich KeyExt gesetzt, um die Tasten zu unter-
  scheiden.
  Die einzige Taste, die nicht korrekt erfat wird, ist die "Pause"-Taste.
  -------------------------------------------------------------------------- }

INTERFACE

USES Dos;

TYPE tum1  = SET OF (rShift,lShift,Strg,Alt,ScrLock,NumLock,CapsLock,Insert);
     tum2  = SET OF (lStrg,lAlt,SysReq,Pause,NumKey,CapsKey,InsKey);
     tstat = SET OF (E1code,E0code,rStrg,rAlt,MFII,NumActivate,lastID,readID);
     tLED  = SET OF (ScrollLED,NumLED,CapsLED);

VAR KeyDown,                             { eigenes Variablen-Array fr }
    KeyExt  : ARRAY [1..88] OF BOOLEAN;  { den Test auf Tastendrcke   }
    umsch1  : tum1  ABSOLUTE $40:$17;    { BIOS-Statusvariablen        }
    umsch2  : tum2  ABSOLUTE $40:$18;
    tastst  : tstat ABSOLUTE $40:$96;
    LEDstat : tLED  ABSOLUTE $40:$97;

IMPLEMENTATION

VAR Old15Vec    : POINTER;
    Old15Proc   : PROCEDURE ABSOLUTE Old15Vec;
    ExitP       : POINTER;

PROCEDURE Keyboard(AX,BX,CX,DX,SI,DI,DS,ES,BP : WORD); INTERRUPT;
  { hngt im Keyboard-Hook $15, um Tasten zu melden }
CONST high : BOOLEAN = FALSE; { zum Test von erweiteren Tasten }
VAR key : BYTE;
BEGIN
  key  := Lo(AX); { gedrckte Taste feststellen... }
  IF key >= $E0 THEN
    BEGIN
      high := TRUE; { die nchste Taste ist eine erweiterte welche }
      Exit;
    END;
  IF key < 128 THEN BEGIN { Taste war ein Make-Code }
    { Taste setzen }
    IF high THEN KeyExt[key AND $7F] := TRUE;
    KeyDown[key AND $7F] := TRUE;
  END ELSE BEGIN { Taste war ein Break-Code }
    { Taste lschen }
    KeyExt[key AND $7F] := FALSE;
    KeyDown[key AND $7F] := FALSE;
  END;
  high := FALSE;
END;

PROCEDURE Int15_hook; FAR; ASSEMBLER;
  { hngt die Interrupt-Prozedur in den Int15 hinein. Lt alle Variablen-
    nderungen zu, auer ds (und das wird m.W. nicht gendert)              }
ASM
      PUSHF;
      CMP AH, $4F    { Tastaturhook aktiviert }
      JNZ @Ok
      POPF           { und hinein }
      PUSHF;
      PUSH CS;
      CALL Keyboard  { Simulation des INT-Aufrufs }
      JMP @ok2
@Ok:  POPF
@ok2: PUSH DS;
      PUSH AX;
      MOV AX, Seg @Data;
      MOV DS,AX;
      POP AX;
      PUSHF;
      CALL [Old15Vec];
      POP DS
      RET 2
END;

PROCEDURE UnitExit; FAR;
BEGIN
  SetIntVec($15,Old15Vec);
  ExitProc := ExitP;
END;

BEGIN
  { Arrays initialisieren }
  FillChar(KeyDown,SizeOf(KeyDown),#0);
  FillChar(KeyExt,SizeOf(KeyExt),#0);
  ExitP := ExitProc;
  GetIntVec($15,Old15Vec);
  ExitProc := @UnitExit;
  SetIntVec($15,@Int15_hook);
END.
