unit video;

{
 Mein kleiner Video-Player!
 Hoffentlich wird's was...
}

interface

uses
    sprite, crt;

var
   video_error: boolean;
   video_lastframe: boolean;

procedure video_init(filename: string);
procedure video_close;
procedure video_play(x1,y1: word);
procedure video_firstframe(x1,y1: word);
procedure video_nextframe(x,y: word);
procedure video_set_buf(buffer: pointer);

implementation

var
   buf: pointer;
   dtx,dty: word;
   f: file;
   x,y: word;
   size: word;

procedure video_init;
begin
     video_error:=false;
     assign(f,filename);
     {$I-}
     reset(f,1);
     seek(f,0);
     blockread(f,dtx,2);
     blockread(f,dty,2);
     blockread(f,palette,768);
     {$I+}
     setpal;
end;

procedure video_close;
begin
     {$I-}
     close(f);
     {$I+}
     video_error:=false;
     video_lastframe:=true;
end;

procedure video_set_buf;
begin
     buf:=buffer;
end;

procedure video_nextframe(x,y: word);
var
   width, height: word;
   restx: word;
begin
     width:=dtx;
     height:=dty;
     blockread(f,vscreen^,size);
     asm
        push ds
        push es
        les di,buf
        lds si,vscreen
        mov ax,320
        mul y
        add ax,x
        add di,ax
        mov ax,320
        sub ax,width
        mov restx,ax
        mov bx,height
     @y_loop:
        mov cx,width
     @x_loop:
        mov al,ds:[si]
        xor al,255
        jnz @one_byte
        mov al,ds:[si+1]
        mov ah,ds:[si+2]
        add si,3
     @repeat_loop:
        mov es:[di],al
        inc di
        dec cx
        jne @allright
        add di,restx
        mov cx,width
        dec bx
        je @end
     @allright:
        dec ah
        jne @repeat_loop
        jmp @x_loop
     @one_byte:
        mov al,ds:[si]
        mov es:[di],al
        inc di
        inc si
        dec cx
        jne @x_loop
        add di,restx
        dec bx
        jne @y_loop
     @end:
        pop es
        pop ds
     end;
     blockread(f,size,2);
     if size = 0 then video_lastframe:=true;
end;

procedure video_firstframe;
begin
     {$I-}
     x:=x1;
     y:=y1;
     seek(f,772);
     blockread(f,size,2);
     video_lastframe:=false;
     {$I+}
end;

procedure video_play;
begin
     video_firstframe(x1,y1);
     while ((size > 0) and (not eof(f))) do begin
           video_nextframe(x,y);
           if keypressed then size:=0;
     end;
end;

begin
     video_lastframe:=true;
     buf:=ptr($0a000,$0000);
end.